=== modified file '.bzrignore'
--- .bzrignore	2007-09-02 15:42:18 +0000
+++ .bzrignore	2009-07-11 18:39:14 +0000
@@ -10,3 +10,4 @@
 bzr-gtk.trunk-matkor.e3p
 bzr-gtk.trunk-matkor.e3s
 bzr-gtk.trunk-matkor.e3t
+credits.pickle

=== modified file 'AUTHORS'
--- AUTHORS	2008-04-07 20:34:51 +0000
+++ AUTHORS	2010-05-25 17:09:02 +0000
@@ -1,6 +1,8 @@
 bzr-gtk is a plugin that is based on a collection of earlier plugins for 
-Bazaar. It is currently maintained by Jelmer Vernooij <jelmer@samba.org> and 
-Szilveszter Farkas <Szilveszter.Farkas@gmail.com>.
+Bazaar. It was originally developed by Jelmer Vernooij <jelmer@samba.org> and 
+Szilveszter Farkas <Szilveszter.Farkas@gmail.com> but is now maintained 
+by a team of developers; see https://launchpad.net/~bzr-gtk/+members for 
+a list
 
 bzrk was written by Scott James Remnant <scott@ubuntu.com>. 
 It's vaguely based on a screenshot of gitk (the equivalent tool for git)
@@ -11,8 +13,6 @@
 
 nautilus-bzr was written by Jelmer Vernooij and Jeff Bailey.
 
-Olive was written by Szilveszter Farkas <Szilveszter.Farkas@gmail.com>.
-
 The tag icon was created by Jakub Steiner.
 The bug icon was created by Josef Vybíral.
 

=== modified file 'HACKING'
--- HACKING	2007-07-15 15:05:06 +0000
+++ HACKING	2008-07-17 11:51:03 +0000
@@ -8,4 +8,8 @@
 (http://developer.gnome.org/projects/gup/hig/) should be followed where 
 possible.
 
+Several parts of bzr-gtk are currently using glade. However, we are slowly
+trying to move away from glade so please don't add new code that uses glade and
+try to remove the use of glade.
+
 Please update the NEWS file when closing bugs or adding new features.

=== modified file 'MANIFEST.in'
--- MANIFEST.in	2005-10-17 01:07:49 +0000
+++ MANIFEST.in	2010-05-25 17:09:02 +0000
@@ -1,2 +1,13 @@
 include AUTHORS
 include COPYING
+include HACKING
+include NEWS
+include TODO
+include bzr-gtk.applications
+include bzr-gtk.cfg
+include credits.pickle
+include preferences/TODO
+include *.desktop
+include *.ui
+recursive-include icons *.png *.svg
+recursive-include po *.po *.pot

=== modified file 'NEWS'
--- NEWS	2008-06-06 18:04:45 +0000
+++ NEWS	2011-03-02 15:24:46 +0000
@@ -1,22 +1,272 @@
-0.95.0	UNRELEASED
+0.101.0	UNRELEASED
+
+0.100.0	2011-03-02
+
+ BUG FIXES
+
+  * make sure that gdiff opened from gannotate knows its parent
+    (gannotate, that is, and does not exit when it (gdiff) is closed.
+
+  * Clarify 'visualise' help about the multiple branches feature
+    and the --revision parameter. (Vincent Ladeuil, #556347)
+
+  * Mark as compatible with bzr 2.3. (Jelmer Vernooij)
+
+  * Fix appindicator icon category. (Michael Terry, #685634)
+
+  * Mark as compatible with Bazaar 2.4. (Jelmer Vernooij)
+
+  * "bzr viz" now shows authors instead of committers. (Jelmer Vernooij, #693949)
+
+  * Don't use markup for secondary text in error dialogs.
+    (Edward Ari Bichetero, #656641)
+
+  * Generate pickles file when running 'setup.py sdist'. (Jelmer Vernooij, #397526)
+
+ FEATURES
+ 
+  * Add lock dialog. (Daniel Schierbeck, #93652)
+
+0.99.1	2010-08-26
+
+ BUG FIXES
+
+  * Trivial release to include credits pickle file.
+
+   * Mark as compatible with Bazaar 2.3. (Vincent Ladeuil)
+
+0.99.0 2010-08-13
+
+ BUG FIXES
+
+   * Guard setup() call when not loaded as __main__. (Robert Collins)
+
+   * Ignore gnomekeyring.IOError when checking if credentials are available
+     in the GNOME keyring. (Jelmer Vernooij, #534326)
+
+   * Don't crash when there is already a lan-notify instance running.
+     (Jelmer Vernooij, #339284)
+
+   * Return the credentials if successfully found in gnome-keyring.
+     (John Szakmeister)
+
+   * Support non-bzr patches. (Toshio Kuratomi, #502076)
+
+   * Avoid using private functions to get branch config. (Jelmer Vernooij,
+     #583554)
+
+   * Mark as compatible with Bazaar 2.2. (Martin Pool, #597379)
+
+FEATURES
+
+  * Add 'Find' button to start text search.
+    (Martin Pool, #556347)
+
+  * Add 'glog' as an alias for visualize (aka viz) as too many
+    people are still confused.
+    (Vincent Ladeuil)
+
+  * Add support for Indicator Application (Sense Hofstede, Jelmer Vernooij,
+    #518179)
+
+  * Add more tooltips to Olive. (Adrian Room, #333876)
+
+0.98.0 2010-02-24
+
+BUG FIXES
+
+  * Fix relative import in olive menu.
+    (Mathias Brodala, #269883)
+
+  * Fix typo in checkout dialog.
+    (Jasper Groenewegen, #466507)
+
+  * Adds help for ginit and gtags.
+    (Andrew Starr-Bochicchio, #512701)
+
+0.97.0 2009-08-25
+
+BUG FIXES
+
+  * Avoid GnomeKeyringCredentialStore traceback on Ubuntu Hardy
+    by being more tolerant about gobject methods availability.
+    (Vincent Ladeuil, #403430)
+  
+  * Fixed emblem and nautilus bzr-status column for ignored files.
+    (Lucas Shrewsbury, #294632)
+    
+  * Fixed emblem and nautilus bzr-status column for unversioned files.
+    (Lucas Shrewsbury, #417966)
+
+  * Switch to using disutils sdist instead of bzr export.
+    (Mark Lee, #398242)
+
+0.96.2	2009-07-08
+
+ BUG FIXES
+
+  * Same player shoots again. Version credits.pickle and rebuild the tarball
+    after running 'python ./setup.py build_credits', update
+    http://bazaar-vcs.org/bzr-gtk/releasing accordingly.  
+    (Vincent Ladeuil, #397526)
+ 
+0.96.1	2009-07-08
+
+ BUG FIXES
+ 
+  * Rebuild the tarball after running 'python ./setup.py build_credits',
+    update http://bazaar-vcs.org/bzr-gtk/releasing accordingly.
+   (Vincent Ladeuil, #397526)
+ 
+
+0.96.0	2009-07-08
+
+ UI
+ 
+  * Add colored status messages in Olive file list (Jasper Groenewegen)
+
+  * Use the new progress bar implementation from bzrlib.
+   (Vincent Ladeuil, 385191)
+
+ CHANGES
+ 
+  * Add ginfo command line option (Jasper Groenewegen)
+  
+  * Diff window uses GtkSourceView2 now. (Szilveszter Farkas)
+
+ BUG FIXES
+ 
+  * Fix the Branch/Get dialog refusing to open after hitting Cancel. (Markus
+  Korn, #294396)
+
+  * Fix Olive homepage URL. (#255152)
+
+  * Fix gannotate.conf handling. (Vincent Ladeuil, #373157)
+
+  * Save commit messages at uncommit time, restore them at
+    gcommit time. Also allow saving commit messages if the commit
+    is cancelled. (Anne Mohsen, Vincent Ladeuil, #215674)
+
+  * Mark as compatible with bzr 1.13.
+
+ FEATURES
+
+  * Support storing credentials in the GNOME Keyring if it is 
+    available. (Jelmer Vernooij)
+
+  * Fix opening Status window in Olive (#316310)
+
+0.95.0	2008-08-04
 
  UI
 
   * Added Refresh menu option with F5 keyboard shortcut (Russ Brown)
 
+  * Show progress bars in bzr viz window (Chad Miller, Jelmer Vernooij)
+
+  * Added menu option for indexing branches if bzr-search is present.
+    (Jelmer Vernooij)
+
+  * Add "Send Merge Directive" button in bzr viz. (Jelmer Vernooij)
+
+  * Remove dummy "Edit->Find" option. (Jelmer Vernooij)
+
+  * Added an optional diff panel to bzr vis.  (Scott Scriven)
+
+  * Made bzr vis remember whether the toolbar is visible.  (Scott Scriven)
+
+  * Made bzr vis remember window and panel sizes.  (Scott Scriven)
+
+  * Sort Olive bookmarks by title (Jasper Groenewegen)
+  
+  * Add controls to wrap long lines in gdiff and diff in visualise. (Jasper Groenewegen, #229789)
+  
+  * Made merge dialog to give choice between folder and custom location (Jasper Groenewegen)
+
+  * Add new dialog to browse looms and switch to threads in loom branches. (Jelmer Vernooij)
+  
+  * Show status for folders in Olive file list (Jasper Groenewegen)
+  
+  * Change appearance Olive bookmarks (Jasper Groenewegen)
+  
+  * Add ability to have dialog popup from Olive location bar. (Jasper Groenewegen)
+
  BUG FIXES
 
   * Replace _() calls by _i18n() calls. (Vincent Ladeuil, #187283)
   
   * Fixed adding tags. (Javier Derderian, #228709)
 
+  * Fix history mode button. (Jasper Groenewegen, #144962)
+
+  * Fixed handle-patch script. (Jelmer Vernooij)
+
+  * Fix import in olive. (Jelmer Vernooij, #223935)
+
+  * Avoid use of removed smart_add. (Jelmer Vernooij, #244025, #244027)
+
+  * Remove use of upstream removed Repository.revision_parents() 
+    (Jelmer Vernooij)
+
+  * List network drives in Olive. (Kevin Light, #244308)
+
+  * Fix progress bar handling. (Jelmer Vernooij)
+
+  * Fix broken symlink handling. (Jasper Groenewegen)
+
+  * Fix import in Olive rename dialog. (Kevin Light)
+
+  * Removed some redundant screen redrawing in bzr vis.  (Scott Scriven)
+
+  * Fixed overflowing labels in bzr vis.  (Scott Scriven)
+
+  * Fix plugin description in gpreferences. (Jasper Groenewegen, #232191)
+
+  * Remove question for setting default push location. (Jasper Groenewegen, #151818)
+
+  * Automatically change to history mode on selecting a revision from the list. (Jasper Groenewegen, #144963)
+
+  * Check if file is versioned before opening gannotate window from olive. (Jasper Groenewegen, #115358)
+  
+  * Make sure error/info/warning dialogs know their parent window. (Jasper Groenewegen, #252208)
+  
+  * Handle unreadable .bzr subfolder in Olive. (Jasper Groenewegen, #229044)
+
+  * Import gobject in bzr-notify, as it is used there to set a timeout. (James Westby)
+
+ CHANGES
+
+  * Moved notify icon code to separate script. (Jelmer Vernooij)
+
+  * Verify testaments when showing signatures on revisions and
+    re-enable signature display. (Jelmer Vernooij)
+
+  * Show credits for bzr-gtk in the about dialog. (Jelmer Vernooij)
+  
+  * Add gmerge command line option (Jasper Groenewegen, #124760)
+
  INTERNALS
 
   * All i18n calls should now go through _i18n which must be imported from
     bzrlib.plugins.gtk. This addresses the occasional collisions with '_' used
     as an anonymous variable. (Vincent Ladeuil)
 
-
+  * Add test for linegraph code. (Jelmer Vernooij)
+
+  * Remove obsolete tortoisebzr tests. (Jelmer Vernooij)
+
+  * Share revision context menu and main revision menu in bzr viz. (Jelmer Vernooij)
+
+  * Remove glade from merge dialog. (Jasper Groenewegen)
+
+  * Remove glade from olive about, rename, remove, move, mkdir, add dialogs. (Jasper Groenewegen)
+
+  * Remove glade from olive main window (Jasper Groenewegen)
+  
+  * Remove glade from olive info dialog (Jasper Groenewegen)
+
+  * Rewrite Olive mouse button event handling (Kevin Light)
+  
 0.94.0    2008-05-04
 
  CHANGES

=== modified file 'README'
--- README	2008-03-09 13:47:52 +0000
+++ README	2009-05-26 13:58:24 +0000
@@ -23,8 +23,8 @@
 
 In order to see syntax highlighted diffs:
 
-  * gtksourceview python bindings (on Debian and Ubuntu systems, these
-    are in the python-gnome2-desktop package)
+  * GtkSourceView2 Python bindings (on Debian and Ubuntu systems, these
+    are in the python-gtksourceview2 package)
 
 In order to use the nautilus integration, you will need:
 

=== modified file '__init__.py'
--- __init__.py	2008-06-27 16:53:56 +0000
+++ __init__.py	2011-01-31 10:19:52 +0000
@@ -15,28 +15,53 @@
 """Graphical support for Bazaar using GTK.
 
 This plugin includes:
-commit-notify     Start the graphical notifier of commits.
-gannotate         GTK+ annotate. 
-gbranch           GTK+ branching. 
-gcheckout         GTK+ checkout. 
+gannotate         GTK+ annotate.
+gbranch           GTK+ branching.
+gcheckout         GTK+ checkout.
 gcommit           GTK+ commit dialog.
-gconflicts        GTK+ conflicts. 
-gdiff             Show differences in working tree in a GTK+ Window. 
+gconflicts        GTK+ conflicts.
+gdiff             Show differences in working tree in a GTK+ Window.
 ginit             Initialise a new branch.
-gmissing          GTK+ missing revisions dialog. 
-gpreferences      GTK+ preferences dialog. 
+gloom             GTK+ loom browse dialog
+gmerge            GTK+ merge dialog
+gmissing          GTK+ missing revisions dialog.
+gpreferences      GTK+ preferences dialog.
 gpush             GTK+ push.
 gsend             GTK+ send merge directive.
 gstatus           GTK+ status dialog.
 gtags             Manage branch tags.
-visualise         Graphically visualise this branch. 
+visualise         Graphically visualise this branch.
 """
 
+import os
 import sys
 
+if getattr(sys, "frozen", None) is not None: # we run bzr.exe
+
+    # FIXME: Unless a better packaging solution is found, the following
+    # provides a workaround for https://bugs.launchpad.net/bzr/+bug/388790 Also
+    # see https://code.edge.launchpad.net/~vila/bzr-gtk/388790-windows-setup
+    # for more details about while it's needed.
+
+    # NOTE: _lib must be ahead of bzrlib or sax.saxutils (in olive) fails
+    here = os.path.dirname(__file__)
+    sys.path.insert(0, os.path.join(here, '_lib'))
+    sys.path.append(os.path.join(here, '_lib/gtk-2.0'))
+
+
 import bzrlib
+import bzrlib.api
+from bzrlib import (
+    branch,
+    config,
+    errors,
+    )
+from bzrlib.commands import plugin_cmds
 
-version_info = (0, 95, 0, 'dev', 1)
+from info import (
+    bzr_plugin_version as version_info,
+    bzr_compatible_versions,
+    )
 
 if version_info[3] == 'final':
     version_string = '%d.%d.%d' % version_info[:3]
@@ -44,50 +69,12 @@
     version_string = '%d.%d.%d%s%d' % version_info
 __version__ = version_string
 
-required_bzrlib = (1, 3)
-
-def check_bzrlib_version(desired):
-    """Check that bzrlib is compatible.
-
-    If version is < bzr-gtk version, assume incompatible.
-    """
-    bzrlib_version = bzrlib.version_info[:2]
-    try:
-        from bzrlib.trace import warning
-    except ImportError:
-        # get the message out any way we can
-        from warnings import warn as warning
-    if bzrlib_version < desired:
-        from bzrlib.errors import BzrError
-        warning('Installed Bazaar version %s is too old to be used with bzr-gtk'
-                ' %s.' % (bzrlib.__version__, __version__))
-        raise BzrError('Version mismatch: %r, %r' % (version_info, bzrlib.version_info) )
-
-
-if version_info[2] == "final":
-    check_bzrlib_version(required_bzrlib)
-
-from bzrlib.trace import warning
+bzrlib.api.require_any_api(bzrlib, bzr_compatible_versions)
+
 if __name__ != 'bzrlib.plugins.gtk':
+    from bzrlib.trace import warning
     warning("Not running as bzrlib.plugins.gtk, things may break.")
 
-from bzrlib.lazy_import import lazy_import
-lazy_import(globals(), """
-from bzrlib import (
-    branch,
-    builtins,
-    errors,
-    merge_directive,
-    workingtree,
-    )
-""")
-
-from bzrlib.commands import Command, register_command, display_command
-from bzrlib.errors import NotVersionedError, BzrCommandError, NoSuchFile
-from bzrlib.option import Option
-
-import os.path
-
 def import_pygtk():
     try:
         import pygtk
@@ -104,623 +91,95 @@
     bzrlib.ui.ui_factory = GtkUIFactory()
 
 
-def data_path():
-    return os.path.dirname(__file__)
-
-
-def icon_path(*args):
-    basedirs = [os.path.join(data_path()),
+def data_basedirs():
+    return [os.path.dirname(__file__),
              "/usr/share/bzr-gtk", 
              "/usr/local/share/bzr-gtk"]
-    for basedir in basedirs:
-        path = os.path.join(basedir, 'icons', *args)
+
+
+def data_path(*args):
+    for basedir in data_basedirs():
+        path = os.path.join(basedir, *args)
         if os.path.exists(path):
             return path
     return None
 
 
-def open_display():
-    pygtk = import_pygtk()
+def icon_path(*args):
+    return data_path(os.path.join('icons', *args))
+
+
+commands = {
+    "gannotate": ["gblame", "gpraise"],
+    "gbranch": [],
+    "gcheckout": [],
+    "gcommit": ["gci"],
+    "gconflicts": [],
+    "gdiff": [],
+    "ginit": [],
+    "gmerge": [],
+    "gmissing": [],
+    "gpreferences": [],
+    "gpush": [],
+    "gsend": [],
+    "gstatus": ["gst"],
+    "gtags": [],
+    "visualise": ["visualize", "vis", "viz", 'glog'],
+    }
+
+try:
+    from bzrlib.plugins import loom
+except ImportError:
+    pass # Loom plugin doesn't appear to be present
+else:
+    commands["gloom"] = []
+
+for cmd, aliases in commands.iteritems():
+    plugin_cmds.register_lazy("cmd_%s" % cmd, aliases,
+                              "bzrlib.plugins.gtk.commands")
+
+def save_commit_messages(*args):
+    from bzrlib.plugins.gtk import commit
+    commit.save_commit_messages(*args)
+
+branch.Branch.hooks.install_named_hook('post_uncommit',
+                                       save_commit_messages,
+                                       "Saving commit messages for gcommit")
+
+credential_store_registry = getattr(config, "credential_store_registry", None)
+if credential_store_registry is not None:
     try:
-        import gtk
-    except RuntimeError, e:
-        if str(e) == "could not open display":
-            raise NoDisplayError
-    set_ui_factory()
-    return gtk
- 
-
-class GTKCommand(Command):
-    """Abstract class providing GTK specific run commands."""
-
-    def run(self):
-        open_display()
-        dialog = self.get_gtk_dialog(os.path.abspath('.'))
-        dialog.run()
-
-
-class cmd_gbranch(GTKCommand):
-    """GTK+ branching.
-    
-    """
-
-    def get_gtk_dialog(self, path):
-        from bzrlib.plugins.gtk.branch import BranchDialog
-        return BranchDialog(path)
-
-
-class cmd_gcheckout(GTKCommand):
-    """ GTK+ checkout.
-    
-    """
-    
-    def get_gtk_dialog(self, path):
-        from bzrlib.plugins.gtk.checkout import CheckoutDialog
-        return CheckoutDialog(path)
-
-
-
-class cmd_gpush(GTKCommand):
-    """ GTK+ push.
-    
-    """
-    takes_args = [ "location?" ]
-
-    def run(self, location="."):
-        (br, path) = branch.Branch.open_containing(location)
-        open_display()
-        from push import PushDialog
-        dialog = PushDialog(br.repository, br.last_revision(), br)
-        dialog.run()
-
-
-
-class cmd_gdiff(GTKCommand):
-    """Show differences in working tree in a GTK+ Window.
-    
-    Otherwise, all changes for the tree are listed.
-    """
-    takes_args = ['filename?']
-    takes_options = ['revision']
-
-    @display_command
-    def run(self, revision=None, filename=None):
-        set_ui_factory()
-        wt = workingtree.WorkingTree.open_containing(".")[0]
-        wt.lock_read()
-        try:
-            branch = wt.branch
-            if revision is not None:
-                if len(revision) == 1:
-                    tree1 = wt
-                    revision_id = revision[0].as_revision_id(tree1.branch)
-                    tree2 = branch.repository.revision_tree(revision_id)
-                elif len(revision) == 2:
-                    revision_id_0 = revision[0].as_revision_id(branch)
-                    tree2 = branch.repository.revision_tree(revision_id_0)
-                    revision_id_1 = revision[1].as_revision_id(branch)
-                    tree1 = branch.repository.revision_tree(revision_id_1)
-            else:
-                tree1 = wt
-                tree2 = tree1.basis_tree()
-
-            from diff import DiffWindow
-            import gtk
-            window = DiffWindow()
-            window.connect("destroy", gtk.main_quit)
-            window.set_diff("Working Tree", tree1, tree2)
-            if filename is not None:
-                tree_filename = wt.relpath(filename)
-                try:
-                    window.set_file(tree_filename)
-                except NoSuchFile:
-                    if (tree1.path2id(tree_filename) is None and 
-                        tree2.path2id(tree_filename) is None):
-                        raise NotVersionedError(filename)
-                    raise BzrCommandError('No changes found for file "%s"' % 
-                                          filename)
-            window.show()
-
-            gtk.main()
-        finally:
-            wt.unlock()
-
-
-def start_viz_window(branch, revisions, limit=None):
-    """Start viz on branch with revision revision.
-    
-    :return: The viz window object.
-    """
-    from viz import BranchWindow
-    return BranchWindow(branch, revisions, limit)
-
-
-class cmd_visualise(Command):
-    """Graphically visualise this branch.
-
-    Opens a graphical window to allow you to see the history of the branch
-    and relationships between revisions in a visual manner,
-
-    The default starting point is latest revision on the branch, you can
-    specify a starting point with -r revision.
-    """
-    takes_options = [
-        "revision",
-        Option('limit', "Maximum number of revisions to display.",
-               int, 'count')]
-    takes_args = [ "locations*" ]
-    aliases = [ "visualize", "vis", "viz" ]
-
-    def run(self, locations_list, revision=None, limit=None):
-        set_ui_factory()
-        if locations_list is None:
-            locations_list = ["."]
-        revids = []
-        for location in locations_list:
-            (br, path) = branch.Branch.open_containing(location)
-            if revision is None:
-                revids.append(br.last_revision())
-            else:
-                revids.append(revision[0].as_revision_id(br))
-        import gtk
-        pp = start_viz_window(br, revids, limit)
-        pp.connect("destroy", lambda w: gtk.main_quit())
-        pp.show()
-        gtk.main()
-
-
-class cmd_gannotate(GTKCommand):
-    """GTK+ annotate.
-    
-    Browse changes to FILENAME line by line in a GTK+ window.
-    """
-
-    takes_args = ["filename", "line?"]
-    takes_options = [
-        Option("all", help="Show annotations on all lines."),
-        Option("plain", help="Don't highlight annotation lines."),
-        Option("line", type=int, argname="lineno",
-               help="Jump to specified line number."),
-        "revision",
-    ]
-    aliases = ["gblame", "gpraise"]
-    
-    def run(self, filename, all=False, plain=False, line='1', revision=None):
-        gtk = open_display()
-
-        try:
-            line = int(line)
-        except ValueError:
-            raise BzrCommandError('Line argument ("%s") is not a number.' % 
-                                  line)
-
-        from annotate.gannotate import GAnnotateWindow
-        from annotate.config import GAnnotateConfig
-        from bzrlib.bzrdir import BzrDir
-
-        wt, br, path = BzrDir.open_containing_tree_or_branch(filename)
-        if wt is not None:
-            tree = wt
-        else:
-            tree = br.basis_tree()
-
-        file_id = tree.path2id(path)
-
-        if file_id is None:
-            raise NotVersionedError(filename)
-        if revision is not None:
-            if len(revision) != 1:
-                raise BzrCommandError("Only 1 revion may be specified.")
-            revision_id = revision[0].as_revision_id(br)
-            tree = br.repository.revision_tree(revision_id)
-        else:
-            revision_id = getattr(tree, 'get_revision_id', lambda: None)()
-
-        window = GAnnotateWindow(all, plain, branch=br)
-        window.connect("destroy", lambda w: gtk.main_quit())
-        config = GAnnotateConfig(window)
-        window.show()
-        br.lock_read()
-        if wt is not None:
-            wt.lock_read()
-        try:
-            window.annotate(tree, br, file_id)
-            window.jump_to_line(line)
-            gtk.main()
-        finally:
-            br.unlock()
-            if wt is not None:
-                wt.unlock()
-
-
-
-class cmd_gcommit(GTKCommand):
-    """GTK+ commit dialog
-
-    Graphical user interface for committing revisions"""
-
-    aliases = [ "gci" ]
-    takes_args = []
-    takes_options = []
-
-    def run(self, filename=None):
-        import os
-        open_display()
-        from commit import CommitDialog
-        from bzrlib.errors import (BzrCommandError,
-                                   NotBranchError,
-                                   NoWorkingTree)
-
-        wt = None
-        br = None
-        try:
-            (wt, path) = workingtree.WorkingTree.open_containing(filename)
-            br = wt.branch
-        except NoWorkingTree, e:
-            from dialog import error_dialog
-            error_dialog(_i18n('Directory does not have a working tree'),
-                         _i18n('Operation aborted.'))
-            return 1 # should this be retval=3?
-
-        # It is a good habit to keep things locked for the duration, but it
-        # could cause difficulties if someone wants to do things in another
-        # window... We could lock_read() until we actually go to commit
-        # changes... Just a thought.
-        wt.lock_write()
-        try:
-            dlg = CommitDialog(wt)
-            return dlg.run()
-        finally:
-            wt.unlock()
-
-
-class cmd_gstatus(GTKCommand):
-    """GTK+ status dialog
-
-    Graphical user interface for showing status 
-    information."""
-    
-    aliases = [ "gst" ]
-    takes_args = ['PATH?']
-    takes_options = ['revision']
-
-    def run(self, path='.', revision=None):
-        import os
-        gtk = open_display()
-        from status import StatusDialog
-        (wt, wt_path) = workingtree.WorkingTree.open_containing(path)
-        
-        if revision is not None:
-            try:
-                revision_id = revision[0].as_revision_id(wt.branch)
-            except:
-                from bzrlib.errors import BzrError
-                raise BzrError('Revision %r doesn\'t exist' % revision[0].user_spec )
-        else:
-            revision_id = None
-
-        status = StatusDialog(wt, wt_path, revision_id)
-        status.connect("destroy", gtk.main_quit)
-        status.run()
-
-
-class cmd_gsend(GTKCommand):
-    """GTK+ send merge directive.
-
-    """
-    def run(self):
-        (br, path) = branch.Branch.open_containing(".")
-        gtk = open_display()
-        from bzrlib.plugins.gtk.mergedirective import SendMergeDirectiveDialog
-        from StringIO import StringIO
-        dialog = SendMergeDirectiveDialog(br)
-        if dialog.run() == gtk.RESPONSE_OK:
-            outf = StringIO()
-            outf.writelines(dialog.get_merge_directive().to_lines())
-            mail_client = br.get_config().get_mail_client()
-            mail_client.compose_merge_request(dialog.get_mail_to(), "[MERGE]", 
-                outf.getvalue())
-
-            
-
-
-class cmd_gconflicts(GTKCommand):
-    """GTK+ conflicts.
-    
-    Select files from the list of conflicts and run an external utility to
-    resolve them.
-    """
-    def run(self):
-        (wt, path) = workingtree.WorkingTree.open_containing('.')
-        open_display()
-        from bzrlib.plugins.gtk.conflicts import ConflictsDialog
-        dialog = ConflictsDialog(wt)
-        dialog.run()
-
-
-class cmd_gpreferences(GTKCommand):
-    """ GTK+ preferences dialog.
-
-    """
-    def run(self):
-        open_display()
-        from bzrlib.plugins.gtk.preferences import PreferencesWindow
-        dialog = PreferencesWindow()
-        dialog.run()
-
-
-class cmd_gmissing(Command):
-    """ GTK+ missing revisions dialog.
-
-    """
-    takes_args = ["other_branch?"]
-    def run(self, other_branch=None):
-        pygtk = import_pygtk()
-        try:
-            import gtk
-        except RuntimeError, e:
-            if str(e) == "could not open display":
-                raise NoDisplayError
-
-        from bzrlib.plugins.gtk.missing import MissingWindow
-        from bzrlib.branch import Branch
-
-        local_branch = Branch.open_containing(".")[0]
-        if other_branch is None:
-            other_branch = local_branch.get_parent()
-            
-            if other_branch is None:
-                raise errors.BzrCommandError("No peer location known or specified.")
-        remote_branch = Branch.open_containing(other_branch)[0]
-        set_ui_factory()
-        local_branch.lock_read()
-        try:
-            remote_branch.lock_read()
-            try:
-                dialog = MissingWindow(local_branch, remote_branch)
-                dialog.run()
-            finally:
-                remote_branch.unlock()
-        finally:
-            local_branch.unlock()
-
-
-class cmd_ginit(GTKCommand):
-    def run(self):
-        open_display()
-        from initialize import InitDialog
-        dialog = InitDialog(os.path.abspath(os.path.curdir))
-        dialog.run()
-
-
-class cmd_gtags(GTKCommand):
-    def run(self):
-        br = branch.Branch.open_containing('.')[0]
-        
-        gtk = open_display()
-        from tags import TagsWindow
-        window = TagsWindow(br)
-        window.show()
-        gtk.main()
-
-
-commands = [
-    cmd_gannotate, 
-    cmd_gbranch,
-    cmd_gcheckout, 
-    cmd_gcommit, 
-    cmd_gconflicts, 
-    cmd_gdiff,
-    cmd_ginit,
-    cmd_gmissing, 
-    cmd_gpreferences, 
-    cmd_gpush, 
-    cmd_gsend,
-    cmd_gstatus,
-    cmd_gtags,
-    cmd_visualise
-    ]
-
-for cmd in commands:
-    register_command(cmd)
-
-
-class cmd_commit_notify(GTKCommand):
-    """Run the bzr commit notifier.
-
-    This is a background program which will pop up a notification on the users
-    screen when a commit occurs.
-    """
-
-    def run(self):
-        from notify import NotifyPopupMenu
-        gtk = open_display()
-        menu = NotifyPopupMenu()
-        icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
-        icon.connect('popup-menu', menu.display)
-
-        import cgi
-        import dbus
-        import dbus.service
-        import pynotify
-        from bzrlib.bzrdir import BzrDir
-        from bzrlib import errors
-        from bzrlib.osutils import format_date
-        from bzrlib.transport import get_transport
-        if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
-            import dbus.glib
-        BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
-        bus = dbus.SessionBus()
-
-        def catch_branch(revision_id, urls):
-            # TODO: show all the urls, or perhaps choose the 'best'.
-            url = urls[0]
-            try:
-                if isinstance(revision_id, unicode):
-                    revision_id = revision_id.encode('utf8')
-                transport = get_transport(url)
-                a_dir = BzrDir.open_from_transport(transport)
-                branch = a_dir.open_branch()
-                revno = branch.revision_id_to_revno(revision_id)
-                revision = branch.repository.get_revision(revision_id)
-                summary = 'New revision %d in %s' % (revno, url)
-                body  = 'Committer: %s\n' % revision.committer
-                body += 'Date: %s\n' % format_date(revision.timestamp,
-                    revision.timezone)
-                body += '\n'
-                body += revision.message
-                body = cgi.escape(body)
-                nw = pynotify.Notification(summary, body)
-                def start_viz(notification=None, action=None, data=None):
-                    """Start the viz program."""
-                    pp = start_viz_window(branch, revision_id)
-                    pp.show()
-                def start_branch(notification=None, action=None, data=None):
-                    """Start a Branch dialog"""
-                    from bzrlib.plugins.gtk.branch import BranchDialog
-                    bd = BranchDialog(remote_path=url)
-                    bd.run()
-                nw.add_action("inspect", "Inspect", start_viz, None)
-                nw.add_action("branch", "Branch", start_branch, None)
-                nw.set_timeout(5000)
-                nw.show()
-            except Exception, e:
-                print e
-                raise
-        bus.add_signal_receiver(catch_branch,
-                                dbus_interface=BROADCAST_INTERFACE,
-                                signal_name="Revision")
-        pynotify.init("bzr commit-notify")
-        gtk.main()
-
-register_command(cmd_commit_notify)
-
-
-class cmd_gselftest(GTKCommand):
-    """Version of selftest that displays a notification at the end"""
-
-    takes_args = builtins.cmd_selftest.takes_args
-    takes_options = builtins.cmd_selftest.takes_options
-    _see_also = ['selftest']
-
-    def run(self, *args, **kwargs):
-        import cgi
-        import sys
-        default_encoding = sys.getdefaultencoding()
-        # prevent gtk from blowing up later
-        gtk = import_pygtk()
-        # prevent gtk from messing with default encoding
-        import pynotify
-        if sys.getdefaultencoding() != default_encoding:
-            reload(sys)
-            sys.setdefaultencoding(default_encoding)
-        result = builtins.cmd_selftest().run(*args, **kwargs)
-        if result == 0:
-            summary = 'Success'
-            body = 'Selftest succeeded in "%s"' % os.getcwd()
-        if result == 1:
-            summary = 'Failure'
-            body = 'Selftest failed in "%s"' % os.getcwd()
-        pynotify.init("bzr gselftest")
-        note = pynotify.Notification(cgi.escape(summary), cgi.escape(body))
-        note.set_timeout(pynotify.EXPIRES_NEVER)
-        note.show()
-
-
-register_command(cmd_gselftest)
-
-
-class cmd_test_gtk(GTKCommand):
-    """Version of selftest that just runs the gtk test suite."""
-
-    takes_options = ['verbose',
-                     Option('one', short_name='1',
-                            help='Stop when one test fails.'),
-                     Option('benchmark', help='Run the benchmarks.'),
-                     Option('lsprof-timed',
-                     help='Generate lsprof output for benchmarked'
-                          ' sections of code.'),
-                     Option('list-only',
-                     help='List the tests instead of running them.'),
-                     Option('randomize', type=str, argname="SEED",
-                     help='Randomize the order of tests using the given'
-                          ' seed or "now" for the current time.'),
-                    ]
-    takes_args = ['testspecs*']
-
-    def run(self, verbose=None, one=False, benchmark=None,
-            lsprof_timed=None, list_only=False, randomize=None,
-            testspecs_list=None):
-        from bzrlib import __path__ as bzrlib_path
-        from bzrlib.tests import selftest
-
-        print '%10s: %s' % ('bzrlib', bzrlib_path[0])
-        if benchmark:
-            print 'No benchmarks yet'
-            return 3
-
-            test_suite_factory = bench_suite
-            if verbose is None:
-                verbose = True
-            # TODO: should possibly lock the history file...
-            benchfile = open(".perf_history", "at", buffering=1)
-        else:
-            test_suite_factory = test_suite
-            if verbose is None:
-                verbose = False
-            benchfile = None
-
-        if testspecs_list is not None:
-            pattern = '|'.join(testspecs_list)
-        else:
-            pattern = ".*"
-
-        try:
-            result = selftest(verbose=verbose,
-                              pattern=pattern,
-                              stop_on_failure=one,
-                              test_suite_factory=test_suite_factory,
-                              lsprof_timed=lsprof_timed,
-                              bench_history=benchfile,
-                              list_only=list_only,
-                              random_seed=randomize,
-                             )
-        finally:
-            if benchfile is not None:
-                benchfile.close()
-
-register_command(cmd_test_gtk)
-
-
-
-import gettext
-gettext.install('olive-gtk')
-
-# Let's create a specialized alias to protect '_' from being erased by other
-# uses of '_' as an anonymous variable (think pdb for one).
-_i18n = gettext.gettext
-
-class NoDisplayError(BzrCommandError):
-    """gtk could not find a proper display"""
-
-    def __str__(self):
-        return "No DISPLAY. Unable to run GTK+ application."
-
-
-def test_suite():
-    from unittest import TestSuite
-    import tests
+        credential_store_registry.register_lazy(
+            "gnome-keyring", "bzrlib.plugins.gtk.keyring", "GnomeKeyringCredentialStore",
+            help="The GNOME Keyring.", fallback=True)
+    except TypeError:
+    # Fallback credentials stores were introduced in Bazaar 1.15
+        credential_store_registry.register_lazy(
+            "gnome-keyring", "bzrlib.plugins.gtk.keyring", "GnomeKeyringCredentialStore",
+            help="The GNOME Keyring.")
+
+
+def load_tests(basic_tests, module, loader):
+    testmod_names = [
+        'tests',
+        ]
     import sys
     default_encoding = sys.getdefaultencoding()
     try:
-        result = TestSuite()
+        result = basic_tests
         try:
             import_pygtk()
         except errors.BzrCommandError:
-            return result
-        result.addTest(tests.test_suite())
+            return basic_tests
+        basic_tests.addTest(loader.loadTestsFromModuleNames(
+                ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
     finally:
         if sys.getdefaultencoding() != default_encoding:
             reload(sys)
             sys.setdefaultencoding(default_encoding)
-    return result
+    return basic_tests
+
+
+def _i18n(text):
+    # Stub until we support proper i18n
+    return text

=== modified file 'about.py'
--- about.py	2008-04-01 09:59:41 +0000
+++ about.py	2010-12-17 22:48:28 +0000
@@ -23,7 +23,27 @@
 import bzrlib
 import gtk
 import os
-from bzrlib.plugins.gtk import icon_path
+
+from bzrlib.plugins.gtk import data_path, icon_path
+
+
+def read_license():
+    license_paths = [data_path("COPYING"), "/usr/share/common-licenses/GPL-2"]
+    for license_file in license_paths:
+        if license_file is not None and os.path.exists(license_file):
+            return file(license_file).read()
+    # Fall back to just license name if we can't find the file
+    return "GPLv2 or later"
+
+
+def load_credits():
+    import pickle
+    try:
+        credits = pickle.load(file(data_path("credits.pickle")))
+    except IOError:
+        credits = None
+    return credits
+
 
 class AboutDialog(gtk.AboutDialog):
     def __init__(self):
@@ -31,7 +51,15 @@
         self.set_name("Bazaar GTK")
         self.set_version(bzrlib.plugins.gtk.version_string)
         self.set_website("http://bazaar-vcs.org/BzrGtk")
-        self.set_license("GNU GPL v2 or later")
-        self.set_icon(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        self.set_license(read_license())
+        self.set_logo(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        credits = load_credits()
+        if credits is not None:
+            (authors, documenters, artists, translators) = credits
+            self.set_authors(authors)
+            self.set_documenters(documenters)
+            self.set_artists(artists)
+            self.set_translator_credits("\n".join(translators))
         self.connect ("response", lambda d, r: d.destroy())
 
+

=== modified file 'annotate/colormap.py'
--- annotate/colormap.py	2007-08-16 14:31:02 +0000
+++ annotate/colormap.py	2011-02-18 13:01:03 +0000
@@ -13,6 +13,7 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
 import sys
 
 class AnnotateColorMap:

=== modified file 'annotate/config.py'
--- annotate/config.py	2007-01-17 06:42:55 +0000
+++ annotate/config.py	2010-02-08 13:28:34 +0000
@@ -18,24 +18,15 @@
 
 import gtk.gdk
 
-from bzrlib.config import config_dir
-import bzrlib.util.configobj.configobj as configobj
-
-
-gannotate_configspec = (
-    "[window]",
-    "width = integer(default=750)",
-    "height = integer(default=550)",
-    "maximized = boolean(default=False)",
-    "x = integer(default=0)",
-    "y = integer(default=0)",
-    "pane_position = integer(default=325)",
-    "[spans]",
-    "max_custom_spans = integer(default=4)",
-    "custom_spans = float_list()"
-)
-
-gannotate_config_filename = os.path.join(config_dir(), "gannotate.conf")
+from bzrlib import config
+try:
+    import bzrlib.util.configobj.configobj as configobj
+except ImportError:
+    import configobj
+
+
+def gannotate_config_filename():
+    return os.path.join(config.config_dir(), "gannotate.conf")
 
 
 class GAnnotateConfig(configobj.ConfigObj):
@@ -47,20 +38,20 @@
     """
 
     def __init__(self, window):
-        configobj.ConfigObj.__init__(self, gannotate_config_filename,
-                                     configspec=gannotate_configspec)
+        configobj.ConfigObj.__init__(self, gannotate_config_filename())
         self.window = window
         self.pane = window.pane
-        
-        self.initial_comment = ["gannotate plugin configuration"]
-        self['window']['width'] = 750
-        self['window']['height'] = 550
-        self['window']['maximized'] = False
-        self['window']['x'] = 0
-        self['window']['y'] = 0
-        self['window']['pane_position'] = 325
-        self['spans']['max_custom_spans'] = 4
-        self['spans']['custom_spans'] = []
+
+        if 'window' not in self:
+            # Set default values, configobj expects strings here
+            self.initial_comment = ["gannotate plugin configuration"]
+            self['window'] = {}
+            self['window']['width'] = '750'
+            self['window']['height'] = '550'
+            self['window']['maximized'] = 'False'
+            self['window']['x'] = '0'
+            self['window']['y'] = '0'
+            self['window']['pane_position'] = '325'
 
         self.apply()
         self._connect_signals()
@@ -68,16 +59,14 @@
     def apply(self):
         """Apply properties and such from gannotate.conf, or
         gannotate_configspec defaults."""
-        self.pane.set_position(self["window"]["pane_position"])
-        self.window.set_default_size(self["window"]["width"],
-                                     self["window"]["height"])
-        self.window.move(self["window"]["x"], self["window"]["y"])
+        self.pane.set_position(self['window'].as_int('pane_position'))
+        self.window.set_default_size(self['window'].as_int('width'),
+                                     self['window'].as_int('height'))
+        self.window.move(self['window'].as_int('x'), self['window'].as_int('y'))
 
-        if self["window"]["maximized"]:
+        if self['window'].as_bool('maximized'):
             self.window.maximize()
 
-        # XXX Don't know how to set an empty list as default in
-        # gannotate_configspec.
     def _connect_signals(self):
         self.window.connect("destroy", self._write)
         self.window.connect("configure-event", self._save_window_props)
@@ -91,9 +80,7 @@
             self["window"]["width"], self["window"]["height"] = w.get_size()
             self["window"]["x"], self["window"]["y"] = w.get_position()
             maximized = False
-
         self["window"]["maximized"] = maximized
-        
         return False
 
     def _save_pane_props(self, w, gparam):
@@ -102,11 +89,6 @@
 
         return False
 
-    def _save_custom_spans(self, w, *args):
-        self["spans"]["custom_spans"] = w.custom_spans
-
-        return False
-
     def _write(self, *args):
         self.write()
 

=== modified file 'annotate/gannotate.py'
--- annotate/gannotate.py	2008-04-29 08:17:01 +0000
+++ annotate/gannotate.py	2011-02-18 13:01:03 +0000
@@ -23,11 +23,11 @@
 import pango
 import re
 
-from bzrlib import patiencediff, tsort
+from bzrlib import patiencediff
 from bzrlib.errors import NoSuchRevision
 from bzrlib.revision import NULL_REVISION, CURRENT_REVISION
 
-from colormap import AnnotateColorMap, AnnotateColorSaturation
+from colormap import AnnotateColorSaturation
 from bzrlib.plugins.gtk.revisionview import RevisionView
 from bzrlib.plugins.gtk.window import Window
 
@@ -49,9 +49,9 @@
         self.all = all
         self.plain = plain
         self._branch = branch
-        
+
         Window.__init__(self, parent)
-        
+
         self.set_icon(self.render_icon(gtk.STOCK_FIND, gtk.ICON_SIZE_BUTTON))
         self.annotate_colormap = AnnotateColorSaturation()
 
@@ -68,15 +68,15 @@
         self.revisionview.set_file_id(file_id)
         self.revision_id = getattr(tree, 'get_revision_id', 
                                    lambda: CURRENT_REVISION)()
-        
+
         # [revision id, line number, author, revno, highlight color, line]
         self.annomodel = gtk.ListStore(gobject.TYPE_STRING,
-                                       gobject.TYPE_STRING,
+                                       gobject.TYPE_INT,
                                        gobject.TYPE_STRING,
                                        gobject.TYPE_STRING,
                                        gobject.TYPE_STRING,
                                        gobject.TYPE_STRING)
-        
+
         last_seen = None
         try:
             branch.lock_read()
@@ -86,12 +86,12 @@
             for revision_id, revno in revno_map.iteritems():
                 self.dotted[revision_id] = '.'.join(str(num) for num in revno)
             for line_no, (revision, revno, line)\
-                    in enumerate(self._annotate(tree, file_id)):
+                in enumerate(self._annotate(tree, file_id)):
                 if revision.revision_id == last_seen and not self.all:
                     revno = author = ""
                 else:
                     last_seen = revision.revision_id
-                    author = revision.get_apparent_author()
+                    author = ", ".join(revision.get_apparent_authors())
 
                 if revision.revision_id not in self.revisions:
                     self.revisions[revision.revision_id] = revision
@@ -102,7 +102,7 @@
                                        revno,
                                        None,
                                        line.rstrip("\r\n")
-                                      ])
+                                       ])
                 self.annotations.append(revision)
 
             if not self.plain:
@@ -125,7 +125,7 @@
             # bar?
             print("gannotate: Line number %d does't exist. Defaulting to "
                   "line 1." % lineno)
-	    return
+            return
         else:
             row = lineno - 1
 
@@ -139,7 +139,7 @@
         current_revision.timestamp = time.time()
         current_revision.message = '[Not yet committed]'
         current_revision.parent_ids = tree.get_parent_ids()
-        current_revision.properties['branch-nick'] = self.branch.nick
+        current_revision.properties['branch-nick'] = self.branch._get_nick(local=True)
         current_revno = '%d?' % (self.branch.revno() + 1)
         repository = self.branch.repository
         if self.revision_id == CURRENT_REVISION:
@@ -212,9 +212,13 @@
         hbox.pack_start(self.back_button, expand=False, fill=True)
         self.forward_button = self._create_forward_button()
         hbox.pack_start(self.forward_button, expand=False, fill=True)
+        self.find_button = self._create_find_button()
+        hbox.pack_start(self.find_button, expand=False, fill=True)
+        self.goto_button = self._create_goto_button()
+        hbox.pack_start(self.goto_button, expand=False, fill=True)
         hbox.show()
         vbox.pack_start(hbox, expand=False, fill=True)
-        
+
         self.pane = pane = gtk.VPaned()
         pane.add1(swbox)
         pane.add2(self.revisionview)
@@ -234,11 +238,11 @@
 
         self.add(vbox)
 
-    def _search_by_text(self, accel_group, window, key, modifiers):
+    def _search_by_text(self, *ignored): # (accel_group, window, key, modifiers):
         self._search.show_for('text')
         self._search.set_target(self.annoview, TEXT_LINE_COL)
 
-    def _search_by_line(self, accel_group, window, key, modifiers):
+    def _search_by_line(self, *ignored): # accel_group, window, key, modifiers):
         self._search.show_for('line')
         self._search.set_target(self.annoview, LINE_NUM_COL)
 
@@ -256,7 +260,7 @@
             else:
                 tree2 = repository.revision_tree(NULL_REVISION)
         from bzrlib.plugins.gtk.diff import DiffWindow
-        window = DiffWindow()
+        window = DiffWindow(self)
         window.set_diff("Diff for line %d" % (row+1), tree1, tree2)
         window.set_file(tree1.id2path(self.file_id))
         window.show()
@@ -344,6 +348,27 @@
         button.set_sensitive(False)
         return button
 
+    def _create_find_button(self):
+        button = gtk.Button()
+        button.set_use_stock(True)
+        button.set_label("gtk-find")
+        button.set_tooltip_text("Search for text (Ctrl+F)")
+        button.connect("clicked", self._search_by_text)
+        button.set_relief(gtk.RELIEF_NONE)
+        button.show()
+        button.set_sensitive(True)
+        return button
+
+    def _create_goto_button(self):
+        button = gtk.Button()
+        button.set_label("Goto Line")
+        button.set_tooltip_text("Scroll to a line by entering its number (Ctrl+G)")
+        button.connect("clicked", self._search_by_line)
+        button.set_relief(gtk.RELIEF_NONE)
+        button.show()
+        button.set_sensitive(True)
+        return button
+
     def go_back(self):
         last_tree = self.tree
         rev_id = self._selected_revision()
@@ -389,7 +414,7 @@
                 return j - i
 
 
-class FakeRevision:
+class FakeRevision(object):
     """ A fake revision.
 
     For when a revision is referenced but not present.
@@ -404,12 +429,13 @@
         self.timezone = 0
         self.properties = {}
 
-    def get_apparent_author(self):
-        return self.committer
+    def get_apparent_authors(self):
+        return [self.committer]
 
 
 class RevisionCache(object):
     """A caching revision source"""
+
     def __init__(self, real_source, seed_cache=None):
         self.__real_source = real_source
         if seed_cache is None:
@@ -506,18 +532,22 @@
 
     def _match(self, model, iterator, column):
         matching_case = self._match_case.get_active()
-        string, = model.get(iterator, column)
+        cell_value, = model.get(iterator, column)
         key = self._entry.get_text()
-        if self._regexp.get_active():
+        if column == LINE_NUM_COL:
+            # FIXME: For goto-line there are faster algorithms than searching 
+            # every line til we find the right one! -- mbp 2011-01-27
+            return key.strip() == str(cell_value)
+        elif self._regexp.get_active():
             if matching_case:
-                match = re.compile(key).search(string, 1)
+                match = re.compile(key).search(cell_value, 1)
             else:
-                match = re.compile(key, re.I).search(string, 1)
+                match = re.compile(key, re.I).search(cell_value, 1)
         else:
             if not matching_case:
-                string = string.lower()
+                cell_value = cell_value.lower()
                 key = key.lower()
-            match = string.find(key) != -1
+            match = cell_value.find(key) != -1
 
         return match
 

=== modified file 'bazaar-properties.desktop'
--- bazaar-properties.desktop	2007-07-15 15:13:34 +0000
+++ bazaar-properties.desktop	2009-10-06 13:57:12 +0000
@@ -1,8 +1,7 @@
 [Desktop Entry]
-Encoding=UTF-8
 Name=Bazaar Preferences
 Comment=Configure Bazaar settings
-Icon=bazaar
+Icon=bzr-icon-64
 Exec=bzr gpreferences
 Terminal=false
 Type=Application

=== modified file 'branchbox.py'
--- branchbox.py	2008-03-14 02:13:27 +0000
+++ branchbox.py	2010-05-29 23:42:20 +0000
@@ -24,12 +24,11 @@
 from bzrlib.config import GlobalConfig
 import gtk
 from history import UrlHistory
-from olive import Preferences
 import gobject
 
 class BranchSelectionBox(gtk.HBox):
     def __init__(self, path=None):
-        super(BranchSelectionBox, self).__init__()
+        gobject.GObject.__init__(self)
         self._combo = gtk.ComboBoxEntry()
         self._combo.child.connect('focus-out-event', self._on_combo_changed)
         
@@ -39,10 +38,6 @@
 
         self.add(self._combo)
 
-        gobject.signal_new('branch-changed', BranchSelectionBox, 
-                           gobject.SIGNAL_RUN_LAST,
-                           gobject.TYPE_NONE, (gobject.TYPE_OBJECT,))
-
         if path is not None:
             self.set_url(path)
 
@@ -62,13 +57,13 @@
         for item in self._history.get_entries():
             self._combo_model.append([ item ])
         
-        pref = Preferences()
-        for item in pref.get_bookmarks():
-            self._combo_model.append([ item ])
-        
         self._combo.set_model(self._combo_model)
         self._combo.set_text_column(0)
 
     def _on_combo_changed(self, widget, event):
         self.emit('branch-changed', widget)
-    
+
+gobject.signal_new('branch-changed', BranchSelectionBox, 
+                   gobject.SIGNAL_RUN_LAST,
+                   gobject.TYPE_NONE, (gobject.TYPE_OBJECT,))
+gobject.type_register(BranchSelectionBox)

=== modified file 'branchview/__init__.py'
--- branchview/__init__.py	2008-01-13 14:12:49 +0000
+++ branchview/__init__.py	2011-02-18 13:01:03 +0000
@@ -1,2 +1,1 @@
-
 from treeview import *

=== modified file 'branchview/linegraph.py'
--- branchview/linegraph.py	2008-06-29 16:11:12 +0000
+++ branchview/linegraph.py	2009-12-10 16:13:32 +0000
@@ -1,4 +1,3 @@
-# -*- coding: UTF-8 -*-
 """Directed graph production.
 
 This module contains the code to produce an ordered directed graph of a
@@ -6,7 +5,7 @@
 window.
 """
 
-__copyright__ = "Copyright © 2005 Canonical Ltd."
+__copyright__ = "Copyright 2005 Canonical Ltd."
 __author__    = "Scott James Remnant <scott@ubuntu.com>"
 
 from bzrlib.revision import NULL_REVISION
@@ -47,7 +46,7 @@
     def update_root_progress(step_number):
         """IFF our container received a root progress bar, then update it."""
         if root_progress is not None:
-            root_progress.update(current=step_number)
+            root_progress.update(None, step_number)
 
     graph_parents = {}
     ghosts = set()
@@ -55,7 +54,7 @@
     update_root_progress(1)
     progress_bar = ui.ui_factory.nested_progress_bar()
     try:
-        progress_bar.update(msg="Arranging tree fragments")
+        progress_bar.update("Arranging tree fragments")
         for i, (revid, parent_revids) in enumerate(graph.iter_ancestry(start_revs)):
             if i % 25 == 0:
                 progress_bar.tick()
@@ -75,10 +74,10 @@
     update_root_progress(2)
     progress_bar = ui.ui_factory.nested_progress_bar()
     try:
-        progress_bar.update(msg="Removing ghosts", total=len(ghosts))
+        progress_bar.update("Removing ghosts", 0, len(ghosts))
         for i, ghost in enumerate(ghosts):
             if i % 25 == 0:
-                progress_bar.update(current=i)
+                progress_bar.update(None, i)
             for ghost_child in graph_children[ghost]:
                 graph_parents[ghost_child] = [p for p in graph_parents[ghost_child]
                                               if p not in ghosts]
@@ -118,7 +117,7 @@
     update_root_progress(3)
     progress_bar = ui.ui_factory.nested_progress_bar()
     try:
-        progress_bar.update(msg="Finding nodes", total=len(merge_sorted_revisions))
+        progress_bar.update("Finding nodes", 0, len(merge_sorted_revisions))
         for (rev_index, (sequence_number,
                          revid,
                          merge_depth,
@@ -126,7 +125,7 @@
                          end_of_merge)) in enumerate(merge_sorted_revisions):
 
             if rev_index % 25 == 0:
-                progress_bar.update(current=rev_index)
+                progress_bar.update(None, rev_index)
             if maxnum and rev_index >= maxnum:
                 break
             revid_index[revid] = rev_index
@@ -184,10 +183,10 @@
         update_root_progress(4)
         progress_bar = ui.ui_factory.nested_progress_bar()
         try:
-            progress_bar.update(msg="Organizing edges", total=len(branch_ids))
+            progress_bar.update("Organizing edges", 0, len(branch_ids))
             for i, branch_id in enumerate(branch_ids):
                 if i % 25 == 0:
-                    progress_bar.update(current=i)
+                    progress_bar.update(None, i)
                 branch_line = branch_lines[branch_id]
                 
                 # Find the col_index for the direct parent branch. This will be the
@@ -314,10 +313,10 @@
         update_root_progress(5)
         progress_bar = ui.ui_factory.nested_progress_bar()
         try:
-            progress_bar.update(msg="Pretifying graph", total=len(lines))
+            progress_bar.update("Prettifying graph", 0, len(lines))
             for i, (child_index, parent_index, line_col_indexes) in enumerate(lines):
                 if i % 25 == 0:
-                    progress_bar.update(current=i)
+                    progress_bar.update(None, i)
                 (child_col_index, child_color) = linegraph[child_index][1]
                 (parent_col_index, parent_color) = linegraph[parent_index][1]
                 

=== modified file 'branchview/treemodel.py'
--- branchview/treemodel.py	2008-04-24 15:26:14 +0000
+++ branchview/treemodel.py	2011-02-18 13:16:37 +0000
@@ -9,9 +9,10 @@
 
 import gtk
 import gobject
-import pango
 import re
 from xml.sax.saxutils import escape
+
+from bzrlib.config import parse_username
 from bzrlib.revision import NULL_REVISION
 
 from time import (strftime, localtime)
@@ -29,18 +30,18 @@
 PARENTS = 10
 CHILDREN = 11
 TAGS = 12
+AUTHORS = 13
 
 class TreeModel(gtk.GenericTreeModel):
 
-    
     def __init__ (self, branch, line_graph_data):
         gtk.GenericTreeModel.__init__(self)
         self.revisions = {}
-	self.branch = branch
+        self.branch = branch
         self.repository = branch.repository
         self.line_graph_data = line_graph_data
 
-    	if self.branch.supports_tags():
+        if self.branch.supports_tags():
             self.tags = self.branch.tags.get_reverse_tag_dict()
         else:
             self.tags = {}
@@ -54,10 +55,10 @@
 
     def on_get_flags(self):
         return gtk.TREE_MODEL_LIST_ONLY
-    
+
     def on_get_n_columns(self):
-        return 13
-    
+        return 14
+
     def on_get_column_type(self, index):
         if index == REVID: return gobject.TYPE_STRING
         if index == NODE: return gobject.TYPE_PYOBJECT
@@ -72,13 +73,14 @@
         if index == PARENTS: return gobject.TYPE_PYOBJECT
         if index == CHILDREN: return gobject.TYPE_PYOBJECT
         if index == TAGS: return gobject.TYPE_PYOBJECT
-        
+        if index == AUTHORS: return gobject.TYPE_STRING
+
     def on_get_iter(self, path):
         return path[0]
-    
+
     def on_get_path(self, rowref):
         return rowref
-    
+
     def on_get_value(self, rowref, column):
         if len(self.line_graph_data) > 0:
             (revid, node, lines, parents,
@@ -108,34 +110,36 @@
             self.revisions[revid] = revision
         else:
             revision = self.revisions[revid]
-        
+
         if column == REVISION: return revision
         if column == SUMMARY: return escape(revision.get_summary())
         if column == MESSAGE: return escape(revision.message)
-        if column == COMMITTER: return re.sub('<.*@.*>', '', 
-                                             revision.committer).strip(' ')
-        if column == TIMESTAMP: 
+        if column == COMMITTER: return parse_username(revision.committer)[0]
+        if column == TIMESTAMP:
             return strftime("%Y-%m-%d %H:%M", localtime(revision.timestamp))
+        if column == AUTHORS:
+            return ", ".join([
+                parse_username(author)[0] for author in revision.get_apparent_authors()])
 
     def on_iter_next(self, rowref):
         if rowref < len(self.line_graph_data) - 1:
             return rowref+1
         return None
-    
+
     def on_iter_children(self, parent):
         if parent is None: return 0
         return None
-    
+
     def on_iter_has_child(self, rowref):
         return False
-    
+
     def on_iter_n_children(self, rowref):
         if rowref is None: return len(self.line_graph_data)
         return 0
-    
+
     def on_iter_nth_child(self, parent, n):
         if parent is None: return n
         return None
-    
+
     def on_iter_parent(self, child):
         return None

=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2008-06-29 16:24:24 +0000
+++ branchview/treeview.py	2011-02-18 13:16:37 +0000
@@ -6,20 +6,19 @@
 __copyright__ = "Copyright © 2005 Canonical Ltd."
 __author__    = "Daniel Schierbeck <daniel.schierbeck@gmail.com>"
 
-import sys
-import string
 import gtk
 import gobject
 import pango
-import re
 import treemodel
 from bzrlib import ui
 
-from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk.ui import ProgressPanel
 from linegraph import linegraph, same_branch
 from graphcell import CellRendererGraph
 from treemodel import TreeModel
 from bzrlib.revision import NULL_REVISION
+from bzrlib.plugins.gtk import lock
+
 
 class TreeView(gtk.VBox):
 
@@ -91,7 +90,9 @@
                               (gobject.TYPE_PYOBJECT, gobject.TYPE_PYOBJECT)),
         'tag-added': (gobject.SIGNAL_RUN_FIRST,
                               gobject.TYPE_NONE,
-                              (gobject.TYPE_STRING, gobject.TYPE_STRING))
+                              (gobject.TYPE_STRING, gobject.TYPE_STRING)),
+        'refreshed': (gobject.SIGNAL_RUN_FIRST, gobject.TYPE_NONE,
+                              ())
     }
 
     def __init__(self, branch, start, maxnum, compact=True):
@@ -106,6 +107,12 @@
         """
         gtk.VBox.__init__(self, spacing=0)
 
+        self.progress_widget = ProgressPanel()
+        self.pack_start(self.progress_widget, expand=False, fill=True)
+        if getattr(ui.ui_factory, "set_progress_bar_widget", None) is not None:
+            # We'are using our own ui, let's tell it to use our widget.
+            ui.ui_factory.set_progress_bar_widget(self.progress_widget)
+
         self.scrolled_window = gtk.ScrolledWindow()
         self.scrolled_window.set_policy(gtk.POLICY_AUTOMATIC,
                                         gtk.POLICY_AUTOMATIC)
@@ -115,9 +122,10 @@
 
         self.scrolled_window.add(self.construct_treeview())
 
-        self.iter = None
+        self.path = None
         self.branch = branch
         self.revision = None
+        self.index = {}
 
         self.start = start
         self.maxnum = maxnum
@@ -125,7 +133,13 @@
 
         gobject.idle_add(self.populate)
 
-        self.connect("destroy", lambda x: self.branch.unlock())
+        self.connect("destroy", self._on_destroy)
+
+    def _on_destroy(self, *ignored):
+        self.branch.unlock()
+        if getattr(ui.ui_factory, "set_progress_bar_widget", None) is not None:
+            # We'are using our own ui, let's tell it to stop using our widget.
+            ui.ui_factory.set_progress_bar_widget(None)
 
     def do_get_property(self, property):
         if property.name == 'revno-column-visible':
@@ -141,13 +155,17 @@
         elif property.name == 'branch':
             return self.branch
         elif property.name == 'revision':
-            return self.model.get_value(self.iter, treemodel.REVISION)
+            return self.model.get_value(self.model.get_iter(self.path),
+                                        treemodel.REVISION)
         elif property.name == 'revision-number':
-            return self.model.get_value(self.iter, treemodel.REVNO)
+            return self.model.get_value(self.model.get_iter(self.path),
+                                        treemodel.REVNO)
         elif property.name == 'children':
-            return self.model.get_value(self.iter, treemodel.CHILDREN)
+            return self.model.get_value(self.model.get_iter(self.path),
+                                        treemodel.CHILDREN)
         elif property.name == 'parents':
-            return self.model.get_value(self.iter, treemodel.PARENTS)
+            return self.model.get_value(self.model.get_iter(self.path),
+                                        treemodel.PARENTS)
         else:
             raise AttributeError, 'unknown property %s' % property.name
 
@@ -173,6 +191,9 @@
         """Return revision id of currently selected revision, or None."""
         return self.get_property('revision')
 
+    def has_revision_id(self, revision_id):
+        return (revision_id in self.index)
+
     def set_revision(self, revision):
         self.set_property('revision', revision)
 
@@ -201,19 +222,16 @@
     def add_tag(self, tag, revid=None):
         if revid is None: revid = self.revision.revision_id
 
-        try:
-            self.branch.unlock()
-
+        if lock.release(self.branch):
             try:
-                self.branch.lock_write()
+                lock.acquire(self.branch, lock.WRITE)
                 self.model.add_tag(tag, revid)
             finally:
-                self.branch.unlock()
-
-        finally:
-            self.branch.lock_read()
-
-        self.emit('tag-added', tag, revid)
+                lock.release(self.branch)
+
+            lock.acquire(self.branch, lock.READ)
+
+            self.emit('tag-added', tag, revid)
         
     def refresh(self):
         gobject.idle_add(self.populate, self.get_revision())
@@ -269,8 +287,11 @@
                        should be broken.
         """
 
-        loading_progress = ui.ui_factory.nested_progress_bar()
-        loading_progress.update(msg="Loading ancestry graph", total=5)
+        if getattr(ui.ui_factory, "set_progress_bar_widget", None) is not None:
+            # We'are using our own ui, let's tell it to use our widget.
+            ui.ui_factory.set_progress_bar_widget(self.progress_widget)
+        self.progress_bar = ui.ui_factory.nested_progress_bar()
+        self.progress_bar.update("Loading ancestry graph", 0, 5)
 
         try:
             if self.compact:
@@ -287,7 +308,7 @@
                                                             broken_line_length,
                                                             show_graph,
                                                             self.mainline_only,
-                                                            loading_progress)
+                                                            self.progress_bar)
 
             self.model = TreeModel(self.branch, linegraphdata)
             self.graph_cell.columns_len = columns_len
@@ -304,9 +325,10 @@
             else:
                 self.set_revision(revision)
 
+            self.emit('refreshed')
             return False
         finally:
-            loading_progress.finished()
+            self.progress_bar.finished()
 
     def construct_treeview(self):
         self.treeview = gtk.TreeView()
@@ -319,6 +341,7 @@
         if set_tooltip is not None:
             set_tooltip(treemodel.MESSAGE)
 
+        self._prev_cursor_path = None
         self.treeview.connect("cursor-changed",
                 self._on_selection_changed)
 
@@ -369,13 +392,13 @@
         cell = gtk.CellRendererText()
         cell.set_property("width-chars", 15)
         cell.set_property("ellipsize", pango.ELLIPSIZE_END)
-        self.committer_column = gtk.TreeViewColumn("Committer")
-        self.committer_column.set_resizable(False)
-        self.committer_column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
-        self.committer_column.set_fixed_width(200)
-        self.committer_column.pack_start(cell, expand=True)
-        self.committer_column.add_attribute(cell, "text", treemodel.COMMITTER)
-        self.treeview.append_column(self.committer_column)
+        self.authors_column = gtk.TreeViewColumn("Author(s)")
+        self.authors_column.set_resizable(False)
+        self.authors_column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
+        self.authors_column.set_fixed_width(200)
+        self.authors_column.pack_start(cell, expand=True)
+        self.authors_column.add_attribute(cell, "text", treemodel.AUTHORS)
+        self.treeview.append_column(self.authors_column)
 
         cell = gtk.CellRendererText()
         cell.set_property("width-chars", 20)
@@ -390,18 +413,19 @@
         self.treeview.append_column(self.date_column)
         
         return self.treeview
-
+    
     def _on_selection_changed(self, treeview):
         """callback for when the treeview changes."""
         (path, focus) = treeview.get_cursor()
-        if path is not None:
-            self.iter = self.model.get_iter(path)
+        if (path is not None) and (path != self._prev_cursor_path):
+            self._prev_cursor_path = path # avoid emitting twice per click
+            self.path = path
             self.emit('revision-selected')
 
     def _on_revision_selected(self, widget, event):
-        from bzrlib.plugins.gtk.revisionmenu import RevisionPopupMenu
+        from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
         if event.button == 3:
-            menu = RevisionPopupMenu(self.branch.repository, 
+            menu = RevisionMenu(self.branch.repository, 
                 [self.get_revision().revision_id],
                 self.branch)
             menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))

=== modified file 'bzr-handle-patch'
--- bzr-handle-patch	2008-06-27 16:53:56 +0000
+++ bzr-handle-patch	2010-04-13 15:06:17 +0000
@@ -25,7 +25,7 @@
 	try:
 		directive = merge_directive.MergeDirective.from_lines(lines)
 	except errors.NotAMergeDirective:
-		controller = DiffController(path, lines)
+		controller = DiffController(path, lines, allow_dirty=True)
 	else:
 		controller = MergeDirectiveController(path, directive)
 	window = controller.window
@@ -33,7 +33,7 @@
 	gtk = open_display()
 	window.connect("destroy", gtk.main_quit)
 except Exception, e:
-	from dialog import error_dialog
+	from bzrlib.plugins.gtk.dialog import error_dialog
 	error_dialog('Error', str(e))
 	raise
 gtk.main()

=== modified file 'bzr-handle-patch.desktop'
--- bzr-handle-patch.desktop	2008-05-01 13:00:15 +0000
+++ bzr-handle-patch.desktop	2008-10-14 19:49:27 +0000
@@ -1,8 +1,8 @@
 [Desktop Entry]
 Name=Bazaar
 Comment=Apply Bazaar Bundle
-Icon=bazaar
-Exec=bzr ghandle-patch %f
+Icon=bzr-icon-64
+Exec=bzr-handle-patch %f
 NoDisplay=true
 Terminal=false
 Type=Application

=== added file 'bzr-notify'
--- bzr-notify	1970-01-01 00:00:00 +0000
+++ bzr-notify	2011-02-15 00:15:40 +0000
@@ -0,0 +1,92 @@
+#!/usr/bin/env python
+
+"""Run the bzr tray icon.
+
+This is a background program which will pop up a notification on the users
+screen when a commit occurs.
+"""
+
+from bzrlib.plugin import load_plugins
+load_plugins()
+
+from bzrlib.plugins.gtk import open_display, icon_path
+
+from bzrlib.plugins.gtk.notify import NotifyPopupMenu
+gtk = open_display()
+
+import cgi
+import dbus
+import dbus.service
+import gobject
+import pynotify
+from bzrlib.bzrdir import BzrDir
+from bzrlib.osutils import format_date
+from bzrlib.transport import get_transport
+
+menu = NotifyPopupMenu()
+try:
+    import appindicator
+except ImportError:
+    icon = gtk.status_icon_new_from_icon_name("bzr-panel")
+    icon.connect('popup-menu', menu.display)
+    icon.set_visible(False)
+    hide_icon = lambda: icon.set_visible(False)
+    show_icon = lambda: icon.set_visible(True)
+else:
+    indicator = appindicator.Indicator ("bzr-gtk-notify",
+        "bzr-panel", appindicator.CATEGORY_OTHER)
+    indicator.set_status (appindicator.STATUS_PASSIVE)
+    indicator.set_attention_icon("bzr-panel")
+    indicator.set_menu(menu)
+    hide_icon = lambda: indicator.set_status (appindicator.STATUS_PASSIVE)
+    show_icon = lambda: indicator.set_status (appindicator.STATUS_ATTENTION)
+
+if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
+    import dbus.glib
+BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
+bus = dbus.SessionBus()
+
+def catch_branch(revision_id, urls):
+    # TODO: show all the urls, or perhaps choose the 'best'.
+    url = urls[0]
+    try:
+        if isinstance(revision_id, unicode):
+            revision_id = revision_id.encode('utf8')
+        transport = get_transport(url)
+        a_dir = BzrDir.open_from_transport(transport)
+        branch = a_dir.open_branch()
+        revno = branch.revision_id_to_revno(revision_id)
+        revision = branch.repository.get_revision(revision_id)
+        summary = 'New revision %d in %s' % (revno, url)
+        body = 'Committer: %s\n' % revision.committer
+        body += 'Date: %s\n' % format_date(revision.timestamp,
+            revision.timezone)
+        body += '\n'
+        body += revision.message
+        body = cgi.escape(body)
+        nw = pynotify.Notification(summary, body)
+        def start_viz(notification=None, action=None, data=None):
+            """Start the viz program."""
+            from bzrlib.plugins.gtk.commands import start_viz_window
+            pp = start_viz_window(branch, revision_id)
+            pp.show()
+        def start_branch(notification=None, action=None, data=None):
+            """Start a Branch dialog"""
+            from bzrlib.plugins.gtk.branch import BranchDialog
+            bd = BranchDialog(remote_path=url)
+            bd.run()
+        if "actions" in pynotify.get_server_caps():
+            nw.add_action("inspect", "Inspect", start_viz, None)
+            nw.add_action("branch", "Branch", start_branch, None)
+        show_icon()
+        gobject.timeout_add(5000, hide_icon)
+        nw.set_timeout(5000)
+        nw.show()
+    except Exception, e:
+        print e
+        raise
+bus.add_signal_receiver(catch_branch,
+                        dbus_interface=BROADCAST_INTERFACE,
+                        signal_name="Revision")
+pynotify.init("bzr-notify")
+gtk.main()

=== modified file 'bzr-notify.desktop'
--- bzr-notify.desktop	2008-05-01 13:00:15 +0000
+++ bzr-notify.desktop	2009-10-06 13:57:12 +0000
@@ -1,11 +1,10 @@
 [Desktop Entry]
-Encoding=UTF-8
 Type=Application
 Version=0.1
 Name=Bazaar Notification
 GenericName=
 Comment=Notification Area Icon for Bazaar
-Icon=bzr-icon-64.png
-Exec=bzr commit-notify
+Icon=bzr-icon-64
+Exec=bzr-notify
 Categories=Application;Development;RevisionControl;
 Terminal=false

=== modified file 'checkout.py'
--- checkout.py	2008-05-05 18:16:46 +0000
+++ checkout.py	2010-05-29 23:42:20 +0000
@@ -33,7 +33,6 @@
 from dialog import error_dialog
 
 from history import UrlHistory
-from olive import Preferences
 
 class CheckoutDialog(gtk.Dialog):
     """ New implementation of the Checkout dialog. """
@@ -55,7 +54,7 @@
         self._combo = gtk.ComboBoxEntry()
         self._label_location = gtk.Label(_i18n("Branch location:"))
         self._label_destination = gtk.Label(_i18n("Destination:"))
-        self._label_nick = gtk.Label(_i18n("Branck nick:"))
+        self._label_nick = gtk.Label(_i18n("Branch nick:"))
         self._label_revision = gtk.Label(_i18n("Revision:"))
         self._hbox_revision = gtk.HBox()
         self._entry_revision = gtk.Entry()
@@ -117,10 +116,6 @@
         for item in self._history.get_entries():
             self._combo_model.append([ item ])
         
-        pref = Preferences()
-        for item in pref.get_bookmarks():
-            self._combo_model.append([ item ])
-        
         self._combo.set_model(self._combo_model)
         self._combo.set_text_column(0)
     

=== removed file 'cmenu.ui'
--- cmenu.ui	2007-07-21 13:16:33 +0000
+++ cmenu.ui	1970-01-01 00:00:00 +0000
@@ -1,32 +0,0 @@
-<ui>
-    <popup name="context_right">
-        <menuitem name="add" action="add" />
-        <menuitem name="remove" action="remove" />
-        <menuitem name="remove_and_delete" action="remove_and_delete" />
-        <menuitem name="rename" action="rename" />
-        <menuitem name="open" action="open" />
-        <separator />
-        <menuitem name="revert" action="revert" />
-        <menuitem name="commit" action="commit" />
-        <separator />
-        <menuitem name="annotate" action="annotate" />
-        <menuitem name="diff" action="diff" />
-        <separator />
-        <menuitem name="bookmark" action="bookmark" />
-    </popup>
-    <popup name="context_left">
-        <menuitem name="edit_bookmark" action="edit_bookmark" />
-        <menuitem name="remove_bookmark" action="remove_bookmark" />
-        <separator />
-        <menuitem name="open_folder" action="open_folder" />
-    </popup>
-    <popup name="toolbar_diff">
-        <menuitem name="diff_selected" action="diff_selected" />
-        <menuitem name="diff_all" action="diff_all" />
-    </popup>
-    <popup name="context_remote">
-        <menuitem name="view_remote" action="view_remote" />
-        <menuitem name="diff_remote" action="diff_remote" />
-        <menuitem name="revert_remote" action="revert_remote" />
-    </popup>
-</ui>

=== added file 'commands.py'
--- commands.py	1970-01-01 00:00:00 +0000
+++ commands.py	2011-01-31 10:19:52 +0000
@@ -0,0 +1,483 @@
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+
+from bzrlib import (
+    branch,
+    errors,
+    workingtree,
+    )
+from bzrlib.commands import (
+    Command,
+    display_command,
+    )
+from bzrlib.errors import (
+    BzrCommandError,
+    NoWorkingTree,
+    NotVersionedError,
+    NoSuchFile,
+    )
+from bzrlib.option import Option
+
+from bzrlib.plugins.gtk import (
+    _i18n,
+    import_pygtk,
+    set_ui_factory,
+    )
+
+
+class NoDisplayError(errors.BzrCommandError):
+    """gtk could not find a proper display"""
+
+    def __str__(self):
+        return "No DISPLAY. Unable to run GTK+ application."
+
+
+def open_display():
+    pygtk = import_pygtk()
+    try:
+        import gtk
+    except RuntimeError, e:
+        if str(e) == "could not open display":
+            raise NoDisplayError
+    set_ui_factory()
+    return gtk
+
+
+
+class GTKCommand(Command):
+    """Abstract class providing GTK specific run commands."""
+
+    def run(self):
+        open_display()
+        dialog = self.get_gtk_dialog(os.path.abspath('.'))
+        dialog.run()
+
+
+class cmd_gbranch(GTKCommand):
+    """GTK+ branching.
+    
+    """
+
+    def get_gtk_dialog(self, path):
+        from bzrlib.plugins.gtk.branch import BranchDialog
+        return BranchDialog(path)
+
+
+class cmd_gcheckout(GTKCommand):
+    """ GTK+ checkout.
+    
+    """
+    
+    def get_gtk_dialog(self, path):
+        from bzrlib.plugins.gtk.checkout import CheckoutDialog
+        return CheckoutDialog(path)
+
+
+
+class cmd_gpush(GTKCommand):
+    """ GTK+ push.
+    
+    """
+    takes_args = [ "location?" ]
+
+    def run(self, location="."):
+        (br, path) = branch.Branch.open_containing(location)
+        open_display()
+        from bzrlib.plugins.gtk.push import PushDialog
+        dialog = PushDialog(br.repository, br.last_revision(), br)
+        dialog.run()
+
+
+class cmd_gloom(GTKCommand):
+    """ GTK+ loom.
+    
+    """
+    takes_args = [ "location?" ]
+
+    def run(self, location="."):
+        try:
+            (tree, path) = workingtree.WorkingTree.open_containing(location)
+            br = tree.branch
+        except NoWorkingTree, e:
+            (br, path) = branch.Branch.open_containing(location)
+            tree = None
+        open_display()
+        from bzrlib.plugins.gtk.loom import LoomDialog
+        dialog = LoomDialog(br, tree)
+        dialog.run()
+
+
+class cmd_gdiff(GTKCommand):
+    """Show differences in working tree in a GTK+ Window.
+    
+    Otherwise, all changes for the tree are listed.
+    """
+    takes_args = ['filename?']
+    takes_options = ['revision']
+
+    @display_command
+    def run(self, revision=None, filename=None):
+        set_ui_factory()
+        wt = workingtree.WorkingTree.open_containing(".")[0]
+        wt.lock_read()
+        try:
+            branch = wt.branch
+            if revision is not None:
+                if len(revision) == 1:
+                    tree1 = wt
+                    revision_id = revision[0].as_revision_id(tree1.branch)
+                    tree2 = branch.repository.revision_tree(revision_id)
+                elif len(revision) == 2:
+                    revision_id_0 = revision[0].as_revision_id(branch)
+                    tree2 = branch.repository.revision_tree(revision_id_0)
+                    revision_id_1 = revision[1].as_revision_id(branch)
+                    tree1 = branch.repository.revision_tree(revision_id_1)
+            else:
+                tree1 = wt
+                tree2 = tree1.basis_tree()
+
+            from diff import DiffWindow
+            import gtk
+            window = DiffWindow()
+            window.connect("destroy", gtk.main_quit)
+            window.set_diff("Working Tree", tree1, tree2)
+            if filename is not None:
+                tree_filename = wt.relpath(filename)
+                try:
+                    window.set_file(tree_filename)
+                except NoSuchFile:
+                    if (tree1.path2id(tree_filename) is None and 
+                        tree2.path2id(tree_filename) is None):
+                        raise NotVersionedError(filename)
+                    raise BzrCommandError('No changes found for file "%s"' % 
+                                          filename)
+            window.show()
+
+            gtk.main()
+        finally:
+            wt.unlock()
+
+
+def start_viz_window(branch, revisions, limit=None):
+    """Start viz on branch with revision revision.
+    
+    :return: The viz window object.
+    """
+    from bzrlib.plugins.gtk.viz import BranchWindow
+    return BranchWindow(branch, revisions, limit)
+
+
+class cmd_visualise(Command):
+    """Graphically visualise one or several branches.
+
+    Opens a graphical window to allow you to see branches history and
+    relationships between revisions in a visual manner,
+
+    If no revision is specified, the branch last revision is taken as a
+    starting point. When a revision is specified, the presented graph starts
+    with it (as a side effect, when a shared repository is used, any revision
+    can be used even if it's not part of the branch history).
+    """
+    takes_options = [
+        "revision",
+        Option('limit', "Maximum number of revisions to display.",
+               int, 'count')]
+    takes_args = [ "locations*" ]
+    aliases = [ "visualize", "vis", "viz" ]
+
+    def run(self, locations_list, revision=None, limit=None):
+        set_ui_factory()
+        if locations_list is None:
+            locations_list = ["."]
+        revids = []
+        for location in locations_list:
+            (br, path) = branch.Branch.open_containing(location)
+            if revision is None:
+                revids.append(br.last_revision())
+            else:
+                revids.append(revision[0].as_revision_id(br))
+        import gtk
+        pp = start_viz_window(br, revids, limit)
+        pp.connect("destroy", lambda w: gtk.main_quit())
+        pp.show()
+        gtk.main()
+
+
+class cmd_gannotate(GTKCommand):
+    """GTK+ annotate.
+    
+    Browse changes to FILENAME line by line in a GTK+ window.
+
+    Within the annotate window, you can use Ctrl-F to search for text, and 
+    Ctrl-G to jump to a line by number.
+    """
+
+    takes_args = ["filename", "line?"]
+    takes_options = [
+        Option("all", help="Show annotations on all lines."),
+        Option("plain", help="Don't highlight annotation lines."),
+        Option("line", type=int, argname="lineno",
+               help="Jump to specified line number."),
+        "revision",
+    ]
+    aliases = ["gblame", "gpraise"]
+    
+    def run(self, filename, all=False, plain=False, line='1', revision=None):
+        gtk = open_display()
+
+        try:
+            line = int(line)
+        except ValueError:
+            raise BzrCommandError('Line argument ("%s") is not a number.' % 
+                                  line)
+
+        from annotate.gannotate import GAnnotateWindow
+        from annotate.config import GAnnotateConfig
+        from bzrlib.bzrdir import BzrDir
+
+        wt, br, path = BzrDir.open_containing_tree_or_branch(filename)
+        if wt is not None:
+            tree = wt
+        else:
+            tree = br.basis_tree()
+
+        file_id = tree.path2id(path)
+
+        if file_id is None:
+            raise NotVersionedError(filename)
+        if revision is not None:
+            if len(revision) != 1:
+                raise BzrCommandError("Only 1 revion may be specified.")
+            revision_id = revision[0].as_revision_id(br)
+            tree = br.repository.revision_tree(revision_id)
+        else:
+            revision_id = getattr(tree, 'get_revision_id', lambda: None)()
+
+        window = GAnnotateWindow(all, plain, branch=br)
+        window.connect("destroy", lambda w: gtk.main_quit())
+        config = GAnnotateConfig(window)
+        window.show()
+        br.lock_read()
+        if wt is not None:
+            wt.lock_read()
+        try:
+            window.annotate(tree, br, file_id)
+            window.jump_to_line(line)
+            gtk.main()
+        finally:
+            br.unlock()
+            if wt is not None:
+                wt.unlock()
+
+
+
+class cmd_gcommit(GTKCommand):
+    """GTK+ commit dialog
+
+    Graphical user interface for committing revisions"""
+
+    aliases = [ "gci" ]
+    takes_args = []
+    takes_options = []
+
+    def run(self, filename=None):
+        open_display()
+        from commit import CommitDialog
+
+        wt = None
+        br = None
+        try:
+            (wt, path) = workingtree.WorkingTree.open_containing(filename)
+            br = wt.branch
+        except NoWorkingTree, e:
+            from dialog import error_dialog
+            error_dialog(_i18n('Directory does not have a working tree'),
+                         _i18n('Operation aborted.'))
+            return 1 # should this be retval=3?
+
+        # It is a good habit to keep things locked for the duration, but it
+        # could cause difficulties if someone wants to do things in another
+        # window... We could lock_read() until we actually go to commit
+        # changes... Just a thought.
+        wt.lock_write()
+        try:
+            dlg = CommitDialog(wt)
+            return dlg.run()
+        finally:
+            wt.unlock()
+
+
+class cmd_gstatus(GTKCommand):
+    """GTK+ status dialog
+
+    Graphical user interface for showing status 
+    information."""
+
+    aliases = [ "gst" ]
+    takes_args = ['PATH?']
+    takes_options = ['revision']
+
+    def run(self, path='.', revision=None):
+        gtk = open_display()
+        from bzrlib.plugins.gtk.status import StatusWindow
+        (wt, wt_path) = workingtree.WorkingTree.open_containing(path)
+
+        if revision is not None:
+            try:
+                revision_id = revision[0].as_revision_id(wt.branch)
+            except:
+                from bzrlib.errors import BzrError
+                raise BzrError('Revision %r doesn\'t exist'
+                               % revision[0].user_spec )
+        else:
+            revision_id = None
+
+        status = StatusWindow(wt, wt_path, revision_id)
+        status.connect("destroy", gtk.main_quit)
+        status.show()
+        gtk.main()
+
+
+class cmd_gsend(GTKCommand):
+    """GTK+ send merge directive.
+
+    """
+    def run(self):
+        (br, path) = branch.Branch.open_containing(".")
+        gtk = open_display()
+        from bzrlib.plugins.gtk.mergedirective import SendMergeDirectiveDialog
+        from StringIO import StringIO
+        dialog = SendMergeDirectiveDialog(br)
+        if dialog.run() == gtk.RESPONSE_OK:
+            outf = StringIO()
+            outf.writelines(dialog.get_merge_directive().to_lines())
+            mail_client = br.get_config().get_mail_client()
+            mail_client.compose_merge_request(dialog.get_mail_to(), "[MERGE]", 
+                outf.getvalue())
+
+            
+
+
+class cmd_gconflicts(GTKCommand):
+    """GTK+ conflicts.
+    
+    Select files from the list of conflicts and run an external utility to
+    resolve them.
+    """
+    def run(self):
+        (wt, path) = workingtree.WorkingTree.open_containing('.')
+        open_display()
+        from bzrlib.plugins.gtk.conflicts import ConflictsDialog
+        dialog = ConflictsDialog(wt)
+        dialog.run()
+
+
+class cmd_gpreferences(GTKCommand):
+    """ GTK+ preferences dialog.
+
+    """
+    def run(self):
+        open_display()
+        from bzrlib.plugins.gtk.preferences import PreferencesWindow
+        dialog = PreferencesWindow()
+        dialog.run()
+
+
+class cmd_gmerge(Command):
+    """ GTK+ merge dialog
+    
+    """
+    takes_args = ["merge_from_path?"]
+    def run(self, merge_from_path=None):
+        from bzrlib.plugins.gtk.dialog import error_dialog
+        from bzrlib.plugins.gtk.merge import MergeDialog
+        
+        (wt, path) = workingtree.WorkingTree.open_containing('.')
+        old_tree = wt.branch.repository.revision_tree(wt.branch.last_revision())
+        delta = wt.changes_from(old_tree)
+        if len(delta.added) or len(delta.removed) or len(delta.renamed) or len(delta.modified):
+            error_dialog(_i18n('There are local changes in the branch'),
+                         _i18n('Please commit or revert the changes before merging.'))
+        else:
+            parent_branch_path = wt.branch.get_parent()
+            merge = MergeDialog(wt, path, parent_branch_path)
+            response = merge.run()
+            merge.destroy()
+
+
+class cmd_gmissing(Command):
+    """ GTK+ missing revisions dialog.
+
+    """
+    takes_args = ["other_branch?"]
+    def run(self, other_branch=None):
+        pygtk = import_pygtk()
+        try:
+            import gtk
+        except RuntimeError, e:
+            if str(e) == "could not open display":
+                raise NoDisplayError
+
+        from bzrlib.plugins.gtk.missing import MissingWindow
+        from bzrlib.branch import Branch
+
+        local_branch = Branch.open_containing(".")[0]
+        if other_branch is None:
+            other_branch = local_branch.get_parent()
+            
+            if other_branch is None:
+                raise BzrCommandError("No peer location known or specified.")
+        remote_branch = Branch.open_containing(other_branch)[0]
+        set_ui_factory()
+        local_branch.lock_read()
+        try:
+            remote_branch.lock_read()
+            try:
+                dialog = MissingWindow(local_branch, remote_branch)
+                dialog.run()
+            finally:
+                remote_branch.unlock()
+        finally:
+            local_branch.unlock()
+
+
+class cmd_ginit(GTKCommand):
+    """ GTK+ init dialog
+
+    Graphical user interface for initializing new branches.
+
+    """
+    def run(self):
+        open_display()
+        from initialize import InitDialog
+        dialog = InitDialog(os.path.abspath(os.path.curdir))
+        dialog.run()
+
+
+class cmd_gtags(GTKCommand):
+    """ GTK+ tags dialog 
+
+    Graphical user interface to view, create, or remove tags.
+
+    """
+    def run(self):
+        br = branch.Branch.open_containing('.')[0]
+        
+        gtk = open_display()
+        from tags import TagsWindow
+        window = TagsWindow(br)
+        window.show()
+        gtk.main()

=== modified file 'commit.py'
--- commit.py	2008-06-07 09:00:24 +0000
+++ commit.py	2010-07-21 20:21:17 +0000
@@ -14,6 +14,8 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+import re
+
 try:
     import pygtk
     pygtk.require("2.0")
@@ -24,16 +26,19 @@
 import gobject
 import pango
 
-import os.path
-import re
-
-from bzrlib import errors, osutils
-from bzrlib.trace import mutter
-from bzrlib.util import bencode
+from bzrlib import (
+    errors,
+    osutils,
+    trace,
+    )
+try:
+    from bzrlib import bencode
+except ImportError:
+    from bzrlib.util import bencode
 
 from bzrlib.plugins.gtk import _i18n
-from dialog import error_dialog, question_dialog
-from errors import show_bzr_error
+from bzrlib.plugins.gtk.dialog import question_dialog
+from bzrlib.plugins.gtk.errors import show_bzr_error
 
 try:
     import dbus
@@ -97,16 +102,24 @@
     return pm
 
 
+_newline_variants_re = re.compile(r'\r\n?')
+def _sanitize_and_decode_message(utf8_message):
+    """Turn a utf-8 message into a sanitized Unicode message."""
+    fixed_newline = _newline_variants_re.sub('\n', utf8_message)
+    return fixed_newline.decode('utf-8')
+
+
 class CommitDialog(gtk.Dialog):
     """Implementation of Commit."""
 
     def __init__(self, wt, selected=None, parent=None):
-        gtk.Dialog.__init__(self, title="Commit - Olive",
-                                  parent=parent,
-                                  flags=0,
-                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        gtk.Dialog.__init__(self, title="Commit to %s" % wt.basedir,
+                            parent=parent, flags=0,)
+        self.connect('delete-event', self._on_delete_window)
         self._question_dialog = question_dialog
 
+        self.set_type_hint(gtk.gdk.WINDOW_TYPE_HINT_NORMAL)
+
         self._wt = wt
         # TODO: Do something with this value, it is used by Olive
         #       It used to set all changes but this one to False
@@ -114,6 +127,7 @@
         self._enable_per_file_commits = True
         self._commit_all_changes = True
         self.committed_revision_id = None # Nothing has been committed yet
+        self._saved_commit_messages_manager = SavedCommitMessagesManager(self._wt, self._wt.branch)
 
         self.setup_params()
         self.construct()
@@ -188,19 +202,24 @@
         self._basis_tree.lock_read()
         try:
             from diff import iter_changes_to_status
+            saved_file_messages = self._saved_commit_messages_manager.get()[1]
             for (file_id, real_path, change_type, display_path
                 ) in iter_changes_to_status(self._basis_tree, self._wt):
                 if self._selected and real_path != self._selected:
                     enabled = False
                 else:
                     enabled = True
+                try:
+                    default_message = saved_file_messages[file_id]
+                except KeyError:
+                    default_message = ''
                 item_iter = store.append([
                     file_id,
                     real_path.encode('UTF-8'),
                     enabled,
                     display_path.encode('UTF-8'),
                     change_type,
-                    '', # Initial comment
+                    default_message, # Initial comment
                     ])
                 if self._selected and enabled:
                     initial_cursor = store.get_path(item_iter)
@@ -232,7 +251,7 @@
                 proxy_obj = bus.get_object('org.freedesktop.NetworkManager',
                                            '/org/freedesktop/NetworkManager')
             except dbus.DBusException:
-                mutter("networkmanager not available.")
+                trace.mutter("networkmanager not available.")
                 self._check_local.show()
                 return
             
@@ -244,7 +263,7 @@
             except dbus.DBusException, e:
                 # Silently drop errors. While DBus may be
                 # available, NetworkManager doesn't necessarily have to be
-                mutter("unable to get networkmanager state: %r" % e)
+                trace.mutter("unable to get networkmanager state: %r" % e)
         self._check_local.show()
 
     def _fill_in_per_file_info(self):
@@ -338,6 +357,10 @@
         self._hpane.pack2(self._right_pane_table, resize=True, shrink=True)
 
     def _construct_action_pane(self):
+        self._button_cancel = gtk.Button(stock=gtk.STOCK_CANCEL)
+        self._button_cancel.connect('clicked', self._on_cancel_clicked)
+        self._button_cancel.show()
+        self.action_area.pack_end(self._button_cancel)
         self._button_commit = gtk.Button(_i18n("Comm_it"), use_underline=True)
         self._button_commit.connect('clicked', self._on_commit_clicked)
         self._button_commit.set_flags(gtk.CAN_DEFAULT)
@@ -539,6 +562,7 @@
         scroller.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
 
         self._global_message_text_view = gtk.TextView()
+        self._set_global_commit_message(self._saved_commit_messages_manager.get()[0])
         self._global_message_text_view.modify_font(pango.FontDescription("Monospace"))
         scroller.add(self._global_message_text_view)
         scroller.set_shadow_type(gtk.SHADOW_IN)
@@ -630,10 +654,12 @@
             if self._commit_all_changes or record[2]:# [2] checkbox
                 file_id = record[0] # [0] file_id
                 path = record[1]    # [1] real path
-                file_message = record[5] # [5] commit message
+                # [5] commit message
+                file_message = _sanitize_and_decode_message(record[5])
                 files.append(path.decode('UTF-8'))
                 if self._enable_per_file_commits and file_message:
                     # All of this needs to be utf-8 information
+                    file_message = file_message.encode('UTF-8')
                     file_info.append({'path':path, 'file_id':file_id,
                                      'message':file_message})
         file_info.sort(key=lambda x:(x['path'], x['file_id']))
@@ -643,6 +669,33 @@
             return files, []
 
     @show_bzr_error
+    def _on_cancel_clicked(self, button):
+        """ Cancel button clicked handler. """
+        self._do_cancel()
+
+    @show_bzr_error
+    def _on_delete_window(self, source, event):
+        """ Delete window handler. """
+        self._do_cancel()
+
+    def _do_cancel(self):
+        """If requested, saves commit messages when cancelling gcommit; they are re-used by a next gcommit"""
+        mgr = SavedCommitMessagesManager()
+        self._saved_commit_messages_manager = mgr
+        mgr.insert(self._get_global_commit_message(),
+                   self._get_specific_files()[1])
+        if mgr.is_not_empty(): # maybe worth saving
+            response = self._question_dialog(
+                _i18n('Commit cancelled'),
+                _i18n('Do you want to save your commit messages ?'),
+                parent=self)
+            if response == gtk.RESPONSE_NO:
+                 # save nothing and destroy old comments if any
+                mgr = SavedCommitMessagesManager()
+        mgr.save(self._wt, self._wt.branch)
+        self.response(gtk.RESPONSE_CANCEL) # close window
+
+    @show_bzr_error
     def _on_commit_clicked(self, button):
         """ Commit button clicked handler. """
         self._do_commit()
@@ -653,7 +706,8 @@
         if message == '':
             response = self._question_dialog(
                 _i18n('Commit with an empty message?'),
-                _i18n('You can describe your commit intent in the message.'))
+                _i18n('You can describe your commit intent in the message.'),
+                parent=self)
             if response == gtk.RESPONSE_NO:
                 # Kindly give focus to message area
                 self._global_message_text_view.grab_focus()
@@ -673,7 +727,9 @@
         for path in self._wt.unknowns():
             response = self._question_dialog(
                 _i18n("Commit with unknowns?"),
-                _i18n("Unknown files exist in the working tree. Commit anyway?"))
+                _i18n("Unknown files exist in the working tree. Commit anyway?"),
+                parent=self)
+                # Doesn't set a parent for the dialog..
             if response == gtk.RESPONSE_NO:
                 return
             break
@@ -693,7 +749,8 @@
             response = self._question_dialog(
                 _i18n('Commit with no changes?'),
                 _i18n('There are no changes in the working tree.'
-                      ' Do you want to commit anyway?'))
+                      ' Do you want to commit anyway?'),
+                parent=self)
             if response == gtk.RESPONSE_YES:
                 rev_id = self._wt.commit(message,
                                allow_pointless=True,
@@ -702,12 +759,15 @@
                                specific_files=specific_files,
                                revprops=revprops)
         self.committed_revision_id = rev_id
+        # destroy old comments if any
+        SavedCommitMessagesManager().save(self._wt, self._wt.branch)
         self.response(gtk.RESPONSE_OK)
 
     def _get_global_commit_message(self):
         buf = self._global_message_text_view.get_buffer()
         start, end = buf.get_bounds()
-        return buf.get_text(start, end).decode('utf-8')
+        text = buf.get_text(start, end)
+        return _sanitize_and_decode_message(text)
 
     def _set_global_commit_message(self, message):
         """Just a helper for the test suite."""
@@ -734,3 +794,102 @@
                                        show_offset=False)
         rev_dict['revision_id'] = rev.revision_id
         return rev_dict
+
+
+class SavedCommitMessagesManager:
+    """Save glogal and per-file commit messages.
+
+    Saves global commit message and utf-8 file_id->message dictionary
+    of per-file commit messages on disk. Re-reads them later for re-using.
+    """
+
+    def __init__(self, tree=None, branch=None):
+        """If branch is None, builds empty messages, otherwise reads them
+        from branch's disk storage. 'tree' argument is for the future."""
+        if branch is None:
+            self.global_message = u''
+            self.file_messages = {}
+        else:
+            config = branch.get_config()
+            self.global_message = config.get_user_option(
+                'gtk_global_commit_message')
+            if self.global_message is None:
+                self.global_message = u''
+            file_messages = config.get_user_option('gtk_file_commit_messages')
+            if file_messages: # unicode and B-encoded:
+                self.file_messages = bencode.bdecode(
+                    file_messages.encode('UTF-8'))
+            else:
+                self.file_messages = {}
+
+    def get(self):
+        return self.global_message, self.file_messages
+
+    def is_not_empty(self):
+        return bool(self.global_message or self.file_messages)
+
+    def insert(self, global_message, file_info):
+        """Formats per-file commit messages (list of dictionaries, one per file)
+        into one utf-8 file_id->message dictionary and merges this with
+        previously existing dictionary. Merges global commit message too."""
+        file_messages = {}
+        for fi in file_info:
+            file_message = fi['message']
+            if file_message:
+                file_messages[fi['file_id']] = file_message # utf-8 strings
+        for k,v in file_messages.iteritems():
+            try:
+                self.file_messages[k] = v + '\n******\n' + self.file_messages[k]
+            except KeyError:
+                self.file_messages[k] = v
+        if self.global_message:
+            self.global_message = global_message + '\n******\n' \
+                + self.global_message
+        else:
+            self.global_message = global_message
+
+    def save(self, tree, branch):
+        # We store in branch's config, which can be a problem if two gcommit
+        # are done in two checkouts of one single branch (comments overwrite
+        # each other). Ideally should be in working tree. But uncommit does
+        # not always have a working tree, though it always has a branch.
+        # 'tree' argument is for the future
+        config = branch.get_config()
+        # should it be named "gtk_" or some more neutral name ("gui_" ?) to
+        # be compatible with qbzr in the future?
+        config.set_user_option('gtk_global_commit_message', self.global_message)
+        # bencode() does not know unicode objects but set_user_option()
+        # requires one:
+        config.set_user_option(
+            'gtk_file_commit_messages',
+            bencode.bencode(self.file_messages).decode('UTF-8'))
+
+
+def save_commit_messages(local, master, old_revno, old_revid,
+                         new_revno, new_revid):
+    b = local
+    if b is None:
+        b = master
+    mgr = SavedCommitMessagesManager(None, b)
+    revid_iterator = b.repository.iter_reverse_revision_history(old_revid)
+    cur_revno = old_revno
+    new_revision_id = old_revid
+    graph = b.repository.get_graph()
+    for rev_id in revid_iterator:
+        if cur_revno == new_revno:
+            break
+        cur_revno -= 1
+        rev = b.repository.get_revision(rev_id)
+        file_info = rev.properties.get('file-info', None)
+        if file_info is None:
+            file_info = {}
+        else:
+            file_info = bencode.bdecode(file_info.encode('UTF-8'))
+        global_message = osutils.safe_unicode(rev.message)
+        # Concatenate comment of the uncommitted revision
+        mgr.insert(global_message, file_info)
+
+        parents = graph.get_parent_map([rev_id]).get(rev_id, None)
+        if not parents:
+            continue
+    mgr.save(None, b)

=== modified file 'conflicts.py'
--- conflicts.py	2008-05-05 18:16:46 +0000
+++ conflicts.py	2011-02-18 13:01:03 +0000
@@ -29,10 +29,11 @@
 from bzrlib.plugins.gtk import _i18n
 
 from dialog import error_dialog, warning_dialog
-from errors import show_bzr_error
+
 
 class ConflictsDialog(gtk.Dialog):
     """ This dialog displays the list of conflicts. """
+
     def __init__(self, wt, parent=None):
         """ Initialize the Conflicts dialog. """
         gtk.Dialog.__init__(self, title="Conflicts - Olive",

=== modified file 'dialog.py'
--- dialog.py	2008-04-11 20:34:06 +0000
+++ dialog.py	2011-02-24 09:49:08 +0000
@@ -21,36 +21,35 @@
     pass
 
 import gtk
-import gtk.glade
-
-
-def _message_dialog(type, primary, secondary, buttons=gtk.BUTTONS_OK):
+
+
+def _message_dialog(type, primary, secondary, parent=None, buttons=gtk.BUTTONS_OK):
     """ Display a given type of MessageDialog with the given message.
     
     :param type: message dialog type
     
     :param message: the message you want to display.
     """
-    dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL, type=type,
+    dialog = gtk.MessageDialog(flags=gtk.DIALOG_MODAL, type=type, parent=parent,
                                buttons=buttons)
     dialog.set_markup('<big><b>' + primary + '</b></big>')
-    dialog.format_secondary_markup(secondary)
+    dialog.format_secondary_text(secondary)
     response = dialog.run()
     dialog.destroy()
     return response
 
-def error_dialog(primary, secondary):
+def error_dialog(primary, secondary, parent=None):
     """ Display an error dialog with the given message. """
-    return _message_dialog(gtk.MESSAGE_ERROR, primary, secondary)
+    return _message_dialog(gtk.MESSAGE_ERROR, primary, secondary, parent)
 
-def info_dialog(primary, secondary):
+def info_dialog(primary, secondary, parent=None):
     """ Display an info dialog with the given message. """
-    return _message_dialog(gtk.MESSAGE_INFO, primary, secondary)
+    return _message_dialog(gtk.MESSAGE_INFO, primary, secondary, parent)
 
-def warning_dialog(primary, secondary):
+def warning_dialog(primary, secondary, parent=None):
     """ Display a warning dialog with the given message. """
-    return _message_dialog(gtk.MESSAGE_WARNING, primary, secondary)
+    return _message_dialog(gtk.MESSAGE_WARNING, primary, secondary, parent)
 
-def question_dialog(primary, secondary):
+def question_dialog(primary, secondary, parent=None):
     """ Display a dialog with the given question. """
-    return _message_dialog(gtk.MESSAGE_QUESTION, primary, secondary, gtk.BUTTONS_YES_NO)
+    return _message_dialog(gtk.MESSAGE_QUESTION, primary, secondary, parent, gtk.BUTTONS_YES_NO)

=== modified file 'diff.py'
--- diff.py	2008-05-22 02:33:40 +0000
+++ diff.py	2010-10-08 14:26:56 +0000
@@ -1,11 +1,10 @@
-# -*- coding: UTF-8 -*-
 """Difference window.
 
 This module contains the code to manage the diff window which shows
 the changes made between two revisions on a branch.
 """
 
-__copyright__ = "Copyright © 2005 Canonical Ltd."
+__copyright__ = "Copyright 2005 Canonical Ltd."
 __author__    = "Scott James Remnant <scott@ubuntu.com>"
 
 
@@ -18,9 +17,14 @@
 import os
 import re
 import sys
+import inspect
+try:
+    from xml.etree.ElementTree import Element, SubElement, tostring
+except ImportError:
+    from elementtree.ElementTree import Element, SubElement, tostring
 
 try:
-    import gtksourceview
+    import gtksourceview2
     have_gtksourceview = True
 except ImportError:
     have_gtksourceview = False
@@ -31,14 +35,13 @@
     have_gconf = False
 
 from bzrlib import (
+    errors,
     merge as _mod_merge,
     osutils,
-    progress,
     urlutils,
     workingtree,
 )
 from bzrlib.diff import show_diff_trees, internal_diff
-from bzrlib.errors import NoSuchFile
 from bzrlib.patches import parse_patches
 from bzrlib.trace import warning
 from bzrlib.plugins.gtk import _i18n
@@ -46,6 +49,14 @@
 from dialog import error_dialog, info_dialog, warning_dialog
 
 
+def fallback_guess_language(slm, content_type):
+    for lang_id in slm.get_language_ids():
+        lang = slm.get_language(lang_id)
+        if "text/x-patch" in lang.get_mime_types():
+            return lang
+    return None
+
+
 class SelectCancelled(Exception):
 
     pass
@@ -64,144 +75,121 @@
         self.set_shadow_type(gtk.SHADOW_IN)
 
         if have_gtksourceview:
-            self.buffer = gtksourceview.SourceBuffer()
-            slm = gtksourceview.SourceLanguagesManager()
-            gsl = slm.get_language_from_mime_type("text/x-patch")
+            self.buffer = gtksourceview2.Buffer()
+            slm = gtksourceview2.LanguageManager()
+            guess_language = getattr(gtksourceview2.LanguageManager, 
+                "guess_language", fallback_guess_language)
+            gsl = guess_language(slm, content_type="text/x-patch")
             if have_gconf:
-                self.apply_gedit_colors(gsl)
-            self.apply_colordiff_colors(gsl)
+                self.apply_gedit_colors(self.buffer)
+            self.apply_colordiff_colors(self.buffer)
             self.buffer.set_language(gsl)
-            self.buffer.set_highlight(True)
+            self.buffer.set_highlight_syntax(True)
 
-            sourceview = gtksourceview.SourceView(self.buffer)
+            self.sourceview = gtksourceview2.View(self.buffer)
         else:
             self.buffer = gtk.TextBuffer()
-            sourceview = gtk.TextView(self.buffer)
+            self.sourceview = gtk.TextView(self.buffer)
 
-        sourceview.set_editable(False)
-        sourceview.modify_font(pango.FontDescription("Monospace"))
-        self.add(sourceview)
-        sourceview.show()
+        self.sourceview.set_editable(False)
+        self.sourceview.modify_font(pango.FontDescription("Monospace"))
+        self.add(self.sourceview)
+        self.sourceview.show()
 
     @staticmethod
-    def apply_gedit_colors(lang):
-        """Set style for lang to that specified in gedit configuration.
+    def apply_gedit_colors(buf):
+        """Set style to that specified in gedit configuration.
 
         This method needs the gconf module.
 
-        :param lang: a gtksourceview.SourceLanguage object.
+        :param buf: a gtksourceview2.Buffer object.
         """
-        GEDIT_SYNTAX_PATH = '/apps/gedit-2/preferences/syntax_highlighting'
-        GEDIT_LANG_PATH = GEDIT_SYNTAX_PATH + '/' + lang.get_id()
+        GEDIT_SCHEME_PATH = '/apps/gedit-2/preferences/editor/colors/scheme'
+        GEDIT_USER_STYLES_PATH = os.path.expanduser('~/.gnome2/gedit/styles')
 
         client = gconf.client_get_default()
-        client.add_dir(GEDIT_LANG_PATH, gconf.CLIENT_PRELOAD_NONE)
-
-        for tag in lang.get_tags():
-            tag_id = tag.get_id()
-            gconf_key = GEDIT_LANG_PATH + '/' + tag_id
-            style_string = client.get_string(gconf_key)
-
-            if style_string is None:
-                continue
-
-            # function to get a bool from a string that's either '0' or '1'
-            string_bool = lambda x: bool(int(x))
-
-            # style_string is a string like "2/#FFCCAA/#000000/0/1/0/0"
-            # values are: mask, fg, bg, italic, bold, underline, strike
-            # this packs them into (str_value, attr_name, conv_func) tuples
-            items = zip(style_string.split('/'), ['mask', 'foreground',
-                'background', 'italic', 'bold', 'underline', 'strikethrough' ],
-                [ int, gtk.gdk.color_parse, gtk.gdk.color_parse, string_bool,
-                    string_bool, string_bool, string_bool ]
-            )
-
-            style = gtksourceview.SourceTagStyle()
-
-            # XXX The mask attribute controls whether the present values of
-            # foreground and background color should in fact be used. Ideally
-            # (and that's what gedit does), one could set all three attributes,
-            # and let the TagStyle object figure out which colors to use.
-            # However, in the GtkSourceview python bindings, the mask attribute
-            # is read-only, and it's derived instead from the colors being
-            # set or not. This means that we have to sometimes refrain from
-            # setting fg or bg colors, depending on the value of the mask.
-            # This code could go away if mask were writable.
-            mask = int(items[0][0])
-            if not (mask & 1): # GTK_SOURCE_TAG_STYLE_USE_BACKGROUND
-                items[2:3] = []
-            if not (mask & 2): # GTK_SOURCE_TAG_STYLE_USE_FOREGROUND
-                items[1:2] = []
-            items[0:1] = [] # skip the mask unconditionally
-
-            for value, attr, func in items:
-                try:
-                    value = func(value)
-                except ValueError:
-                    warning('gconf key %s contains an invalid value: %s'
-                            % gconf_key, value)
-                else:
-                    setattr(style, attr, value)
-
-            lang.set_tag_style(tag_id, style)
+        style_scheme_name = client.get_string(GEDIT_SCHEME_PATH)
+        if style_scheme_name is not None:
+            style_scheme_mgr = gtksourceview2.StyleSchemeManager()
+            style_scheme_mgr.append_search_path(GEDIT_USER_STYLES_PATH)
+            
+            style_scheme = style_scheme_mgr.get_scheme(style_scheme_name)
+            
+            if style_scheme is not None:
+                buf.set_style_scheme(style_scheme)
 
     @classmethod
-    def apply_colordiff_colors(klass, lang):
+    def apply_colordiff_colors(klass, buf):
         """Set style colors for lang using the colordiff configuration file.
 
         Both ~/.colordiffrc and ~/.colordiffrc.bzr-gtk are read.
 
-        :param lang: a "Diff" gtksourceview.SourceLanguage object.
+        :param buf: a "Diff" gtksourceview2.Buffer object.
         """
-        colors = {}
-
-        for f in ('~/.colordiffrc', '~/.colordiffrc.bzr-gtk'):
-            f = os.path.expanduser(f)
-            if os.path.exists(f):
-                try:
-                    f = file(f)
-                except IOError, e:
-                    warning('could not open file %s: %s' % (f, str(e)))
-                else:
-                    colors.update(klass.parse_colordiffrc(f))
-                    f.close()
-
-        if not colors:
-            # ~/.colordiffrc does not exist
-            return
-
-        mapping = {
-                # map GtkSourceView tags to colordiff names
+        scheme_manager = gtksourceview2.StyleSchemeManager()
+        style_scheme = scheme_manager.get_scheme('colordiff')
+        
+        # if style scheme not found, we'll generate it from colordiffrc
+        # TODO: reload if colordiffrc has changed.
+        if style_scheme is None:
+            colors = {}
+
+            for f in ('~/.colordiffrc', '~/.colordiffrc.bzr-gtk'):
+                f = os.path.expanduser(f)
+                if os.path.exists(f):
+                    try:
+                        f = file(f)
+                    except IOError, e:
+                        warning('could not open file %s: %s' % (f, str(e)))
+                    else:
+                        colors.update(klass.parse_colordiffrc(f))
+                        f.close()
+
+            if not colors:
+                # ~/.colordiffrc does not exist
+                return
+            
+            mapping = {
+                # map GtkSourceView2 scheme styles to colordiff names
                 # since GSV is richer, accept new names for extra bits,
                 # defaulting to old names if they're not present
-                'Added@32@line': ['newtext'],
-                'Removed@32@line': ['oldtext'],
-                'Location': ['location', 'diffstuff'],
-                'Diff@32@file': ['file', 'diffstuff'],
-                'Special@32@case': ['specialcase', 'diffstuff'],
-        }
-
-        for tag in lang.get_tags():
-            tag_id = tag.get_id()
-            keys = mapping.get(tag_id, [])
-            color = None
-
-            for key in keys:
-                color = colors.get(key, None)
-                if color is not None:
-                    break
-
-            if color is None:
-                continue
-
-            style = gtksourceview.SourceTagStyle()
-            try:
-                style.foreground = gtk.gdk.color_parse(color)
-            except ValueError:
-                warning('not a valid color: %s' % color)
-            else:
-                lang.set_tag_style(tag_id, style)
+                'diff:added-line': ['newtext'],
+                'diff:removed-line': ['oldtext'],
+                'diff:location': ['location', 'diffstuff'],
+                'diff:file': ['file', 'diffstuff'],
+                'diff:special-case': ['specialcase', 'diffstuff'],
+            }
+            
+            converted_colors = {}
+            for name, values in mapping.items():
+                color = None
+                for value in values:
+                    color = colors.get(value, None)
+                    if color is not None:
+                        break
+                if color is None:
+                    continue
+                converted_colors[name] = color
+            
+            # some xml magic to produce needed style scheme description
+            e_style_scheme = Element('style-scheme')
+            e_style_scheme.set('id', 'colordiff')
+            e_style_scheme.set('_name', 'ColorDiff')
+            e_style_scheme.set('version', '1.0')
+            for name, color in converted_colors.items():
+                style = SubElement(e_style_scheme, 'style')
+                style.set('name', name)
+                style.set('foreground', '#%s' % color)
+            
+            scheme_xml = tostring(e_style_scheme, 'UTF-8')
+            if not os.path.exists(os.path.expanduser('~/.local/share/gtksourceview-2.0/styles')):
+                os.makedirs(os.path.expanduser('~/.local/share/gtksourceview-2.0/styles'))
+            file(os.path.expanduser('~/.local/share/gtksourceview-2.0/styles/colordiff.xml'), 'w').write(scheme_xml)
+            
+            scheme_manager.force_rescan()
+            style_scheme = scheme_manager.get_scheme('colordiff')
+        
+        buf.set_style_scheme(style_scheme)
 
     @staticmethod
     def parse_colordiffrc(fileobj):
@@ -305,7 +293,7 @@
         scrollwin.set_shadow_type(gtk.SHADOW_IN)
         self.pack1(scrollwin)
         scrollwin.show()
-
+        
         self.model = gtk.TreeStore(str, str)
         self.treeview = gtk.TreeView(self.model)
         self.treeview.set_headers_visible(False)
@@ -330,9 +318,10 @@
         # text view
 
     def set_diff_text_sections(self, sections):
-        self.diff_view = DiffFileView()
+        if getattr(self, 'diff_view', None) is None:
+            self.diff_view = DiffFileView()
+            self.pack2(self.diff_view)
         self.diff_view.show()
-        self.pack2(self.diff_view)
         for oldname, newname, patch in sections:
             self.diff_view._diffs[newname] = str(patch)
             if newname is None:
@@ -346,8 +335,9 @@
         Compares the two trees and populates the window with the
         differences.
         """
-        self.diff_view = DiffView()
-        self.pack2(self.diff_view)
+        if getattr(self, 'diff_view', None) is None:
+            self.diff_view = DiffView()
+            self.pack2(self.diff_view)
         self.diff_view.show()
         self.diff_view.set_trees(rev_tree, parent_tree)
         self.rev_tree = rev_tree
@@ -380,6 +370,7 @@
                 self.model.append(titer, [ path, path ])
 
         self.treeview.expand_all()
+        self.diff_view.show_diff(None)
 
     def set_file(self, file_path):
         """Select the current file to display"""
@@ -390,7 +381,7 @@
                     tv_path = child.path
                     break
         if tv_path is None:
-            raise NoSuchFile(file_path)
+            raise errors.NoSuchFile(file_path)
         self.treeview.set_cursor(tv_path)
         self.treeview.scroll_to_cell(tv_path)
 
@@ -402,9 +393,15 @@
             return
         elif specific_files == [ "" ]:
             specific_files = None
-
+        
         self.diff_view.show_diff(specific_files)
-
+    
+    def _on_wraplines_toggled(self, widget=None, wrap=False):
+        """Callback for when the wrap lines checkbutton is toggled"""
+        if wrap or widget.get_active():
+            self.diff_view.sourceview.set_wrap_mode(gtk.WRAP_WORD)
+        else:
+            self.diff_view.sourceview.set_wrap_mode(gtk.WRAP_NONE)
 
 class DiffWindow(Window):
     """Diff window.
@@ -431,13 +428,33 @@
         self.vbox = gtk.VBox()
         self.add(self.vbox)
         self.vbox.show()
+        self.diff = DiffWidget()
+        self.vbox.pack_end(self.diff, True, True, 0)
+        self.diff.show_all()
+        # Build after DiffWidget to connect signals
+        menubar = self._get_menu_bar()
+        self.vbox.pack_start(menubar, False, False, 0)
         hbox = self._get_button_bar(operations)
         if hbox is not None:
-            self.vbox.pack_start(hbox, expand=False, fill=True)
-        self.diff = DiffWidget()
-        self.vbox.add(self.diff)
-        self.diff.show_all()
-
+            self.vbox.pack_start(hbox, False, True, 0)
+        
+    
+    def _get_menu_bar(self):
+        menubar = gtk.MenuBar()
+        # View menu
+        mb_view = gtk.MenuItem(_i18n("_View"))
+        mb_view_menu = gtk.Menu()
+        mb_view_wrapsource = gtk.CheckMenuItem(_i18n("Wrap _Long Lines"))
+        mb_view_wrapsource.connect('activate', self.diff._on_wraplines_toggled)
+        mb_view_wrapsource.show()
+        mb_view_menu.append(mb_view_wrapsource)
+        mb_view.show()
+        mb_view.set_submenu(mb_view_menu)
+        mb_view.show()
+        menubar.append(mb_view)
+        menubar.show()
+        return menubar
+    
     def _get_button_bar(self, operations):
         """Return a button bar to use.
 
@@ -513,9 +530,10 @@
 
 class DiffController(object):
 
-    def __init__(self, path, patch, window=None):
+    def __init__(self, path, patch, window=None, allow_dirty=False):
         self.path = path
         self.patch = patch
+        self.allow_dirty = allow_dirty
         if window is None:
             window = DiffWindow(operations=self._provide_operations())
             self.initialize_window(window)
@@ -527,7 +545,12 @@
 
     def get_diff_sections(self):
         yield "Complete Diff", None, ''.join(self.patch)
-        for patch in parse_patches(self.patch):
+        # allow_dirty was added to parse_patches in bzrlib 2.2b1
+        if 'allow_dirty' in inspect.getargspec(parse_patches).args:
+            patches = parse_patches(self.patch, allow_dirty=self.allow_dirty)
+        else:
+            patches = parse_patches(self.patch)
+        for patch in patches:
             oldname = patch.oldname.split('\t')[0]
             newname = patch.newname.split('\t')[0]
             yield oldname, newname, str(patch)
@@ -572,9 +595,10 @@
         tree.lock_write()
         try:
             try:
-                merger, verified = _mod_merge.Merger.from_mergeable(tree,
-                    self.directive, progress.DummyProgress())
-                merger.check_basis(True)
+                if tree.has_changes():
+                    raise errors.UncommittedChanges(tree)
+                merger, verified = _mod_merge.Merger.from_mergeable(
+                    tree, self.directive, pb=None)
                 merger.merge_type = _mod_merge.Merge3Merger
                 conflict_count = merger.do_merge()
                 merger.set_pending()
@@ -606,6 +630,7 @@
     renamed_and_modified = 'renamed and modified'
     modified = 'modified'
     kind_changed = 'kind changed'
+    missing = 'missing'
 
     # TODO: Handle metadata changes
 
@@ -626,9 +651,15 @@
                     source_marker = ''
                 else:
                     source_marker = osutils.kind_marker(kinds[0])
+
                 if kinds[1] is None:
-                    assert kinds[0] is not None
-                    marker = osutils.kind_marker(kinds[0])
+                    if kinds[0] is None:
+                        # We assume bzr will flag only files in that case,
+                        # there may be a bzr bug there as only files seems to
+                        # not receive any kind.
+                        marker = osutils.kind_marker('file')
+                    else:
+                        marker = osutils.kind_marker(kinds[0])
                 else:
                     marker = osutils.kind_marker(kinds[1])
 
@@ -636,17 +667,20 @@
                 if real_path is None:
                     real_path = paths[0]
                 assert real_path is not None
-                display_path = real_path + marker
 
                 present_source = versioned[0] and kinds[0] is not None
                 present_target = versioned[1] and kinds[1] is not None
 
-                if present_source != present_target:
+                if kinds[0] is None and kinds[1] is None:
+                    change_type = missing
+                    display_path = real_path + marker
+                elif present_source != present_target:
                     if present_target:
                         change_type = added
                     else:
                         assert present_source
                         change_type = removed
+                    display_path = real_path + marker
                 elif names[0] != names[1] or parent_ids[0] != parent_ids[1]:
                     # Renamed
                     if changed_content or executables[0] != executables[1]:
@@ -660,8 +694,9 @@
                     change_type = kind_changed
                     display_path = (paths[0] + source_marker
                                     + ' => ' + paths[1] + marker)
-                elif changed_content is True or executables[0] != executables[1]:
+                elif changed_content or executables[0] != executables[1]:
                     change_type = modified
+                    display_path = real_path + marker
                 else:
                     assert False, "How did we get here?"
 

=== modified file 'errors.py'
--- errors.py	2008-05-05 18:16:46 +0000
+++ errors.py	2011-02-18 13:01:03 +0000
@@ -16,7 +16,7 @@
 
 import bzrlib.errors as errors
 from bzrlib.plugins.gtk import _i18n
-from dialog import error_dialog
+from dialog import error_dialog, info_dialog
 
 
 def show_bzr_error(unbound):
@@ -33,6 +33,9 @@
         except errors.PointlessCommit:
             error_dialog(_i18n('No changes to commit'),
                          _i18n('Try force commit if you want to commit anyway.'))
+        except errors.PointlessMerge:
+            info_dialog(_i18n('No changes to merge'),
+                         _i18n('Merge location is already fully merged in working tree.'))
         except errors.ConflictsInTree:
             error_dialog(_i18n('Conflicts in tree'),
                          _i18n('You need to resolve the conflicts before committing.'))

=== removed file 'genpot.sh'
--- genpot.sh	2008-05-05 18:16:46 +0000
+++ genpot.sh	1970-01-01 00:00:00 +0000
@@ -1,43 +0,0 @@
-#!/bin/sh
-
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-# Generate translation template
-
-if [ "$1" = "" ]; then
-    POT=po/olive-gtk.pot
-else
-    # Used for debugging
-    POT=$1 
-fi
-
-XGETTEXT="xgettext -o $POT"
-PY_XGETTEXT="$XGETTEXT -L python --from-code=ASCII --keyword=_i18n"
-
-if [ -x $POT ]; then
-    rm $POT
-    touch $POT
-else
-    touch $POT
-fi
-$PY_XGETTEXT olive-gtk
-$XGETTEXT -j olive.glade
-
-for d in . annotate branchview olive preferences viz ;
-do
-   $PY_XGETTEXT -j $d/*.py
-done

=== added file 'icons/bzr-panel.svg'
--- icons/bzr-panel.svg	1970-01-01 00:00:00 +0000
+++ icons/bzr-panel.svg	2010-10-20 00:38:43 +0000
@@ -0,0 +1,123 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="125.3576"
+   height="127.96403"
+   id="svg2393"
+   sodipodi:version="0.32"
+   inkscape:version="0.46"
+   version="1.0"
+   sodipodi:docname="bzr-logo.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape">
+  <defs
+     id="defs2395">
+    <linearGradient
+       id="linearGradient5444">
+      <stop
+         id="stop5446"
+         offset="0"
+         style="stop-color:#729fcf;stop-opacity:1;" />
+      <stop
+         style="stop-color:#3465a4;stop-opacity:1;"
+         offset="0.5"
+         id="stop4547" />
+      <stop
+         id="stop5448"
+         offset="1"
+         style="stop-color:#204ab7;stop-opacity:1;" />
+    </linearGradient>
+    <linearGradient
+       inkscape:collect="always"
+       xlink:href="#linearGradient5444"
+       id="linearGradient2200"
+       x1="372.24512"
+       y1="69.037941"
+       x2="372.24512"
+       y2="0"
+       gradientUnits="userSpaceOnUse"
+       gradientTransform="matrix(1.027169,0,0,1,571.72345,145.71693)" />
+    <inkscape:perspective
+       sodipodi:type="inkscape:persp3d"
+       inkscape:vp_x="0 : 526.18109 : 1"
+       inkscape:vp_y="0 : 1000 : 0"
+       inkscape:vp_z="744.09448 : 526.18109 : 1"
+       inkscape:persp3d-origin="372.04724 : 350.78739 : 1"
+       id="perspective2401" />
+  </defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="0.35"
+     inkscape:cx="375"
+     inkscape:cy="520"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     showgrid="false"
+     inkscape:window-width="642"
+     inkscape:window-height="716"
+     inkscape:window-x="0"
+     inkscape:window-y="26" />
+  <metadata
+     id="metadata2398">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1"
+     transform="translate(-580.17834,-151.23731)">
+    <path
+       style="opacity:1;fill:url(#linearGradient2200);fill-opacity:1;stroke:none;stroke-width:2;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
+       d="M 588.19225,214.74818 L 703.94225,214.74818 C 703.0194,210.71454 649.52368,155.39489 646.56725,155.46693 C 644.54816,155.51613 591.83132,209.09818 588.19225,214.74818 z"
+       id="rect1307"
+       inkscape:export-filename="/home/matt/BZR Header.png"
+       inkscape:export-xdpi="96"
+       inkscape:export-ydpi="96" />
+    <g
+       style="opacity:1;display:inline"
+       id="g3653"
+       transform="translate(754.85055,325.08453)"
+       inkscape:export-filename="/home/matt/Projects/Ubuntu/Bazaar Website/bzr icon 64.png"
+       inkscape:export-xdpi="45.012665"
+       inkscape:export-ydpi="45.012665">
+      <path
+         id="path2749"
+         d="M -143.51431,-75.4275 C -158.48768,-90.57687 -171.17625,-103.66019 -171.7111,-104.50153 C -174.63909,-109.10738 -172.34363,-112.16647 -143.7155,-141.81059 C -119.96256,-166.4065 -114.08422,-171.84722 -111.26302,-171.84722 C -108.45655,-171.84722 -102.57922,-166.49332 -79.566158,-142.97326 C -59.704508,-122.67403 -51.314608,-113.24681 -51.314608,-111.22876 C -51.314608,-107.03298 -109.21126,-47.88319 -113.31814,-47.88319 C -115.49463,-47.88319 -123.57621,-55.25503 -143.51431,-75.4275 z"
+         style="opacity:1;fill:#fce94f;fill-opacity:1;stroke:#fce94f;stroke-width:4;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline" />
+      <path
+         id="path2721"
+         d="M -118.75152,-74.850683 C -119.22012,-75.319283 -119.60352,-85.958443 -119.60352,-98.493313 L -119.60352,-121.28395 L -124.85215,-121.28395 C -131.2088,-121.28395 -131.22918,-121.19503 -121.27316,-136.90004 C -116.77235,-143.99978 -113.38241,-148.09169 -112.19584,-147.85705 C -110.34853,-147.49175 -95.321883,-124.90849 -95.321883,-122.4975 C -95.321883,-121.83004 -97.640303,-121.28395 -100.47393,-121.28395 C -103.84689,-121.28395 -105.87693,-120.6299 -106.35276,-119.38989 C -107.55959,-116.24495 -103.45251,-106.32746 -97.296233,-97.520823 C -90.988133,-88.497013 -90.461803,-86.665103 -93.461883,-84.175253 C -95.128693,-82.791933 -96.185063,-83.268713 -100.25177,-87.239733 C -102.90055,-89.826193 -105.46285,-91.547323 -105.94572,-91.064423 C -106.42862,-90.581523 -106.8237,-86.544203 -106.8237,-82.092573 L -106.8237,-73.998703 L -112.36162,-73.998703 C -115.40746,-73.998703 -118.28294,-74.382103 -118.75152,-74.850683 z"
+         style="opacity:1;fill:#c4a000;fill-opacity:1;stroke:#c4a000;display:inline" />
+      <path
+         id="path2727"
+         d="M -120.75152,-76.85072 C -121.22012,-77.31932 -121.60352,-87.95848 -121.60352,-100.49335 L -121.60352,-123.28399 L -126.85215,-123.28399 C -133.2088,-123.28399 -133.22918,-123.19507 -123.27316,-138.90007 C -118.77235,-145.99981 -115.38241,-150.09172 -114.19584,-149.85708 C -112.34853,-149.49178 -97.321888,-126.90852 -97.321888,-124.49754 C -97.321888,-123.83008 -99.640308,-123.28399 -102.47393,-123.28399 C -105.84689,-123.28399 -107.87693,-122.62994 -108.35276,-121.38993 C -109.55959,-118.24499 -105.45251,-108.3275 -99.296238,-99.52086 C -92.988138,-90.49705 -92.461808,-88.66514 -95.461888,-86.17529 C -97.128698,-84.79197 -98.185068,-85.26875 -102.25177,-89.23977 C -104.90055,-91.82623 -107.46285,-93.54736 -107.94572,-93.06446 C -108.42862,-92.58156 -108.8237,-88.54424 -108.8237,-84.09261 L -108.8237,-75.99874 L -114.36162,-75.99874 C -117.40746,-75.99874 -120.28294,-76.38214 -120.75152,-76.85072 z"
+         style="opacity:1;fill:#555753;fill-opacity:1;stroke:#2e3436;stroke-opacity:1;display:inline" />
+      <path
+         d="M -143.51431,-75.4275 C -158.48768,-90.57687 -171.17625,-103.66019 -171.7111,-104.50153 C -174.63909,-109.10738 -172.34363,-112.16647 -143.7155,-141.81059 C -119.96256,-166.4065 -114.08422,-171.84722 -111.26302,-171.84722 C -108.45655,-171.84722 -102.57922,-166.49332 -79.566162,-142.97326 C -59.704512,-122.67403 -51.314612,-113.24681 -51.314612,-111.22876 C -51.314612,-107.03298 -109.21126,-47.88319 -113.31814,-47.88319 C -115.49463,-47.88319 -123.57621,-55.25503 -143.51431,-75.4275 z M -82.734602,-78.80831 C -63.284082,-98.78654 -53.870592,-109.3496 -53.870592,-111.19708 C -53.870592,-114.35673 -108.28764,-170.68595 -111.26979,-170.61328 C -113.31427,-170.56346 -167.39892,-115.6112 -169.81635,-111.12752 C -171.82156,-107.40842 -170.53236,-105.76188 -145.24612,-79.74648 C -117.66227,-51.36719 -115.36413,-49.16116 -113.38369,-49.16116 C -112.40192,-49.16116 -98.609822,-62.50237 -82.734602,-78.80831 z"
+         style="opacity:1;fill:#555753;fill-opacity:1;stroke:#2e3436;stroke-width:2;stroke-miterlimit:4;stroke-dasharray:none;stroke-opacity:1;display:inline"
+         id="path2736" />
+    </g>
+  </g>
+</svg>

=== added file 'icons/emblem-bzr-ignored.svg'
--- icons/emblem-bzr-ignored.svg	1970-01-01 00:00:00 +0000
+++ icons/emblem-bzr-ignored.svg	2009-08-24 05:45:14 +0000
@@ -0,0 +1,175 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:xlink="http://www.w3.org/1999/xlink"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   width="47.999989"
+   height="48.000156"
+   id="svg2"
+   sodipodi:version="0.32"
+   inkscape:version="0.46"
+   sodipodi:docname="emblem-bzr-ignored.svg"
+   inkscape:output_extension="org.inkscape.output.svg.inkscape"
+   version="1.0">
+  <defs
+     id="defs4"><inkscape:perspective
+   sodipodi:type="inkscape:persp3d"
+   inkscape:vp_x="0 : 526.18109 : 1"
+   inkscape:vp_y="0 : 1000 : 0"
+   inkscape:vp_z="744.09448 : 526.18109 : 1"
+   inkscape:persp3d-origin="372.04724 : 350.78739 : 1"
+   id="perspective10" />
+<inkscape:perspective
+   id="perspective2810"
+   inkscape:persp3d-origin="24 : 16 : 1"
+   inkscape:vp_z="48 : 24 : 1"
+   inkscape:vp_y="0 : 1000 : 0"
+   inkscape:vp_x="0 : 24 : 1"
+   sodipodi:type="inkscape:persp3d" />
+
+	
+
+		
+	<linearGradient
+   inkscape:collect="always"
+   xlink:href="#path2394_1_"
+   id="linearGradient2854"
+   gradientUnits="userSpaceOnUse"
+   gradientTransform="matrix(3.3933,0,0,-3.4122,218.9189,318.1022)"
+   x1="-61.669102"
+   y1="89.502403"
+   x2="-66.316704"
+   y2="102.8654" />
+
+			
+			
+				
+			
+				
+			
+				
+			
+			
+		</defs>
+  <sodipodi:namedview
+     id="base"
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1.0"
+     gridtolerance="10000"
+     guidetolerance="10"
+     objecttolerance="10"
+     inkscape:pageopacity="0.0"
+     inkscape:pageshadow="2"
+     inkscape:zoom="11.2"
+     inkscape:cx="26.312796"
+     inkscape:cy="20.859372"
+     inkscape:document-units="px"
+     inkscape:current-layer="layer1"
+     showgrid="false"
+     inkscape:window-width="1440"
+     inkscape:window-height="815"
+     inkscape:window-x="0"
+     inkscape:window-y="33" />
+  <metadata
+     id="metadata7">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+      </cc:Work>
+    </rdf:RDF>
+  </metadata>
+  <g
+     inkscape:label="Layer 1"
+     inkscape:groupmode="layer"
+     id="layer1"
+     transform="translate(-402.78946,-590.46098)">
+    <g
+       id="g3730">
+      <path
+         d="M 450.78945,614.57487 C 450.78945,627.76661 440.04465,638.46113 426.78945,638.46113 C 413.53426,638.46113 402.78946,627.76661 402.78946,614.57487 C 402.78946,601.38313 413.53426,590.68861 426.78945,590.68861 C 440.04465,590.68861 450.78945,601.38313 450.78945,614.57487 L 450.78945,614.57487 z"
+         id="path1880"
+         style="fill:#cecece;fill-opacity:1" />
+      <path
+         d="M 410.65906,604.57402 L 442.70145,604.38984 L 426.84705,631.00774 L 410.65906,604.57402 z"
+         randomized="0"
+         rounded="-5.8980598e-17"
+         flatsided="true"
+         arg2="2.3170736"
+         arg1="1.2698761"
+         r2="1.1936886"
+         r1="2.387377"
+         cy="4.4422603"
+         cx="5.0319409"
+         sides="3"
+         type="star"
+         id="path1876"
+         style="fill:#ffffff;stroke:#ffffff;stroke-width:0.62367463;stroke-linecap:round;stroke-linejoin:round" />
+      <a
+         transform="matrix(0.8635686,0,0,-0.8635686,58.384145,1148.9732)"
+         id="a3656">
+        <rect
+           style="fill:#cecece;fill-opacity:1;stroke:#cecece;stroke-width:0.81032175;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1"
+           id="rect1878"
+           x="424.77585"
+           y="605.72937"
+           width="3.9887989"
+           height="11.656094" />
+      </a>
+      <rect
+         transform="scale(1,-1)"
+         height="2.9972355"
+         width="4.0166292"
+         y="-612.50317"
+         x="424.97717"
+         id="rect1880"
+         style="fill:#cecece;fill-opacity:1;stroke:#cecece;stroke-width:0.41237092;stroke-linecap:round;stroke-linejoin:round;stroke-opacity:1" />
+      <polygon
+         transform="matrix(2.3999994,0,0,2.3919749,400.38946,588.22966)"
+         points="5.148,9.137 12.528,7.054 13.806,11.666 6.427,13.749 5.148,9.137 "
+         id="rect2942"
+         style="fill:none" />
+      <g
+         label="Layer 1"
+         transform="matrix(3.3932944,0,0,3.4122168,400.02647,587.51282)"
+         id="g1972">
+				
+					<linearGradient
+   gradientTransform="matrix(3.3933,0,0,-3.4122,218.9189,318.1022)"
+   y2="102.8654"
+   x2="-66.316704"
+   y1="89.502403"
+   x1="-61.669102"
+   gradientUnits="userSpaceOnUse"
+   id="path2394_1_">
+					<stop
+   id="stop2800"
+   style="stop-color:#EEEEEC"
+   offset="0" />
+
+					<stop
+   id="stop2802"
+   style="stop-color:#EEEEEC"
+   offset="1" />
+
+				</linearGradient>
+
+				<path
+   d="M 7.943,0.864 C 4.039,0.864 0.849,4 0.849,7.864 C 0.849,8.086 0.863,8.408 0.884,8.624 C 1.34,8.366 1.738,8.039 2.268,7.809 C 3.793,7.148 5.583,6.483 7.599,6.114 C 9.614,5.745 11.805,5.551 14.13,5.551 C 14.274,5.551 14.393,5.581 14.536,5.582 C 13.571,2.854 11.028,0.864 7.943,0.864 z"
+   nodetypes="cscssscc"
+   id="path2394"
+   style="fill:url(#linearGradient2854)" />
+
+			</g>
+    </g>
+  </g>
+</svg>

=== added file 'info.py'
--- info.py	1970-01-01 00:00:00 +0000
+++ info.py	2011-03-02 15:24:46 +0000
@@ -0,0 +1,32 @@
+#!/usr/bin/env python
+# API Info for bzr-gtk
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+bzr_plugin_name = "gtk"
+
+# versions ending in 'exp' mean experimental mappings
+# versions ending in 'dev' mean development version
+# versions ending in 'final' mean release (well tested, etc)
+bzr_plugin_version = (0, 101, 0, 'dev', 0)
+
+#FIXME: fill this in automatically somehow
+bzr_commands = []
+
+bzr_compatible_versions = [(2, 1, 0), (2, 2, 0), (2, 3, 0), (2, 4, 0)]
+
+bzr_minimum_version = bzr_compatible_versions[0]
+
+bzr_maximum_version = bzr_compatible_versions[-1]

=== added file 'keyring.py'
--- keyring.py	1970-01-01 00:00:00 +0000
+++ keyring.py	2010-06-04 12:12:59 +0000
@@ -0,0 +1,86 @@
+# Copyright (C) 2009 Jelmer Vernooij <jelmer@samba.org>
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import gobject
+try:
+    import gnomekeyring
+except ImportError:
+    gnomekeyring = None
+
+from bzrlib.config import (
+    CredentialStore,
+    )
+
+
+class GnomeKeyringCredentialStore(CredentialStore):
+
+    def __init__(self):
+        CredentialStore.__init__(self)
+        # Older versions of gobject don't provide get_application_name so we
+        # can't always check.
+        get_app_name = getattr(gobject, 'get_application_name', None)
+        if get_app_name is None or get_app_name() is None:
+            # External applications that load bzrlib may already have set the
+            # application name so we don't contradict them (when we can
+            # determine it that is).
+            gobject.set_application_name("bzr")
+
+    def decode_password(self, credentials):
+        if gnomekeyring is None:
+            return None
+        attrs = {}
+        if "scheme" in credentials:
+            attrs["protocol"] = credentials["scheme"].encode("utf-8")
+        if "host" in credentials:
+            attrs["server"] = credentials["host"].encode("utf-8")
+        if "user" in credentials:
+            attrs["user"] = credentials["user"].encode("utf-8")
+        if credentials.get("port") is not None:
+            attrs["port"] = credentials["port"]
+        try:
+            items = gnomekeyring.find_items_sync(
+                gnomekeyring.ITEM_NETWORK_PASSWORD, attrs)
+            return items[0].secret
+        except (gnomekeyring.NoMatchError, gnomekeyring.DeniedError):
+            return None
+
+    def get_credentials(self, scheme, host, port=None, user=None, path=None, 
+                        realm=None):
+        if gnomekeyring is None:
+            return None
+        attrs = {
+            "protocol": scheme.encode("utf-8"),
+            "server": host.encode("utf-8"),
+            }
+        # TODO: realm ?
+        if port is not None:
+            attrs["port"] = port
+        if user is not None:
+            attrs["user"] = user.encode("utf-8")
+        credentials = { "scheme": scheme, "host": host, "port": port, 
+            "realm": realm, "user": user}
+        try:
+            items = gnomekeyring.find_items_sync(
+                gnomekeyring.ITEM_NETWORK_PASSWORD, attrs)
+            credentials["user"] = items[0].attributes["user"]
+            credentials["password"] = items[0].secret
+            return credentials
+        except (gnomekeyring.NoMatchError, gnomekeyring.DeniedError, gnomekeyring.NoKeyringDaemonError,
+                gnomekeyring.IOError), e:
+            from bzrlib import trace
+            trace.mutter('Unable to obtain credentials for %r from GNOME keyring: %r',
+                         attrs, e)
+            return None

=== added file 'lock.py'
--- lock.py	1970-01-01 00:00:00 +0000
+++ lock.py	2011-02-18 11:53:18 +0000
@@ -0,0 +1,62 @@
+
+import gtk
+
+
+RESPONSE_BREAK = 0
+RESPONSE_CANCEL = gtk.RESPONSE_CANCEL
+
+READ = "read"
+WRITE = "write"
+
+
+def acquire(branch, lock_type):
+    if branch.get_physical_lock_status():
+        dialog = LockDialog(branch)
+        response = dialog.run()
+        dialog.destroy()
+
+        if response == RESPONSE_BREAK:
+            branch.break_lock()
+        else:
+            return False
+
+    if lock_type == READ:
+        branch.lock_read()
+    elif lock_type == WRITE:
+        branch.lock_write()
+
+    return True
+
+
+def release(branch):
+    if branch.get_physical_lock_status():
+        dialog = LockDialog(branch)
+        response = dialog.run()
+        dialog.destroy()
+
+        if response == RESPONSE_BREAK:
+            branch.break_lock()
+        elif response == RESPONSE_CANCEL:
+            return False
+
+    branch.unlock()
+
+    return True
+
+
+class LockDialog(gtk.Dialog):
+
+    def __init__(self, branch):
+        gtk.Dialog.__init__(self)
+
+        self.branch = branch
+
+        self.set_title('Lock Not Held')
+
+        self.vbox.add(gtk.Label('This operation cannot be completed as ' \
+                                'another application has locked the branch.'))
+
+        self.add_button('Break Lock', RESPONSE_BREAK)
+        self.add_button(gtk.STOCK_CANCEL, RESPONSE_CANCEL)
+
+        self.vbox.show_all()

=== added file 'loom.py'
--- loom.py	1970-01-01 00:00:00 +0000
+++ loom.py	2008-07-31 01:55:07 +0000
@@ -0,0 +1,122 @@
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
+import gtk
+import gobject
+
+from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk.diff import DiffWidget
+from bzrlib.plugins.gtk.dialog import question_dialog
+from bzrlib.plugins.loom import branch as loom_branch
+from bzrlib.plugins.loom import tree as loom_tree
+
+class LoomDialog(gtk.Dialog):
+    """Simple Loom browse dialog."""
+
+    def __init__(self, branch, tree=None, parent=None):
+        gtk.Dialog.__init__(self, title="Threads",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CLOSE,gtk.RESPONSE_OK))
+        self.branch = branch
+        if tree is not None:
+            self.tree = loom_tree.LoomTreeDecorator(tree)
+        else:
+            self.tree = None
+
+        self._construct()
+
+    def run(self):
+        try:
+            loom_branch.require_loom_branch(self.branch)
+        except loom_branch.NotALoom:
+            response = question_dialog(
+                _i18n("Upgrade to Loom branch?"),
+                _i18n("Branch is not a loom branch. Upgrade to Loom format?"),
+                parent=self)
+                # Doesn't set a parent for the dialog..
+            if response == gtk.RESPONSE_NO:
+                return
+            assert self.branch.nick is not None
+            loom_branch.loomify(self.branch)
+        self._load_threads()
+        return super(LoomDialog, self).run()
+
+    def _construct(self):
+        hbox = gtk.HBox()
+
+        self._threads_scroller = gtk.ScrolledWindow()
+        self._threads_scroller.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        self._threads_view = gtk.TreeView()
+        self._threads_scroller.add(self._threads_view)
+        self._threads_scroller.set_shadow_type(gtk.SHADOW_IN)
+        hbox.pack_start(self._threads_scroller)
+
+        self._threads_store = gtk.ListStore(
+                gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT, gobject.TYPE_STRING)
+        self._threads_view.set_model(self._threads_store)
+        self._threads_view.append_column(gtk.TreeViewColumn("Name", gtk.CellRendererText(), text=0))
+        self._threads_view.connect('cursor-changed', self._on_view_thread)
+        if self.tree is not None:
+            self._threads_view.connect('row-activated', self._on_switch_thread)
+
+        self._diff = DiffWidget()
+        self._diff.show()
+        hbox.pack_end(self._diff)
+
+        hbox.show_all()
+        self.vbox.pack_start(hbox)
+
+        # FIXME: Buttons: combine-thread, revert-loom, record
+        self.set_default_size(500, 350)
+
+    def _on_view_thread(self, treeview):
+        treeselection = treeview.get_selection()
+        (model, selection) = treeselection.get_selected()
+        if selection is None:
+            return
+        revid, parent_revid = model.get(selection, 1, 3)
+        if parent_revid is None:
+            return
+        self.branch.lock_read()
+        try:
+            (rev_tree, parent_tree) = tuple(self.branch.repository.revision_trees([revid, parent_revid]))
+            self._diff.set_diff(rev_tree, parent_tree)
+        finally:
+            self.branch.unlock()
+
+    def _on_switch_thread(self, treeview, path, view_column):
+        new_thread = self._threads_store.get_value(self._threads_store.get_iter(path), 0)
+        self.tree.down_thread(new_thread)
+
+    def _load_threads(self):
+        self._threads_store.clear()
+        
+        self.branch.lock_read()
+        try:
+            threads = self.branch.get_loom_state().get_threads()
+            last_revid = None
+            for name, revid, parent_ids in reversed(threads):
+                self._threads_store.append([name, revid, parent_ids, last_revid])
+                last_revid = revid
+        finally:
+            self.branch.unlock()

=== modified file 'merge.py'
--- merge.py	2008-05-05 18:16:46 +0000
+++ merge.py	2008-07-27 11:37:31 +0000
@@ -23,48 +23,111 @@
     pass
 
 import gtk
-import gtk.glade
 
 from bzrlib.branch import Branch
 import bzrlib.errors as errors
-from bzrlib.plugins.gtk import _i18n
-
-from dialog import error_dialog, info_dialog, warning_dialog
-from errors import show_bzr_error
-from olive.guifiles import GLADEFILENAME
-
-
-class MergeDialog:
+
+from bzrlib.plugins.gtk import _i18n, icon_path
+from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, warning_dialog
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class MergeDialog(gtk.Dialog):
     """ Display the Merge dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath,default_branch_path=None):
+    
+    def __init__(self, wt, wtpath, default_branch_path=None, parent=None):
         """ Initialize the Merge dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_merge', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_merge')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_merge_merge_clicked": self.merge,
-                "on_button_merge_cancel_clicked": self.close,
-                "on_button_merge_open_clicked": self.open }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-
+        gtk.Dialog.__init__(self, title="Merge changes",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        self.set_icon_from_file(icon_path("bzr-icon-64.png"))
+        # Get arguments
         self.wt = wt
         self.wtpath = wtpath
-        
-        # Get some widgets
-        self.entry = self.glade.get_widget('entry_merge')
-        if default_branch_path:
-            self.entry.set_text(default_branch_path)
-
-    def display(self):
-        """ Display the Add file(s) dialog. """
-        self.window.show_all()
-
+        self.default_branch_path = default_branch_path
+        self.parent_window = parent
+        
+        # Create widgets
+        self._hbox = gtk.HBox()
+        self._source = gtk.HBox()
+        self._label_merge_from = gtk.Label(_i18n("Merge from"))
+        self._combo_source = gtk.combo_box_new_text()
+        for entry in [_i18n("Folder"),_i18n("Custom Location")]:
+            self._combo_source.append_text(entry)
+        self._combo_source.connect("changed", self._on_combo_changed)
+        self._button_merge = gtk.Button(_i18n("_Merge"))
+        self._button_merge_icon = gtk.Image()
+        self._button_merge_icon.set_from_stock(gtk.STOCK_APPLY, gtk.ICON_SIZE_BUTTON)
+        self._button_merge.set_image(self._button_merge_icon)
+        self._button_merge.connect('clicked', self._on_merge_clicked)
+        
+        # Add widgets to dialog
+        self.vbox.pack_start(self._hbox, False, False, 0)
+        self._hbox.add(self._label_merge_from)
+        self._hbox.add(self._combo_source)
+        self._hbox.set_spacing(5)
+        self.action_area.pack_end(self._button_merge)
+        
+        if self.default_branch_path and os.path.isdir(
+                            self.default_branch_path.partition('file://')[2]):
+            self.directory = self.default_branch_path.partition('file://')[2]
+            self._combo_source.set_active(0)
+        elif self.default_branch_path:
+            self._combo_source.set_active(1)
+        else:
+            # If no default_branch_path give, default to folder source with current folder
+            self._combo_source.set_active(0)
+        self.vbox.show_all()
+    
+    def _on_folder_source(self):
+        """ Merge from folder, create a filechooser dialog and button """
+        self._source = gtk.HBox()
+        self._filechooser_dialog = gtk.FileChooserDialog(title="Please select a folder",
+                                    parent=self.parent_window,
+                                    action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
+                                    buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
+                                             gtk.STOCK_OPEN, gtk.RESPONSE_OK))
+        self._filechooser_dialog.set_default_response(gtk.RESPONSE_OK)
+        self._filechooser = gtk.FileChooserButton(self._filechooser_dialog)
+        self._filechooser.show()
+        directory = getattr(self, 'directory', None)
+        if not directory:
+            directory = os.path.dirname(self.wt.abspath(self.wtpath))
+        self._filechooser_dialog.set_current_folder(directory)
+        self._source.pack_start(self._filechooser, True, True, 0)
+        self.vbox.pack_start(self._source, True, True, 5)
+        self._source.show()
+    
+    def _on_custom_source(self):
+        """ Merge from a custom source (can be folder, remote, etc), create entry """
+        self._source = gtk.HBox()
+        self._custom_entry = gtk.Entry()
+        if self.default_branch_path:
+            self._custom_entry.set_text(self.default_branch_path)
+        self._custom_entry.connect("activate", self._on_merge_clicked)
+        self._custom_entry.show()
+        self._source.pack_start(self._custom_entry, True, True, 0)
+        self.vbox.pack_start(self._source, True, True, 5)
+        self._source.show()
+    
+    def _on_combo_changed(self, widget):
+        merge_source = self._combo_source.get_active()
+        self._source.destroy()
+        if merge_source == 0:
+            # Merge from folder
+            self._on_folder_source()
+        elif merge_source == 1:
+            # Merge from custom
+            self._on_custom_source()
+    
     @show_bzr_error
-    def merge(self, widget):
-        branch = self.entry.get_text()
+    def _on_merge_clicked(self, widget):
+        merge_source = self._combo_source.get_active()
+        if merge_source == 0:
+            branch = self._filechooser.get_filename()
+        elif merge_source == 1:
+            branch = self._custom_entry.get_text()
         if branch == "":
             error_dialog(_i18n('Branch not given'),
                          _i18n('Please specify a branch to merge from.'))
@@ -78,7 +141,6 @@
             error_dialog(_i18n('Bazaar command error'), str(errmsg))
             return
         
-        self.close()
         if conflicts == 0:
             # No conflicts found.
             info_dialog(_i18n('Merge successful'),
@@ -87,19 +149,5 @@
             # There are conflicts to be resolved.
             warning_dialog(_i18n('Conflicts encountered'),
                            _i18n('Please resolve the conflicts manually before committing.'))
-    
-    def open(self, widget):
-        fcd = gtk.FileChooserDialog(title="Please select a folder",
-                                    parent=self.window,
-                                    action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
-                                    buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
-                                             gtk.STOCK_OPEN, gtk.RESPONSE_OK))
-        fcd.set_default_response(gtk.RESPONSE_OK)
-        
-        if fcd.run() == gtk.RESPONSE_OK:
-            self.entry.set_text(fcd.get_filename())
-        
-        fcd.destroy()
-        
-    def close(self, widget=None):
-        self.window.destroy()
+        
+        self.response(gtk.RESPONSE_OK)

=== modified file 'mergedirective.py'
--- mergedirective.py	2008-03-14 02:19:21 +0000
+++ mergedirective.py	2011-02-18 13:01:03 +0000
@@ -22,7 +22,6 @@
 
 import bzrlib
 import gtk
-import os
 
 from bzrlib.plugins.gtk.branchbox import BranchSelectionBox
 

=== modified file 'missing.py'
--- missing.py	2007-12-06 23:37:06 +0000
+++ missing.py	2011-02-18 13:01:03 +0000
@@ -22,10 +22,10 @@
 
 import gtk
 
-from bzrlib.config import GlobalConfig
 from bzrlib.missing import find_unmerged
 
-from revisionview import RevisionView
+from bzrlib.plugins.gtk.revisionview import RevisionView
+
 
 class MissingWindow(gtk.Dialog):
     """Displays revisions present in one branch but missing in 

=== modified file 'nautilus-bzr.py'
--- nautilus-bzr.py	2008-05-05 18:16:46 +0000
+++ nautilus-bzr.py	2011-02-18 13:01:03 +0000
@@ -12,14 +12,16 @@
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
 from bzrlib.errors import NotBranchError, NoWorkingTree, UnsupportedProtocol
-from bzrlib.tree import file_status
 from bzrlib.workingtree import WorkingTree
 from bzrlib.config import GlobalConfig
 
 from bzrlib.plugin import load_plugins
 load_plugins()
 
-from bzrlib.plugins.gtk import _i18n, cmd_visualise, cmd_gannotate
+from bzrlib.plugins.gtk.commands import cmd_gannotate, start_viz_window
+
+print "Bazaar nautilus module initialized"
+
 
 class BzrExtension(nautilus.MenuProvider, nautilus.ColumnProvider, nautilus.InfoProvider):
     def __init__(self):
@@ -83,7 +85,8 @@
 
         from bzrlib.plugins.gtk.diff import DiffWindow
         window = DiffWindow()
-        window.set_diff(tree.branch.nick, tree, tree.branch.basis_tree())
+        window.set_diff(tree.branch._get_nick(local=True), tree, 
+                        tree.branch.basis_tree())
         window.show()
 
         return
@@ -174,14 +177,13 @@
 
         # We only want to continue here if we get a NotBranchError
         try:
-            tree, path = WorkingTree.open_containing(file)
+            branch, path = Branch.open_containing(file)
         except NotBranchError:
             return
 
-        vis = cmd_visualise()
-        vis.run(file)
-
-        return
+        pp = start_viz_window(branch, [branch.last_revision()])
+        pp.show()
+        gtk.main()
 
     def pull_cb(self, menu, vfs_file):
         # We can only cope with local files
@@ -216,8 +218,8 @@
 
         from bzrlib.plugins.gtk.merge import MergeDialog
         dialog = MergeDialog(tree, path)
-        dialog.display()
-        gtk.main()
+        dialog.run()
+        dialog.destroy()
 
     def get_background_items(self, window, vfs_file):
         items = []
@@ -237,7 +239,7 @@
             items.append(item)
 
             item = nautilus.MenuItem('BzrNautilus::clone',
-                                 'Checkout Bazaar branch',
+                                 'Checkout Bazaar branch ...',
                                  'Checkout Existing Bazaar Branch')
             item.connect('activate', self.clone_cb, vfs_file)
             items.append(item)
@@ -254,31 +256,31 @@
             return item,
         else:
             item = nautilus.MenuItem('BzrNautilus::disable',
-                                      'Disable Bazaar Plugin for the Branch',
+                                      'Disable Bazaar Plugin this Branch',
                                       'Disable Bazaar plugin for nautilus')
             item.connect('activate', self.toggle_integration, 'False', vfs_file)
             items.append(item)
 
         item = nautilus.MenuItem('BzrNautilus::log',
-                             'Log',
+                             'History ...',
                              'Show Bazaar history')
         item.connect('activate', self.log_cb, vfs_file)
         items.append(item)
 
         item = nautilus.MenuItem('BzrNautilus::pull',
-                             'Pull',
+                             'Pull ...',
                              'Pull from another branch')
         item.connect('activate', self.pull_cb, vfs_file)
         items.append(item)
 
         item = nautilus.MenuItem('BzrNautilus::merge',
-                             'Merge',
+                             'Merge ...',
                              'Merge from another branch')
         item.connect('activate', self.merge_cb, vfs_file)
         items.append(item)
 
         item = nautilus.MenuItem('BzrNautilus::commit',
-                             'Commit',
+                             'Commit ...',
                              'Commit Changes')
         item.connect('activate', self.commit_cb, vfs_file)
         items.append(item)
@@ -341,13 +343,13 @@
                 items.append(item)
             elif wtfiles[path] == 'V':
                 item = nautilus.MenuItem('BzrNautilus::log',
-                                 'Log',
+                                 'History ...',
                                  'List changes')
                 item.connect('activate', self.log_cb, vfs_file)
                 items.append(item)
 
                 item = nautilus.MenuItem('BzrNautilus::diff',
-                                 'Diff',
+                                 'View Changes ...',
                                  'Show differences')
                 item.connect('activate', self.diff_cb, vfs_file)
                 items.append(item)
@@ -359,13 +361,13 @@
                 items.append(item)
 
                 item = nautilus.MenuItem('BzrNautilus::annotate',
-                             'Annotate',
+                             'Annotate ...',
                              'Annotate File Data')
                 item.connect('activate', self.annotate_cb, vfs_file)
                 items.append(item)
 
                 item = nautilus.MenuItem('BzrNautilus::commit',
-                             'Commit',
+                             'Commit ...',
                              'Commit Changes')
                 item.connect('activate', self.commit_cb, vfs_file)
                 items.append(item)
@@ -397,10 +399,17 @@
         emblem = None
         status = None
 
-        if tree.has_filename(path):
+        id = tree.path2id(path)
+        if id == None:
+            if tree.is_ignored(path):
+                status = 'ignored'
+                emblem = 'bzr-ignored'
+            else:
+                status = 'unversioned'
+                        
+        elif tree.has_filename(path):
             emblem = 'bzr-controlled'
             status = 'unchanged'
-            id = tree.path2id(path)
 
             delta = tree.changes_from(tree.branch.basis_tree())
             if delta.touches_file_id(id):

=== modified file 'notify.py'
--- notify.py	2007-07-15 15:13:34 +0000
+++ notify.py	2011-02-18 13:01:03 +0000
@@ -16,34 +16,56 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 """Notification area icon and notification for Bazaar."""
 
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
 import gtk
+import bzrlib
+
+
+def has_dbus():
+    return (getattr(bzrlib.plugins, "dbus", None) is not None)
+
+
+def has_avahi():
+    return (getattr(bzrlib.plugins, "avahi", None) is not None)
+
 
 class NotifyPopupMenu(gtk.Menu):
+
     def __init__(self):
         super(NotifyPopupMenu, self).__init__()
         self.create_items()
 
     def create_items(self):
+        from bzrlib import errors
+        item = gtk.CheckMenuItem('_Gateway to LAN')
+        item.connect('toggled', self.toggle_lan_gateway)
+        self.append(item)
+        self.append(gtk.SeparatorMenuItem())
         try:
             from bzrlib.plugins.dbus.activity import LanGateway
             self.langateway = LanGateway()
-            item = gtk.CheckMenuItem('_Gateway to LAN')
-            item.connect('toggled', self.toggle_lan_gateway)
-            self.append(item)
-            self.append(gtk.SeparatorMenuItem())
         except ImportError:
-            pass
+            item.set_sensitive(False)
+        except errors.BzrError:
+            # FIXME: Should only catch errors that indicate a lan-notify 
+            # process is already running.
+            item.set_sensitive(False)
 
+        item = gtk.CheckMenuItem('Announce _branches on LAN')
+        item.connect('toggled', self.toggle_announce_branches)
+        self.append(item)
+        self.append(gtk.SeparatorMenuItem())
         try:
             from bzrlib.plugins.avahi.share import ZeroConfServer
             from bzrlib import urlutils
             self.zeroconfserver = ZeroConfServer(urlutils.normalize_url('.'))
-            item = gtk.CheckMenuItem('Announce _branches on LAN')
-            item.connect('toggled', self.toggle_announce_branches)
-            self.append(item)
-            self.append(gtk.SeparatorMenuItem())
         except ImportError:
-            pass
+            item.set_sensitive(False)
 
         item = gtk.ImageMenuItem(gtk.STOCK_PREFERENCES, None)
         item.connect('activate', self.show_preferences)
@@ -74,12 +96,12 @@
             self.zeroconfserver.close()
 
     def show_about(self, item):
-        from about import AboutDialog
+        from bzrlib.plugins.gtk.about import AboutDialog
         dialog = AboutDialog()
         dialog.run()
 
     def show_preferences(self, item):
-        from preferences import PreferencesWindow
+        from bzrlib.plugins.gtk.preferences import PreferencesWindow
         prefs = PreferencesWindow()
         prefs.run()
 

=== removed directory 'olive'
=== removed file 'olive-gtk'
--- olive-gtk	2008-03-03 17:24:22 +0000
+++ olive-gtk	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-#!/usr/bin/python
-
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-import sys
-import re
-
-try:
-    version_info = sys.version_info
-except AttributeError:
-    version_info = 1, 5 # 1.5 or older
-
-REINVOKE = "__BZR_REINVOKE"
-NEED_VERS = (2, 4)
-KNOWN_PYTHONS = ('python2.4',)
-
-if version_info < NEED_VERS:
-    if not os.environ.has_key(REINVOKE):
-        # mutating os.environ doesn't work in old Pythons
-        os.putenv(REINVOKE, "1")
-        for python in KNOWN_PYTHONS:
-            try:
-                os.execvp(python, [python] + sys.argv)
-            except OSError:
-                pass
-    print >>sys.stderr, ('bzr: error: cannot find a suitable python interpreter'
-                         ' (need %d.%d or later)'
-                        ) % NEED_VERS
-    sys.exit(1)
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-try:
-    import gtk
-    import gtk.glade
-except:
-    print >>sys.stderr, ('You need to install python-glade2 and/or pygtk2 (gtk2)'
-                         ' or set your PYTHONPATH correctly.\n'
-                         'try: export PYTHONPATH=/usr/local/lib/python2.4/site-packages/'
-                        )
-    sys.exit(1)
-
-# gettext support
-import gettext
-gettext.install('olive-gtk')
-
-
-# make sure we could import bzrlib
-try:
-    import bzrlib
-except ImportError:
-    # try to find bzr if it exist in $PATH
-    p = os.popen('bzr version')
-    s = p.read()
-    r = p.close()
-    if r not in (None, 0):
-        print >>sys.stderr, "bzr not found"
-        sys.exit(1)
-    else:
-        bzrlib_match = re.compile(r"bzrlib: (.*)[/\\]bzrlib").search(s)
-        if bzrlib_match:
-            sys.path.append(bzrlib_match.group(1))
-        else:
-            print >>sys.stderr, "Can't find bzrlib location"
-            sys.exit(1)
-
-from bzrlib.plugin import load_plugins
-load_plugins()
-
-import bzrlib.ui
-import bzrlib.plugins.gtk.ui as ui
-bzrlib.ui.ui_factory = ui.GtkUIFactory()
-
-from bzrlib.plugins.gtk.olive import OliveGtk
-app = OliveGtk()
-gtk.main()

=== removed file 'olive-gtk.1'
--- olive-gtk.1	2008-05-01 12:55:33 +0000
+++ olive-gtk.1	1970-01-01 00:00:00 +0000
@@ -1,15 +0,0 @@
-.TH OLIVE-GTK 1 "April 24, 2007"
-.SH NAME
-olive-gtk \- GTK+ frontend for Bazaar
-.SH SYNOPSIS
-.B olive-gtk
-.SH DESCRIPTION
-Olive aims to be a full-featured graphical frontend for the Bazaar (bzr)
-source code management tool.
-.SH SEE ALSO
-.BR bzr (1).
-.SH AUTHOR
-\fBolive-gtk\fP was written by Szilveszter Farkas <szilveszter.farkas@gmail.com>
-.PP
-This manual page was written by Chris Lamb <chris@chris-lamb.co.uk>,
-for the Debian project (but may be used by others).

=== removed file 'olive-gtk.desktop'
--- olive-gtk.desktop	2008-06-03 01:43:08 +0000
+++ olive-gtk.desktop	1970-01-01 00:00:00 +0000
@@ -1,12 +0,0 @@
-[Desktop Entry]
-Encoding=UTF-8
-Type=Application
-Version=1.0
-Name=Olive
-GenericName=Version Control GUI
-GenericName[pl]=Klient graficzny Bazaar
-Comment=Graphical User Interface for the Bazaar Version Control System
-Comment[pl]=Graficzny interfejs dla systemu kontroli wersji Bazaar
-Icon=olive-gtk.png
-Exec=olive-gtk
-Categories=Application;Development;RevisionControl;GTK;GNOME;

=== removed file 'olive.glade'
--- olive.glade	2008-03-30 14:12:10 +0000
+++ olive.glade	1970-01-01 00:00:00 +0000
@@ -1,2550 +0,0 @@
-<?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE glade-interface SYSTEM "glade-2.0.dtd">
-<!--*- mode: xml -*-->
-<glade-interface>
-  <widget class="GtkWindow" id="window_main">
-    <property name="width_request">700</property>
-    <property name="height_request">400</property>
-    <property name="title" translatable="yes">Olive - Bazaar GUI</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <signal name="destroy" handler="on_window_main_destroy"/>
-    <signal name="delete_event" handler="on_window_main_delete_event"/>
-    <child>
-      <widget class="GtkVBox" id="vbox_main">
-        <property name="visible">True</property>
-        <child>
-          <widget class="GtkMenuBar" id="menubar">
-            <property name="visible">True</property>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_file">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_File</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_file_menu">
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_add_files">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Add file(s)...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_add_files_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image241">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-add</property>
-                            <property name="icon_size">1</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_remove_file">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Remove file(s)...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_remove_file_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image242">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-remove</property>
-                            <property name="icon_size">1</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_file3">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_bookmark">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Bookmark current directory</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_bookmark_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_make_directory">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Make _directory...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_make_directory_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_file1">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_rename">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Rename...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_rename_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_move">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Move...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_move_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_file_annotate">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Annotate...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_file_annotate_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_file2">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_quit">
-                        <property name="visible">True</property>
-                        <property name="label">gtk-quit</property>
-                        <property name="use_underline">True</property>
-                        <property name="use_stock">True</property>
-                        <signal name="activate" handler="on_quit_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_view">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_View</property>
-                <property name="use_underline">True</property>
-                <signal name="activate" handler="on_menuitem_view_activate"/>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_view_menu">
-                    <child>
-                      <widget class="GtkCheckMenuItem" id="menuitem_view_show_hidden_files">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Show _hidden files</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_view_show_hidden_files_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkCheckMenuItem" id="menuitem_view_show_ignored_files">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Show _ignored files</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_view_show_ignored_files_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_view1">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_view_refresh">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Refresh</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_view_refresh_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_branch">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_Branch</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_branch_menu">
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_initialize">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Initialize...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_initialize_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_get">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Get...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_get_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_checkout">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">C_heckout...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_checkout_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_branch1">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_branch_pull">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Pu_ll</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_pull_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image243">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/pull16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_branch_push">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Pu_sh...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_push_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image244">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/push16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_update">
-                        <property name="visible">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="label" translatable="yes">Update</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_update_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_branch2">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_revert">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Revert all changes</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_revert_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_merge">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Merge...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_merge_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_branch_commit">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Commit...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_commit_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image245">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/commit16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkSeparatorMenuItem" id="separator_branch3">
-                        <property name="visible">True</property>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_tags">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Ta_gs...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_tags_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_status">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">S_tatus...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_status_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_missing_revisions">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Missing _revisions</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_missing_revisions_activate"/>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_branch_conflicts">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">Con_flicts...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_branch_conflicts_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_stats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_Statistics</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_stats_menu">
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_stats_diff">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Differences...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_stats_diff_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image246">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/diff16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_stats_log">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Log...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_stats_log_activate"/>
-                        <child internal-child="image">
-                          <widget class="GtkImage" id="image247">
-                            <property name="visible">True</property>
-                            <property name="pixbuf">icons/log16.png</property>
-                          </widget>
-                        </child>
-                      </widget>
-                    </child>
-                    <child>
-                      <widget class="GtkMenuItem" id="menuitem_stats_infos">
-                        <property name="visible">True</property>
-                        <property name="label" translatable="yes">_Information...</property>
-                        <property name="use_underline">True</property>
-                        <signal name="activate" handler="on_menuitem_stats_infos_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkMenuItem" id="menuitem_help">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">_Help</property>
-                <property name="use_underline">True</property>
-                <child>
-                  <widget class="GtkMenu" id="menuitem_help_menu">
-                    <child>
-                      <widget class="GtkImageMenuItem" id="menuitem_about">
-                        <property name="visible">True</property>
-                        <property name="label">gtk-about</property>
-                        <property name="use_underline">True</property>
-                        <property name="use_stock">True</property>
-                        <signal name="activate" handler="on_about_activate"/>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkToolbar" id="toolbar">
-            <property name="visible">True</property>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_refresh">
-                <property name="visible">True</property>
-                <property name="label">Refresh</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/refresh.png</property>
-                <signal name="clicked" handler="on_toolbutton_refresh_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_diff">
-                <property name="visible">True</property>
-                <property name="label">Diff</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/diff.png</property>
-                <signal name="clicked" handler="on_toolbutton_diff_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_log">
-                <property name="visible">True</property>
-                <property name="label">Log</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/log.png</property>
-                <signal name="clicked" handler="on_toolbutton_log_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkSeparatorToolItem" id="separatortoolitem1">
-                <property name="visible">True</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="homogeneous">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_commit">
-                <property name="visible">True</property>
-                <property name="is_important">True</property>
-                <property name="label">Commit</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/commit.png</property>
-                <signal name="clicked" handler="on_toolbutton_commit_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkSeparatorToolItem" id="separatortoolitem2">
-                <property name="visible">True</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="homogeneous">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_pull">
-                <property name="visible">True</property>
-                <property name="is_important">True</property>
-                <property name="label">Pull</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/pull.png</property>
-                <signal name="clicked" handler="on_toolbutton_pull_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_push">
-                <property name="visible">True</property>
-                <property name="is_important">True</property>
-                <property name="label">Push</property>
-                <property name="use_underline">True</property>
-                <property name="icon">icons/push.png</property>
-                <signal name="clicked" handler="on_toolbutton_push_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkToolButton" id="toolbutton_update">
-                <property name="visible">True</property>
-                <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                <property name="label" translatable="yes">Update</property>
-                <property name="icon">icons/pull.png</property>
-                <signal name="clicked" handler="on_toolbutton_update_clicked"/>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">1</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkHPaned" id="hpaned_main">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="position">200</property>
-            <child>
-              <widget class="GtkScrolledWindow" id="scrolledwindow_left">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                <child>
-                  <widget class="GtkTreeView" id="treeview_left">
-                    <property name="visible">True</property>
-                    <property name="can_focus">True</property>
-                    <property name="headers_visible">False</property>
-                    <signal name="button_press_event" handler="on_treeview_left_button_press_event"/>
-                    <signal name="button_release_event" handler="on_treeview_left_button_release_event"/>
-                    <signal name="row_activated" handler="on_treeview_left_row_activated"/>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="resize">False</property>
-                <property name="shrink">True</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkVBox" id="vbox_main_right">
-                <property name="visible">True</property>
-                <child>
-                  <widget class="GtkHBox" id="hbox_location">
-                    <property name="visible">True</property>
-                    <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                    <property name="border_width">3</property>
-                    <property name="spacing">3</property>
-                    <child>
-                      <widget class="GtkButton" id="button_location_up">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="receives_default">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="relief">GTK_RELIEF_NONE</property>
-                        <property name="response_id">0</property>
-                        <signal name="clicked" handler="on_button_location_up_clicked"/>
-                        <child>
-                          <widget class="GtkImage" id="image_location_up">
-                            <property name="visible">True</property>
-                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                            <property name="stock">gtk-go-up</property>
-                          </widget>
-                        </child>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <placeholder/>
-                    </child>
-                    <child>
-                      <widget class="GtkEntry" id="entry_location">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <signal name="key_press_event" handler="on_entry_location_key_press_event"/>
-                      </widget>
-                      <packing>
-                        <property name="position">2</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkImage" id="image_location_error">
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="stock">gtk-dialog-error</property>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">3</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkButton" id="button_location_jump">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="receives_default">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="label" translatable="yes">gtk-jump-to</property>
-                        <property name="relief">GTK_RELIEF_NONE</property>
-                        <property name="use_stock">True</property>
-                        <property name="response_id">0</property>
-                        <signal name="clicked" handler="on_button_location_jump_clicked"/>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">4</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkVSeparator" id="vseparator">
-                        <property name="visible">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">5</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkCheckButton" id="checkbutton_history">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="label" translatable="yes">H_istory Mode</property>
-                        <property name="use_underline">True</property>
-                        <property name="response_id">0</property>
-                        <property name="draw_indicator">True</property>
-                        <signal name="toggled" handler="on_checkbutton_history_toggled"/>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">6</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkEntry" id="entry_history_revno">
-                        <property name="width_request">75</property>
-                        <property name="visible">True</property>
-                        <property name="sensitive">False</property>
-                        <property name="can_focus">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <signal name="key_press_event" handler="on_entry_history_revno_key_press_event"/>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">7</property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkButton" id="button_history_browse">
-                        <property name="visible">True</property>
-                        <property name="sensitive">False</property>
-                        <property name="can_focus">True</property>
-                        <property name="receives_default">True</property>
-                        <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                        <property name="response_id">0</property>
-                        <signal name="clicked" handler="on_button_history_browse_clicked"/>
-                        <child>
-                          <widget class="GtkImage" id="image_history_browse">
-                            <property name="visible">True</property>
-                            <property name="events">GDK_POINTER_MOTION_MASK | GDK_POINTER_MOTION_HINT_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK</property>
-                            <property name="stock">gtk-open</property>
-                          </widget>
-                        </child>
-                      </widget>
-                      <packing>
-                        <property name="expand">False</property>
-                        <property name="fill">False</property>
-                        <property name="position">8</property>
-                      </packing>
-                    </child>
-                  </widget>
-                  <packing>
-                    <property name="expand">False</property>
-                    <property name="fill">False</property>
-                  </packing>
-                </child>
-                <child>
-                  <widget class="GtkScrolledWindow" id="scrolledwindow_right">
-                    <property name="visible">True</property>
-                    <property name="can_focus">True</property>
-                    <property name="hscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                    <property name="vscrollbar_policy">GTK_POLICY_AUTOMATIC</property>
-                    <child>
-                      <widget class="GtkTreeView" id="treeview_right">
-                        <property name="visible">True</property>
-                        <property name="can_focus">True</property>
-                        <property name="headers_visible">False</property>
-                        <signal name="button_press_event" handler="on_treeview_right_button_press_event"/>
-                        <signal name="row_activated" handler="on_treeview_right_row_activated"/>
-                      </widget>
-                    </child>
-                  </widget>
-                  <packing>
-                    <property name="position">1</property>
-                  </packing>
-                </child>
-              </widget>
-              <packing>
-                <property name="resize">True</property>
-                <property name="shrink">True</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkStatusbar" id="statusbar">
-            <property name="visible">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkAboutDialog" id="aboutdialog">
-    <property name="visible">True</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
-    <property name="name">Olive</property>
-    <property name="copyright" translatable="yes">Copyright (C) 2006 Szilveszter Farkas (Phanatic)</property>
-    <property name="website">https://launchpad.net/products/olive</property>
-    <property name="website_label" translatable="yes">https://launchpad.net/products/olive</property>
-    <property name="authors">Szilveszter Farkas (Phanatic) &lt;szilveszter.farkas@gmail.com&gt;</property>
-    <property name="translator_credits" translatable="yes" comments="TRANSLATORS: Replace this string with your names, one name per line.">translator-credits</property>
-    <property name="logo">icons/oliveicon2.png</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="dialog-vbox1">
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="dialog-action_area1">
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_add">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Olive - Add file(s)</property>
-    <property name="resizable">False</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_add">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkLabel" id="label_add_question">
-            <property name="visible">True</property>
-            <property name="label" translatable="yes">Which file(s) do you want to add?</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_add_selected">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">Selected only</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_add_unknown">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">All unknowns recursively</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-            <property name="group">radiobutton_add_selected</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">4</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_add">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_add_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_add_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_add_add">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_add_add_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment3">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox5">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image13">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-add</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label8">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Add</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_remove">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Olive - Remove file(s)</property>
-    <property name="resizable">False</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_remove">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkLabel" id="label_remove_question">
-            <property name="visible">True</property>
-            <property name="label" translatable="yes">Which file(s) do you want to remove?</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_remove_selected">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">Selected only</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkRadioButton" id="radiobutton_remove_new">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">All files with status 'added'</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="draw_indicator">True</property>
-            <property name="group">radiobutton_remove_selected</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">4</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_remove">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_remove_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_remove_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_remove_remove">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_remove_remove_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment4">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox6">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image39">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-remove</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label10">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Remove</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_mkdir">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Olive - Make directory</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_mkdir">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkEntry" id="entry_mkdir">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="has_focus">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkCheckButton" id="checkbutton_mkdir_versioned">
-            <property name="visible">True</property>
-            <property name="can_focus">True</property>
-            <property name="label" translatable="yes">_Versioned directory</property>
-            <property name="use_underline">True</property>
-            <property name="response_id">0</property>
-            <property name="active">True</property>
-            <property name="draw_indicator">True</property>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_mkdir">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_mkdir_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_mkdir_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_mkdir_mkdir">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_mkdir_mkdir_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment8">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox10">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image143">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-add</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label17">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Make directory</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_move">
-    <property name="width_request">250</property>
-    <property name="title" translatable="yes">Olive - Move</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_move">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkHBox" id="hbox_move">
-            <property name="visible">True</property>
-            <property name="spacing">5</property>
-            <child>
-              <widget class="GtkLabel" id="label_move">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">Move to</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkFileChooserButton" id="filechooserbutton_move">
-                <property name="visible">True</property>
-                <property name="action">GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER</property>
-                <property name="title" translatable="yes">Select a directory</property>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_move">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_move_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_move_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_move_move">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_move_move_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment9">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox11">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image151">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-apply</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label18">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Move</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_rename">
-    <property name="title" translatable="yes">Olive - Rename</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_rename">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkHBox" id="hbox_rename">
-            <property name="visible">True</property>
-            <property name="spacing">5</property>
-            <child>
-              <widget class="GtkLabel" id="label_rename">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">Rename to</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkEntry" id="entry_rename">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="has_focus">True</property>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_rename">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_rename_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_rename_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_rename_rename">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_rename_rename_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment10">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox13">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image159">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-apply</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label20">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Rename</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_info">
-    <property name="title" translatable="yes">Olive - Information</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_NORMAL</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_info">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkExpander" id="expander_info_location">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_location_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment11">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_location">
-                    <property name="visible">True</property>
-                    <property name="n_rows">7</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repobranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_cobranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repoco">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_coroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_branchroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_sharedrepo">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_lightcoroot">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_coroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Checkout root: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_branchroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch root: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repoco_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository checkout: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_cobranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Checkout of branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_repobranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_sharedrepo_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Shared repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_location_lightcoroot_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Light checkout root: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_location">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Location:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_related">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_related_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment12">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_related">
-                    <property name="visible">True</property>
-                    <property name="n_rows">2</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_parentbranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_publishbranch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_publishbranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Publish to branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_related_parentbranch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Parent branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_related">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Related branches:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">3</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_format">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_format_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment13">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_format">
-                    <property name="visible">True</property>
-                    <property name="n_rows">4</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_control">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_repository">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_repository_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_workingtree_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Working tree format: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_format_control_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Control format: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_format">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Format:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">4</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_locking">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_locking_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment14">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_locking">
-                    <property name="visible">True</property>
-                    <property name="n_rows">3</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_repository">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_repository_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Repository lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Branch lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_locking_workingtree_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Working tree lock status: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_locking">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Lock status:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">5</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_missing">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_missing_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment15">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_missing">
-                    <property name="visible">True</property>
-                    <property name="n_rows">2</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_workingtree">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_branch">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_branch_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Missing revisions in branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_missing_workingtree_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Missing revisions in working tree: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_missing">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Missing revisions:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">6</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_wtstats">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_wtstats_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment16">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_wtstats">
-                    <property name="visible">True</property>
-                    <property name="n_rows">8</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unchanged">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_modified">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_added">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_removed">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_renamed">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unknown">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_ignored">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_subdirs">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">7</property>
-                        <property name="bottom_attach">8</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_subdirs_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Versioned subdirectories: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">7</property>
-                        <property name="bottom_attach">8</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_ignored_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Ignored files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">6</property>
-                        <property name="bottom_attach">7</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unknown_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Unknown files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">5</property>
-                        <property name="bottom_attach">6</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_renamed_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Renamed files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_removed_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Removed files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_added_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Added files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_modified_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Modified files: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_wtstats_unchanged_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Unchanged files: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_wtstats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;In the working tree:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">7</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_brstats">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_brstats_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment17">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_brstats">
-                    <property name="visible">True</property>
-                    <property name="n_rows">5</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_revno">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_commiters">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_age">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_firstrev">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_lastrev">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_lastrev_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Time of last revision: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">4</property>
-                        <property name="bottom_attach">5</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_firstrev_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Time of first revision: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">3</property>
-                        <property name="bottom_attach">4</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_age_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Age of branch in days: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">2</property>
-                        <property name="bottom_attach">3</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_commiters_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Number of commiters: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_brstats_revno_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Revisions in branch: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_brstats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Branch history:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">8</property>
-          </packing>
-        </child>
-        <child>
-          <widget class="GtkExpander" id="expander_info_repstats">
-            <property name="can_focus">True</property>
-            <signal name="activate" handler="on_expander_info_repstats_activate"/>
-            <child>
-              <widget class="GtkAlignment" id="alignment18">
-                <property name="visible">True</property>
-                <property name="left_padding">24</property>
-                <child>
-                  <widget class="GtkTable" id="table_info_repstats">
-                    <property name="visible">True</property>
-                    <property name="n_rows">2</property>
-                    <property name="n_columns">2</property>
-                    <property name="column_spacing">12</property>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_revisions">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_size">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">(none)</property>
-                      </widget>
-                      <packing>
-                        <property name="left_attach">1</property>
-                        <property name="right_attach">2</property>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_size_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Size of repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="top_attach">1</property>
-                        <property name="bottom_attach">2</property>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                    <child>
-                      <widget class="GtkLabel" id="label_info_repstats_revisions_label">
-                        <property name="xalign">0</property>
-                        <property name="label" translatable="yes">Revisions in repository: </property>
-                      </widget>
-                      <packing>
-                        <property name="x_options">GTK_FILL</property>
-                        <property name="y_options"></property>
-                      </packing>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkLabel" id="label_info_repstats">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">&lt;b&gt;Revision store:&lt;/b&gt;</property>
-                <property name="use_markup">True</property>
-              </widget>
-              <packing>
-                <property name="type">label_item</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="position">9</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_info">
-            <property name="visible">True</property>
-            <property name="can_default">True</property>
-            <property name="has_default">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_info_close">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="label">gtk-close</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_info_close_clicked"/>
-              </widget>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-  <widget class="GtkDialog" id="window_merge">
-    <property name="visible">True</property>
-    <property name="title" translatable="yes">Merge - Olive</property>
-    <property name="icon">icons/oliveicon2.png</property>
-    <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
-    <child internal-child="vbox">
-      <widget class="GtkVBox" id="vbox_merge">
-        <property name="visible">True</property>
-        <property name="spacing">3</property>
-        <child>
-          <widget class="GtkHBox" id="hbox_merge">
-            <property name="visible">True</property>
-            <property name="spacing">3</property>
-            <child>
-              <widget class="GtkLabel" id="label_merge">
-                <property name="visible">True</property>
-                <property name="label" translatable="yes">Merge from:</property>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkEntry" id="entry_merge">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_merge_open">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_merge_open_clicked"/>
-                <child>
-                  <widget class="GtkImage" id="image240">
-                    <property name="visible">True</property>
-                    <property name="stock">gtk-open</property>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="expand">False</property>
-                <property name="fill">False</property>
-                <property name="position">2</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="position">2</property>
-          </packing>
-        </child>
-        <child internal-child="action_area">
-          <widget class="GtkHButtonBox" id="hbuttonbox_merge">
-            <property name="visible">True</property>
-            <property name="layout_style">GTK_BUTTONBOX_END</property>
-            <child>
-              <widget class="GtkButton" id="button_merge_cancel">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="label">gtk-cancel</property>
-                <property name="use_stock">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_merge_cancel_clicked"/>
-              </widget>
-            </child>
-            <child>
-              <widget class="GtkButton" id="button_merge_merge">
-                <property name="visible">True</property>
-                <property name="can_focus">True</property>
-                <property name="can_default">True</property>
-                <property name="has_default">True</property>
-                <property name="response_id">0</property>
-                <signal name="clicked" handler="on_button_merge_merge_clicked"/>
-                <child>
-                  <widget class="GtkAlignment" id="alignment19">
-                    <property name="visible">True</property>
-                    <property name="xscale">0</property>
-                    <property name="yscale">0</property>
-                    <child>
-                      <widget class="GtkHBox" id="hbox14">
-                        <property name="visible">True</property>
-                        <property name="spacing">2</property>
-                        <child>
-                          <widget class="GtkImage" id="image239">
-                            <property name="visible">True</property>
-                            <property name="stock">gtk-apply</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                          </packing>
-                        </child>
-                        <child>
-                          <widget class="GtkLabel" id="label21">
-                            <property name="visible">True</property>
-                            <property name="label" translatable="yes">_Merge</property>
-                            <property name="use_underline">True</property>
-                          </widget>
-                          <packing>
-                            <property name="expand">False</property>
-                            <property name="fill">False</property>
-                            <property name="position">1</property>
-                          </packing>
-                        </child>
-                      </widget>
-                    </child>
-                  </widget>
-                </child>
-              </widget>
-              <packing>
-                <property name="position">1</property>
-              </packing>
-            </child>
-          </widget>
-          <packing>
-            <property name="expand">False</property>
-            <property name="fill">False</property>
-            <property name="pack_type">GTK_PACK_END</property>
-          </packing>
-        </child>
-      </widget>
-    </child>
-  </widget>
-</glade-interface>

=== removed file 'olive.gladep'
--- olive.gladep	2007-08-10 10:45:06 +0000
+++ olive.gladep	1970-01-01 00:00:00 +0000
@@ -1,8 +0,0 @@
-<?xml version="1.0" standalone="no"?> <!--*- mode: xml -*-->
-<!DOCTYPE glade-project SYSTEM "http://glade.gnome.org/glade-project-2.0.dtd">
-
-<glade-project>
-  <name>olive</name>
-  <program_name>olive</program_name>
-  <pixmaps_directory>.</pixmaps_directory>
-</glade-project>

=== removed file 'olive/__init__.py'
--- olive/__init__.py	2008-06-23 08:05:19 +0000
+++ olive/__init__.py	1970-01-01 00:00:00 +0000
@@ -1,1727 +0,0 @@
- #!/usr/bin/python
-
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-import sys
-import time
-
-# gettext support
-import gettext
-gettext.install('olive-gtk')
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gobject
-import gtk
-import gtk.gdk
-import gtk.glade
-
-from bzrlib.branch import Branch
-import bzrlib.errors as bzrerrors
-from bzrlib.lazy_import import lazy_import
-from bzrlib.ui import ui_factory
-from bzrlib.workingtree import WorkingTree
-
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, warning_dialog
-from bzrlib.plugins.gtk.errors import show_bzr_error
-from guifiles import GLADEFILENAME
-
-from bzrlib.plugins.gtk.diff import DiffWindow
-lazy_import(globals(), """
-from bzrlib.plugins.gtk.viz import branchwin
-""")
-from bzrlib.plugins.gtk.annotate.gannotate import GAnnotateWindow
-from bzrlib.plugins.gtk.annotate.config import GAnnotateConfig
-from bzrlib.plugins.gtk.commit import CommitDialog
-from bzrlib.plugins.gtk.conflicts import ConflictsDialog
-from bzrlib.plugins.gtk.initialize import InitDialog
-from bzrlib.plugins.gtk.push import PushDialog
-from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
-
-def about():
-    """ Display the AboutDialog. """
-    from bzrlib.plugins.gtk import __version__
-    from bzrlib.plugins.gtk.olive.guifiles import GLADEFILENAME
-
-    # Load AboutDialog description
-    dglade = gtk.glade.XML(GLADEFILENAME, 'aboutdialog')
-    dialog = dglade.get_widget('aboutdialog')
-
-    # Set version
-    dialog.set_version(__version__)
-    dialog.set_authors([ _i18n("Lead Developer:"),
-			 "Szilveszter Farkas <szilveszter.farkas@gmail.com>",
-			 _i18n("Contributors:"),
-			 "Jelmer Vernooij <jelmer@samba.org>",
-			 "Mateusz Korniak <mateusz.korniak@ant.gliwice.pl>",
-			 "Gary van der Merwe <garyvdm@gmail.com>" ])
-    dialog.set_artists([ "Simon Pascal Klein <klepas@klepas.org>",
-			 "Jakub Steiner <jimmac@novell.com>" ])
-
-    dialog.run()
-    # Destroy the dialog
-    dialog.destroy()
-
-class OliveGtk:
-    """ The main Olive GTK frontend class. This is called when launching the
-    program. """
-    
-    def __init__(self):
-        self.toplevel = gtk.glade.XML(GLADEFILENAME, 'window_main', 'olive-gtk')
-        self.window = self.toplevel.get_widget('window_main')
-        self.pref = Preferences()
-        self.path = None
-
-        # Initialize the statusbar
-        self.statusbar = self.toplevel.get_widget('statusbar')
-        self.context_id = self.statusbar.get_context_id('olive')
-        
-        # Get the main window
-        self.window_main = self.toplevel.get_widget('window_main')
-        # Get the HPaned
-        self.hpaned_main = self.toplevel.get_widget('hpaned_main')
-        # Get the TreeViews
-        self.treeview_left = self.toplevel.get_widget('treeview_left')
-        self.treeview_right = self.toplevel.get_widget('treeview_right')
-        # Get some important menu items
-        self.menuitem_add_files = self.toplevel.get_widget('menuitem_add_files')
-        self.menuitem_remove_files = self.toplevel.get_widget('menuitem_remove_file')
-        self.menuitem_file_bookmark = self.toplevel.get_widget('menuitem_file_bookmark')
-        self.menuitem_file_make_directory = self.toplevel.get_widget('menuitem_file_make_directory')
-        self.menuitem_file_rename = self.toplevel.get_widget('menuitem_file_rename')
-        self.menuitem_file_move = self.toplevel.get_widget('menuitem_file_move')
-        self.menuitem_file_annotate = self.toplevel.get_widget('menuitem_file_annotate')
-        self.menuitem_view_show_hidden_files = self.toplevel.get_widget('menuitem_view_show_hidden_files')
-        self.menuitem_view_show_ignored_files = self.toplevel.get_widget('menuitem_view_show_ignored_files')
-        self.menuitem_branch = self.toplevel.get_widget('menuitem_branch')
-        self.menuitem_branch_init = self.toplevel.get_widget('menuitem_branch_initialize')
-        self.menuitem_branch_get = self.toplevel.get_widget('menuitem_branch_get')
-        self.menuitem_branch_checkout = self.toplevel.get_widget('menuitem_branch_checkout')
-        self.menuitem_branch_pull = self.toplevel.get_widget('menuitem_branch_pull')
-        self.menuitem_branch_push = self.toplevel.get_widget('menuitem_branch_push')
-        self.menuitem_branch_update = self.toplevel.get_widget('menuitem_branch_update')
-        self.menuitem_branch_revert = self.toplevel.get_widget('menuitem_branch_revert')
-        self.menuitem_branch_merge = self.toplevel.get_widget('menuitem_branch_merge')
-        self.menuitem_branch_commit = self.toplevel.get_widget('menuitem_branch_commit')
-        self.menuitem_branch_tags = self.toplevel.get_widget('menuitem_branch_tags')
-        self.menuitem_branch_status = self.toplevel.get_widget('menuitem_branch_status')
-        self.menuitem_branch_missing = self.toplevel.get_widget('menuitem_branch_missing_revisions')
-        self.menuitem_branch_conflicts = self.toplevel.get_widget('menuitem_branch_conflicts')
-        self.menuitem_stats = self.toplevel.get_widget('menuitem_stats')
-        self.menuitem_stats_diff = self.toplevel.get_widget('menuitem_stats_diff')
-        self.menuitem_stats_log = self.toplevel.get_widget('menuitem_stats_log')
-        # Get some toolbuttons
-        #self.menutoolbutton_diff = self.toplevel.get_widget('menutoolbutton_diff')
-        self.toolbutton_diff = self.toplevel.get_widget('toolbutton_diff')
-        self.toolbutton_log = self.toplevel.get_widget('toolbutton_log')
-        self.toolbutton_commit = self.toplevel.get_widget('toolbutton_commit')
-        self.toolbutton_pull = self.toplevel.get_widget('toolbutton_pull')
-        self.toolbutton_push = self.toplevel.get_widget('toolbutton_push')
-        self.toolbutton_update = self.toplevel.get_widget('toolbutton_update')
-        # Get the drive selector
-        self.combobox_drive = gtk.combo_box_new_text()
-        self.combobox_drive.connect("changed", self._refresh_drives)
-        
-        # Get the navigation widgets
-        self.hbox_location = self.toplevel.get_widget('hbox_location')
-        self.button_location_up = self.toplevel.get_widget('button_location_up')
-        self.button_location_jump = self.toplevel.get_widget('button_location_jump')
-        self.entry_location = self.toplevel.get_widget('entry_location')
-        self.image_location_error = self.toplevel.get_widget('image_location_error')
-        
-        # Get the History widgets
-        self.check_history = self.toplevel.get_widget('checkbutton_history')
-        self.entry_history = self.toplevel.get_widget('entry_history_revno')
-        self.button_history = self.toplevel.get_widget('button_history_browse')
-        
-        self.vbox_main_right = self.toplevel.get_widget('vbox_main_right')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_window_main_destroy": gtk.main_quit,
-                "on_window_main_delete_event": self.on_window_main_delete_event,
-                "on_quit_activate": self.on_window_main_delete_event,
-                "on_about_activate": self.on_about_activate,
-                "on_menuitem_add_files_activate": self.on_menuitem_add_files_activate,
-                "on_menuitem_remove_file_activate": self.on_menuitem_remove_file_activate,
-                "on_menuitem_file_bookmark_activate": self.on_menuitem_file_bookmark_activate,
-                "on_menuitem_file_make_directory_activate": self.on_menuitem_file_make_directory_activate,
-                "on_menuitem_file_move_activate": self.on_menuitem_file_move_activate,
-                "on_menuitem_file_rename_activate": self.on_menuitem_file_rename_activate,
-                "on_menuitem_file_annotate_activate": self.on_menuitem_file_annotate_activate,
-                "on_menuitem_view_show_hidden_files_activate": self.on_menuitem_view_show_hidden_files_activate,
-                "on_menuitem_view_show_ignored_files_activate": self.on_menuitem_view_show_ignored_files_activate,
-                "on_menuitem_view_refresh_activate": self.on_menuitem_view_refresh_activate,
-                "on_menuitem_branch_initialize_activate": self.on_menuitem_branch_initialize_activate,
-                "on_menuitem_branch_get_activate": self.on_menuitem_branch_get_activate,
-                "on_menuitem_branch_checkout_activate": self.on_menuitem_branch_checkout_activate,
-                "on_menuitem_branch_revert_activate": self.on_menuitem_branch_revert_activate,
-                "on_menuitem_branch_merge_activate": self.on_menuitem_branch_merge_activate,
-                "on_menuitem_branch_commit_activate": self.on_menuitem_branch_commit_activate,
-                "on_menuitem_branch_push_activate": self.on_menuitem_branch_push_activate,
-                "on_menuitem_branch_pull_activate": self.on_menuitem_branch_pull_activate,
-                "on_menuitem_branch_update_activate": self.on_menuitem_branch_update_activate,                
-                "on_menuitem_branch_tags_activate": self.on_menuitem_branch_tags_activate,
-                "on_menuitem_branch_status_activate": self.on_menuitem_branch_status_activate,
-                "on_menuitem_branch_missing_revisions_activate": self.on_menuitem_branch_missing_revisions_activate,
-                "on_menuitem_branch_conflicts_activate": self.on_menuitem_branch_conflicts_activate,
-                "on_menuitem_stats_diff_activate": self.on_menuitem_stats_diff_activate,
-                "on_menuitem_stats_log_activate": self.on_menuitem_stats_log_activate,
-                "on_menuitem_stats_infos_activate": self.on_menuitem_stats_infos_activate,
-                "on_toolbutton_refresh_clicked": self.on_menuitem_view_refresh_activate,
-                "on_toolbutton_log_clicked": self.on_menuitem_stats_log_activate,
-                #"on_menutoolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
-                "on_toolbutton_diff_clicked": self.on_menuitem_stats_diff_activate,
-                "on_toolbutton_commit_clicked": self.on_menuitem_branch_commit_activate,
-                "on_toolbutton_pull_clicked": self.on_menuitem_branch_pull_activate,
-                "on_toolbutton_push_clicked": self.on_menuitem_branch_push_activate,
-                "on_toolbutton_update_clicked": self.on_menuitem_branch_update_activate,
-                "on_treeview_right_button_press_event": self.on_treeview_right_button_press_event,
-                "on_treeview_right_row_activated": self.on_treeview_right_row_activated,
-                "on_treeview_left_button_press_event": self.on_treeview_left_button_press_event,
-                "on_treeview_left_button_release_event": self.on_treeview_left_button_release_event,
-                "on_treeview_left_row_activated": self.on_treeview_left_row_activated,
-                "on_button_location_up_clicked": self.on_button_location_up_clicked,
-                "on_button_location_jump_clicked": self.on_button_location_jump_clicked,
-                "on_entry_location_key_press_event": self.on_entry_location_key_press_event,
-                "on_checkbutton_history_toggled": self.on_checkbutton_history_toggled,
-                "on_entry_history_revno_key_press_event": self.on_entry_history_revno_key_press_event,
-                "on_button_history_browse_clicked": self.on_button_history_browse_clicked
-            }
-        
-        # Connect the signals to the handlers
-        self.toplevel.signal_autoconnect(dic)
-        
-        self._just_started = True
-        
-        # Apply window size and position
-        width = self.pref.get_preference('window_width', 'int')
-        height = self.pref.get_preference('window_height', 'int')
-        self.window.resize(width, height)
-        x = self.pref.get_preference('window_x', 'int')
-        y = self.pref.get_preference('window_y', 'int')
-        self.window.move(x, y)
-        # Apply paned position
-        pos = self.pref.get_preference('paned_position', 'int')
-        self.hpaned_main.set_position(pos)
-        
-        # Apply menu to the toolbutton
-        #menubutton = self.toplevel.get_widget('menutoolbutton_diff')
-        #menubutton.set_menu(handler.menu.toolbar_diff)
-        
-        # Now we can show the window
-        self.window.show()
-        
-        # Show drive selector if under Win32
-        if sys.platform == 'win32':
-            self.hbox_location.pack_start(self.combobox_drive, False, False, 0)
-            self.hbox_location.reorder_child(self.combobox_drive, 1)
-            self.combobox_drive.show()
-            self.gen_hard_selector()
-        
-        self._load_left()
-
-        # Apply menu state
-        self.menuitem_view_show_hidden_files.set_active(self.pref.get_preference('dotted_files', 'bool'))
-        self.menuitem_view_show_ignored_files.set_active(self.pref.get_preference('ignored_files', 'bool'))
-
-        # We're starting local
-        self.remote = False
-        self.remote_branch = None
-        self.remote_path = None
-        self.remote_revision = None
-        
-        self.set_path(os.getcwd())
-        self._load_right()
-        
-        self._just_started = False
-
-    def set_path(self, path, force_remote=False):
-        self.notbranch = False
-        
-        if force_remote:
-            # Forcing remote mode (reading data from inventory)
-            self._show_stock_image(gtk.STOCK_DISCONNECT)
-            try:
-                br = Branch.open_containing(path)[0]
-            except bzrerrors.NotBranchError:
-                self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
-                self.check_history.set_active(False)
-                self.check_history.set_sensitive(False)
-                return False
-            except bzrerrors.UnsupportedProtocol:
-                self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
-                self.check_history.set_active(False)
-                self.check_history.set_sensitive(False)
-                return False
-            
-            self._show_stock_image(gtk.STOCK_CONNECT)
-            
-            self.remote = True
-           
-            # We're remote
-            self.remote_branch, self.remote_path = Branch.open_containing(path)
-            
-            if self.remote_revision is None:
-                self.remote_revision = self.remote_branch.last_revision()
-            
-            self.remote_entries = self.remote_branch.repository.get_inventory(self.remote_revision).entries()
-            
-            if len(self.remote_path) == 0:
-                self.remote_parent = self.remote_branch.repository.get_inventory(self.remote_branch.last_revision()).iter_entries_by_dir().next()[1].file_id
-            else:
-                for (name, type) in self.remote_entries:
-                    if name == self.remote_path:
-                        self.remote_parent = type.file_id
-                        break
-            
-            if not path.endswith('/'):
-                path += '/'
-            
-            if self.remote_branch.base == path:
-                self.button_location_up.set_sensitive(False)
-            else:
-                self.button_location_up.set_sensitive(True)
-        else:
-            if os.path.isdir(path):
-                self.image_location_error.destroy()
-                self.remote = False
-                
-                # We're local
-                try:
-                    self.wt, self.wtpath = WorkingTree.open_containing(path)
-                except (bzrerrors.NotBranchError, bzrerrors.NoWorkingTree):
-                    self.notbranch = True
-                
-                # If we're in the root, we cannot go up anymore
-                if sys.platform == 'win32':
-                    drive, tail = os.path.splitdrive(path)
-                    if tail in ('', '/', '\\'):
-                        self.button_location_up.set_sensitive(False)
-                    else:
-                        self.button_location_up.set_sensitive(True)
-                else:
-                    if self.path == '/':
-                        self.button_location_up.set_sensitive(False)
-                    else:
-                        self.button_location_up.set_sensitive(True)
-            elif not os.path.isfile(path):
-                # Doesn't seem to be a file nor a directory, trying to open a
-                # remote location
-                self._show_stock_image(gtk.STOCK_DISCONNECT)
-                try:
-                    br = Branch.open_containing(path)[0]
-                except bzrerrors.NotBranchError:
-                    self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
-                    self.check_history.set_active(False)
-                    self.check_history.set_sensitive(False)
-                    return False
-                except bzrerrors.UnsupportedProtocol:
-                    self._show_stock_image(gtk.STOCK_DIALOG_ERROR)
-                    self.check_history.set_active(False)
-                    self.check_history.set_sensitive(False)
-                    return False
-                
-                self._show_stock_image(gtk.STOCK_CONNECT)
-                
-                self.remote = True
-               
-                # We're remote
-                self.remote_branch, self.remote_path = Branch.open_containing(path)
-                
-                if self.remote_revision is None:
-                    self.remote_revision = self.remote_branch.last_revision()
-                
-                self.remote_entries = self.remote_branch.repository.get_inventory(self.remote_revision).entries()
-                
-                if len(self.remote_path) == 0:
-                    self.remote_parent = self.remote_branch.repository.get_inventory(self.remote_branch.last_revision()).iter_entries_by_dir().next()[1].file_id
-                else:
-                    for (name, type) in self.remote_entries:
-                        if name == self.remote_path:
-                            self.remote_parent = type.file_id
-                            break
-                
-                if not path.endswith('/'):
-                    path += '/'
-                
-                if self.remote_branch.base == path:
-                    self.button_location_up.set_sensitive(False)
-                else:
-                    self.button_location_up.set_sensitive(True)
-        
-        if self.notbranch:
-            self.check_history.set_active(False)
-            self.check_history.set_sensitive(False)
-        else:
-            self.check_history.set_sensitive(True)
-        
-        self.statusbar.push(self.context_id, path)
-        self.entry_location.set_text(path)
-        self.path = path
-        return True
-
-    def get_path(self):
-        if not self.remote:
-            return self.path
-        else:
-            # Remote mode
-            if len(self.remote_path) > 0:
-                return self.remote_branch.base + self.remote_path + '/'
-            else:
-                return self.remote_branch.base
-   
-    def on_about_activate(self, widget):
-        about()
-    
-    def on_button_history_browse_clicked(self, widget):
-        """ Browse for revision button handler. """
-        if self.remote:
-            br = self.remote_branch
-        else:
-            br = self.wt.branch
-            
-        revb = RevisionBrowser(br, self.window)
-        response = revb.run()
-        if response != gtk.RESPONSE_NONE:
-            revb.hide()
-        
-            if response == gtk.RESPONSE_OK:
-                if revb.selected_revno is not None:
-                    self.entry_history.set_text(revb.selected_revno)
-            
-            revb.destroy()
-    
-    def on_button_location_jump_clicked(self, widget):
-        """ Location Jump button handler. """
-        location = self.entry_location.get_text()
-        
-        if self.set_path(location):
-            self.refresh_right()
-    
-    def on_button_location_up_clicked(self, widget):
-        """ Location Up button handler. """
-        if not self.remote:
-            # Local mode
-            self.set_path(os.path.split(self.get_path())[0])
-        else:
-            # Remote mode
-            delim = '/'
-            newpath = delim.join(self.get_path().split(delim)[:-2])
-            newpath += '/'
-            self.set_path(newpath)
-
-        self.refresh_right()
-    
-    def on_checkbutton_history_toggled(self, widget):
-        """ History Mode toggle handler. """
-        if self.check_history.get_active():
-            # History Mode activated
-            self.entry_history.set_sensitive(True)
-            self.button_history.set_sensitive(True)
-        else:
-            # History Mode deactivated
-            self.entry_history.set_sensitive(False)
-            self.button_history.set_sensitive(False)
-    
-    @show_bzr_error
-    def on_entry_history_revno_key_press_event(self, widget, event):
-        """ Key pressed handler for the history entry. """
-        if event.keyval == gtk.gdk.keyval_from_name('Return') or event.keyval == gtk.gdk.keyval_from_name('KP_Enter'):
-            # Return was hit, so we have to load that specific revision
-            # Emulate being remote, so inventory should be used
-            path = self.get_path()
-            if not self.remote:
-                self.remote = True
-                self.remote_branch = self.wt.branch
-            
-            revno = int(self.entry_history.get_text())
-            self.remote_revision = self.remote_branch.get_rev_id(revno)
-            if self.set_path(path, True):
-                self.refresh_right()
-    
-    def on_entry_location_key_press_event(self, widget, event):
-        """ Key pressed handler for the location entry. """
-        if event.keyval == gtk.gdk.keyval_from_name('Return') or event.keyval == gtk.gdk.keyval_from_name('KP_Enter'):
-            # Return was hit, so we have to jump
-            self.on_button_location_jump_clicked(widget)
-    
-    def on_menuitem_add_files_activate(self, widget):
-        """ Add file(s)... menu handler. """
-        from add import OliveAdd
-        add = OliveAdd(self.wt, self.wtpath, self.get_selected_right())
-        add.display()
-    
-    def on_menuitem_branch_get_activate(self, widget):
-        """ Branch/Get... menu handler. """
-        from bzrlib.plugins.gtk.branch import BranchDialog
-        
-        if self.remote:
-            branch = BranchDialog(os.getcwd(), self.window, self.remote_branch.base)
-        else:
-            branch = BranchDialog(self.get_path(), self.window)
-        response = branch.run()
-        if response != gtk.RESPONSE_NONE:
-            branch.hide()
-            
-            if response == gtk.RESPONSE_OK:
-                self.refresh_right()
-            
-            branch.destroy()
-    
-    def on_menuitem_branch_checkout_activate(self, widget):
-        """ Branch/Checkout... menu handler. """
-        from bzrlib.plugins.gtk.checkout import CheckoutDialog
-        
-        if self.remote:
-            checkout = CheckoutDialog(os.getcwd(), self.window, self.remote_branch.base)
-        else:
-            checkout = CheckoutDialog(self.get_path(), self.window)
-        response = checkout.run()
-        if response != gtk.RESPONSE_NONE:
-            checkout.hide()
-        
-            if response == gtk.RESPONSE_OK:
-                self.refresh_right()
-            
-            checkout.destroy()
-    
-    @show_bzr_error
-    def on_menuitem_branch_commit_activate(self, widget):
-        """ Branch/Commit... menu handler. """
-#     def __init__(self, wt, wtpath, notbranch, selected=None, parent=None):
-        selected = self.get_selected_right()
-        if selected:
-            selected = os.path.join(self.wtpath, selected)
-        commit = CommitDialog(wt=self.wt,
-                              parent=self.window,
-                              selected=selected,
-                             )
-        response = commit.run()
-        if response != gtk.RESPONSE_NONE:
-            commit.hide()
-        
-            if response == gtk.RESPONSE_OK:
-                self.refresh_right()
-            
-            commit.destroy()
-    
-    def on_menuitem_branch_conflicts_activate(self, widget):
-        """ Branch/Conflicts... menu handler. """
-        conflicts = ConflictsDialog(self.wt, self.window)
-        response = conflicts.run()
-        if response != gtk.RESPONSE_NONE:
-            conflicts.destroy()
-    
-    def on_menuitem_branch_merge_activate(self, widget):
-        """ Branch/Merge... menu handler. """
-        from bzrlib.plugins.gtk.merge import MergeDialog
-        
-        if self.check_for_changes():
-            error_dialog(_i18n('There are local changes in the branch'),
-                         _i18n('Please commit or revert the changes before merging.'))
-        else:
-            parent_branch_path = self.wt.branch.get_parent()
-            merge = MergeDialog(self.wt, self.wtpath,default_branch_path=parent_branch_path )
-            merge.display()
-
-    @show_bzr_error
-    def on_menuitem_branch_missing_revisions_activate(self, widget):
-        """ Branch/Missing revisions menu handler. """
-        
-        from bzrlib.missing import find_unmerged, iter_log_revisions
-        
-        local_branch = self.wt.branch
-        parent_branch_path = local_branch.get_parent()
-        if parent_branch_path is None:
-            error_dialog(_i18n('Parent location is unknown'),
-                         _i18n('Cannot determine missing revisions if no parent location is known.'))
-            return
-        
-        parent_branch = Branch.open(parent_branch_path)
-        
-        if parent_branch.base == local_branch.base:
-            parent_branch = local_branch
-        
-        local_extra, remote_extra = find_unmerged(local_branch,parent_branch)
-
-        if local_extra or remote_extra:
-            
-            ## def log_revision_one_line_text(log_revision):
-            ##    """ Generates one line description of log_revison ended with end of line."""
-            ##    revision = log_revision.rev
-            ##    txt =  "- %s (%s)\n" % (revision.get_summary(), revision.committer, )
-            ##    txt = txt.replace("<"," ") # Seems < > chars are expected to be xml tags ...
-            ##    txt = txt.replace(">"," ")
-            ##    return txt
-            
-            dlg_txt = ""
-            if local_extra:
-                dlg_txt += _i18n('%d local extra revision(s). \n') % (len(local_extra),) 
-                ## NOTE: We do not want such ugly info about missing revisions
-                ##       Revision Browser should be used there
-                ## max_revisions = 10
-                ## for log_revision in iter_log_revisions(local_extra, local_branch.repository, verbose=1):
-                ##    dlg_txt += log_revision_one_line_text(log_revision)
-                ##    if max_revisions <= 0:
-                ##        dlg_txt += _i18n("more ... \n")
-                ##        break
-                ## max_revisions -= 1
-            ## dlg_txt += "\n"
-            if remote_extra:
-                dlg_txt += _i18n('%d local missing revision(s).\n') % (len(remote_extra),) 
-                ## max_revisions = 10
-                ## for log_revision in iter_log_revisions(remote_extra, parent_branch.repository, verbose=1):
-                ##    dlg_txt += log_revision_one_line_text(log_revision)
-                ##    if max_revisions <= 0:
-                ##        dlg_txt += _i18n("more ... \n")
-                ##        break
-                ##    max_revisions -= 1
-                
-            info_dialog(_i18n('There are missing revisions'),
-                        dlg_txt)
-        else:
-            info_dialog(_i18n('Local branch up to date'),
-                        _i18n('There are no missing revisions.'))
-
-    @show_bzr_error
-    def on_menuitem_branch_pull_activate(self, widget):
-        """ Branch/Pull menu handler. """
-        branch_to = self.wt.branch
-
-        location = branch_to.get_parent()
-        if location is None:
-            error_dialog(_i18n('Parent location is unknown'),
-                                     _i18n('Pulling is not possible until there is a parent location.'))
-            return
-
-        branch_from = Branch.open(location)
-
-        if branch_to.get_parent() is None:
-            branch_to.set_parent(branch_from.base)
-
-        ret = branch_to.pull(branch_from)
-        
-        info_dialog(_i18n('Pull successful'), _i18n('%d revision(s) pulled.') % ret)
-        
-    @show_bzr_error
-    def on_menuitem_branch_update_activate(self, widget):
-        """ Brranch/checkout update menu handler. """
-        
-        ret = self.wt.update()
-        conflicts = self.wt.conflicts()
-        if conflicts:
-            info_dialog(_i18n('Update successful but conflicts generated'), _i18n('Number of conflicts generated: %d.') % (len(conflicts),) )
-        else:
-            info_dialog(_i18n('Update successful'), _i18n('No conflicts generated.') )
-    
-    def on_menuitem_branch_push_activate(self, widget):
-        """ Branch/Push... menu handler. """
-        push = PushDialog(repository=None,revid=None,branch=self.wt.branch, parent=self.window)
-        response = push.run()
-        if response != gtk.RESPONSE_NONE:
-            push.destroy()
-    
-    @show_bzr_error
-    def on_menuitem_branch_revert_activate(self, widget):
-        """ Branch/Revert all changes menu handler. """
-        ret = self.wt.revert([])
-        if ret:
-            warning_dialog(_i18n('Conflicts detected'),
-                           _i18n('Please have a look at the working tree before continuing.'))
-        else:
-            info_dialog(_i18n('Revert successful'),
-                        _i18n('All files reverted to last revision.'))
-        self.refresh_right()
-    
-    def on_menuitem_branch_status_activate(self, widget):
-        """ Branch/Status... menu handler. """
-        from bzrlib.plugins.gtk.status import StatusDialog
-        status = StatusDialog(self.wt, self.wtpath)
-        response = status.run()
-        if response != gtk.RESPONSE_NONE:
-            status.destroy()
-    
-    def on_menuitem_branch_initialize_activate(self, widget):
-        """ Initialize current directory. """
-        init = InitDialog(self.path, self.window)
-        response = init.run()
-        if response != gtk.RESPONSE_NONE:
-            init.hide()
-        
-            if response == gtk.RESPONSE_OK:
-                self.refresh_right()
-            
-            init.destroy()
-        
-    def on_menuitem_branch_tags_activate(self, widget):
-        """ Branch/Tags... menu handler. """
-        from bzrlib.plugins.gtk.tags import TagsWindow
-        if not self.remote:
-            window = TagsWindow(self.wt.branch, self.window)
-        else:
-            window = TagsWindow(self.remote_branch, self.window)
-        window.show()
-    
-    def on_menuitem_file_annotate_activate(self, widget):
-        """ File/Annotate... menu handler. """
-        if self.get_selected_right() is None:
-            error_dialog(_i18n('No file was selected'),
-                         _i18n('Please select a file from the list.'))
-            return
-        
-        branch = self.wt.branch
-        file_id = self.wt.path2id(self.wt.relpath(os.path.join(self.path, self.get_selected_right())))
-        
-        window = GAnnotateWindow(all=False, plain=False, parent=self.window)
-        window.set_title(os.path.join(self.path, self.get_selected_right()) + " - Annotate")
-        config = GAnnotateConfig(window)
-        window.show()
-        branch.lock_read()
-        try:
-            window.annotate(self.wt, branch, file_id)
-        finally:
-            branch.unlock()
-    
-    def on_menuitem_file_bookmark_activate(self, widget):
-        """ File/Bookmark current directory menu handler. """
-        if self.pref.add_bookmark(self.path):
-            info_dialog(_i18n('Bookmark successfully added'),
-                        _i18n('The current directory was bookmarked. You can reach\nit by selecting it from the left panel.'))
-            self.pref.write()
-        else:
-            warning_dialog(_i18n('Location already bookmarked'),
-                           _i18n('The current directory is already bookmarked.\nSee the left panel for reference.'))
-        
-        self.refresh_left()
-    
-    def on_menuitem_file_make_directory_activate(self, widget):
-        """ File/Make directory... menu handler. """
-        from mkdir import OliveMkdir
-        mkdir = OliveMkdir(self.wt, self.wtpath)
-        mkdir.display()
-    
-    def on_menuitem_file_move_activate(self, widget):
-        """ File/Move... menu handler. """
-        from move import OliveMove
-        move = OliveMove(self.wt, self.wtpath, self.get_selected_right())
-        move.display()
-    
-    def on_menuitem_file_rename_activate(self, widget):
-        """ File/Rename... menu handler. """
-        from rename import OliveRename
-        rename = OliveRename(self.wt, self.wtpath, self.get_selected_right())
-        rename.display()
-
-    def on_menuitem_remove_file_activate(self, widget):
-        """ Remove (unversion) selected file. """
-        from remove import OliveRemoveDialog
-        remove = OliveRemoveDialog(self.wt, self.wtpath,
-                                   selected=self.get_selected_right(),
-                                   parent=self.window)
-        response = remove.run()
-        
-        if response != gtk.RESPONSE_NONE:
-            remove.hide()
-        
-            if response == gtk.RESPONSE_OK:
-                self.set_path(self.path)
-                self.refresh_right()
-            
-            remove.destroy()
-    
-    def on_menuitem_stats_diff_activate(self, widget):
-        """ Statistics/Differences... menu handler. """
-        window = DiffWindow(parent=self.window)
-        parent_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
-        window.set_diff(self.wt.branch.nick, self.wt, parent_tree)
-        window.show()
-    
-    def on_menuitem_stats_infos_activate(self, widget):
-        """ Statistics/Informations... menu handler. """
-        from info import OliveInfo
-        if self.remote:
-            info = OliveInfo(self.remote_branch)
-        else:
-            info = OliveInfo(self.wt.branch)
-        info.display()
-    
-    def on_menuitem_stats_log_activate(self, widget):
-        """ Statistics/Log... menu handler. """
-
-        if not self.remote:
-            branch = self.wt.branch
-        else:
-            branch = self.remote_branch
-
-        window = branchwin.BranchWindow(branch, branch.last_revision(), None, parent=self.window)
-        window.show()
-    
-    def on_menuitem_view_refresh_activate(self, widget):
-        """ View/Refresh menu handler. """
-        # Refresh the left pane
-        self.refresh_left()
-        # Refresh the right pane
-        self.refresh_right()
-   
-    def on_menuitem_view_show_hidden_files_activate(self, widget):
-        """ View/Show hidden files menu handler. """
-        self.pref.set_preference('dotted_files', widget.get_active())
-        if self.path is not None:
-            self.refresh_right()
-
-    def on_menuitem_view_show_ignored_files_activate(self, widget):
-        """ Hide/Show ignored files menu handler. """
-        self.pref.set_preference('ignored_files', widget.get_active())
-        if self.path is not None:
-            self.refresh_right()
-            
-    def on_treeview_left_button_press_event(self, widget, event):
-        """ Occurs when somebody right-clicks in the bookmark list. """
-        if event.button == 3:
-            # Don't show context with nothing selected
-            if self.get_selected_left() == None:
-                return
-
-            # Create a menu
-            from menu import OliveMenu
-            menu = OliveMenu(path=self.get_path(),
-                             selected=self.get_selected_left(),
-                             app=self)
-            
-            menu.left_context_menu().popup(None, None, None, 0,
-                                           event.time)
-
-    def on_treeview_left_button_release_event(self, widget, event):
-        """ Occurs when somebody just clicks a bookmark. """
-        if event.button != 3:
-            # Allow one-click bookmark opening
-            if self.get_selected_left() == None:
-                return
-            
-            newdir = self.get_selected_left()
-            if newdir == None:
-                return
-
-            if self.set_path(newdir):
-                self.refresh_right()
-
-    def on_treeview_left_row_activated(self, treeview, path, view_column):
-        """ Occurs when somebody double-clicks or enters an item in the
-        bookmark list. """
-
-        newdir = self.get_selected_left()
-        if newdir == None:
-            return
-
-        if self.set_path(newdir):
-            self.refresh_right()
-
-    def on_treeview_right_button_press_event(self, widget, event):
-        """ Occurs when somebody right-clicks in the file list. """
-        if event.button == 3:
-            # Create a menu
-            from menu import OliveMenu
-            menu = OliveMenu(path=self.get_path(),
-                             selected=self.get_selected_right(),
-                             app=self)
-            # get the menu items
-            m_open = menu.ui.get_widget('/context_right/open')
-            m_add = menu.ui.get_widget('/context_right/add')
-            m_remove = menu.ui.get_widget('/context_right/remove')
-            m_rename = menu.ui.get_widget('/context_right/rename')
-            m_revert = menu.ui.get_widget('/context_right/revert')
-            m_commit = menu.ui.get_widget('/context_right/commit')
-            m_annotate = menu.ui.get_widget('/context_right/annotate')
-            m_diff = menu.ui.get_widget('/context_right/diff')
-            # check if we're in a branch
-            try:
-                from bzrlib.branch import Branch
-                Branch.open_containing(self.get_path())
-                if self.remote:
-                    m_open.set_sensitive(False)
-                    m_add.set_sensitive(False)
-                    m_remove.set_sensitive(False)
-                    m_rename.set_sensitive(False)
-                    m_revert.set_sensitive(False)
-                    m_commit.set_sensitive(False)
-                    m_annotate.set_sensitive(False)
-                    m_diff.set_sensitive(False)
-                else:
-                    m_open.set_sensitive(True)
-                    m_add.set_sensitive(True)
-                    m_remove.set_sensitive(True)
-                    m_rename.set_sensitive(True)
-                    m_revert.set_sensitive(True)
-                    m_commit.set_sensitive(True)
-                    m_annotate.set_sensitive(True)
-                    m_diff.set_sensitive(True)
-            except bzrerrors.NotBranchError:
-                m_open.set_sensitive(True)
-                m_add.set_sensitive(False)
-                m_remove.set_sensitive(False)
-                m_rename.set_sensitive(False)
-                m_revert.set_sensitive(False)
-                m_commit.set_sensitive(False)
-                m_annotate.set_sensitive(False)
-                m_diff.set_sensitive(False)
-
-            if not self.remote:
-                menu.right_context_menu().popup(None, None, None, 0,
-                                                event.time)
-            else:
-                menu.remote_context_menu().popup(None, None, None, 0,
-                                                 event.time)
-        
-    def on_treeview_right_row_activated(self, treeview, path, view_column):
-        """ Occurs when somebody double-clicks or enters an item in the
-        file list. """
-        from launch import launch
-        
-        newdir = self.get_selected_right()
-        
-        if not self.remote:
-            # We're local
-            if newdir == '..':
-                self.set_path(os.path.split(self.get_path())[0])
-            else:
-                fullpath = os.path.join(self.get_path(), newdir)
-                if os.path.isdir(fullpath):
-                    # selected item is an existant directory
-                    self.set_path(fullpath)
-                else:
-                    launch(fullpath)
-        else:
-            # We're remote
-            if self._is_remote_dir(self.get_path() + newdir):
-                self.set_path(self.get_path() + newdir)
-        
-        self.refresh_right()
-    
-    def on_window_main_delete_event(self, widget, event=None):
-        """ Do some stuff before exiting. """
-        width, height = self.window_main.get_size()
-        self.pref.set_preference('window_width', width)
-        self.pref.set_preference('window_height', height)
-        x, y = self.window_main.get_position()
-        self.pref.set_preference('window_x', x)
-        self.pref.set_preference('window_y', y)
-        self.pref.set_preference('paned_position',
-                                 self.hpaned_main.get_position())
-        
-        self.pref.write()
-        self.window_main.destroy()
-        
-    def _load_left(self):
-        """ Load data into the left panel. (Bookmarks) """
-        # Create TreeStore
-        treestore = gtk.TreeStore(str, str)
-        
-        # Get bookmarks
-        bookmarks = self.pref.get_bookmarks()
-        
-        # Add them to the TreeStore
-        titer = treestore.append(None, [_i18n('Bookmarks'), None])
-        for item in bookmarks:
-            title = self.pref.get_bookmark_title(item)
-            treestore.append(titer, [title, item])
-        
-        # Create the column and add it to the TreeView
-        self.treeview_left.set_model(treestore)
-        tvcolumn_bookmark = gtk.TreeViewColumn(_i18n('Bookmark'))
-        self.treeview_left.append_column(tvcolumn_bookmark)
-        
-        # Set up the cells
-        cell = gtk.CellRendererText()
-        tvcolumn_bookmark.pack_start(cell, True)
-        tvcolumn_bookmark.add_attribute(cell, 'text', 0)
-        
-        # Expand the tree
-        self.treeview_left.expand_all()
-
-    def _load_right(self):
-        """ Load data into the right panel. (Filelist) """
-        # Create ListStore
-        # Model: [ icon, dir, name, status text, status, size (int), size (human), mtime (int), mtime (local), fileid ]
-        liststore = gtk.ListStore(gobject.TYPE_STRING,
-                                  gobject.TYPE_BOOLEAN,
-                                  gobject.TYPE_STRING,
-                                  gobject.TYPE_STRING,
-                                  gobject.TYPE_STRING,
-                                  gobject.TYPE_STRING,
-                                  gobject.TYPE_STRING,
-                                  gobject.TYPE_INT,
-                                  gobject.TYPE_STRING,
-                                  gobject.TYPE_STRING)
-        
-        dirs = []
-        files = []
-        
-        # Fill the appropriate lists
-        dotted_files = self.pref.get_preference('dotted_files', 'bool')
-        for item in os.listdir(self.path):
-            if not dotted_files and item[0] == '.':
-                continue
-            if os.path.isdir(self.path + os.sep + item):
-                dirs.append(item)
-            else:
-                files.append(item)
-        
-        if not self.notbranch:
-            branch = self.wt.branch
-            tree2 = self.wt.branch.repository.revision_tree(branch.last_revision())
-        
-            delta = self.wt.changes_from(tree2, want_unchanged=True)
-        
-        # Add'em to the ListStore
-        for item in dirs:
-            try:
-                statinfo = os.stat(self.path + os.sep + item)
-            except OSError, e:
-                if e.errno == 40:
-                    continue
-                else:
-                    raise
-            liststore.append([ gtk.STOCK_DIRECTORY,
-                               True,
-                               item,
-                               '',
-                               '',
-                               "<DIR>",
-                               "<DIR>",
-                               statinfo.st_mtime,
-                               self._format_date(statinfo.st_mtime),
-                               ''])
-        for item in files:
-            status = 'unknown'
-            fileid = ''
-            if not self.notbranch:
-                filename = self.wt.relpath(self.path + os.sep + item)
-                
-                try:
-                    self.wt.lock_read()
-                    
-                    for rpath, rpathnew, id, kind, text_modified, meta_modified in delta.renamed:
-                        if rpathnew == filename:
-                            status = 'renamed'
-                            fileid = id
-                    for rpath, id, kind in delta.added:
-                        if rpath == filename:
-                            status = 'added'
-                            fileid = id
-                    for rpath, id, kind in delta.removed:
-                        if rpath == filename:
-                            status = 'removed'
-                            fileid = id
-                    for rpath, id, kind, text_modified, meta_modified in delta.modified:
-                        if rpath == filename:
-                            status = 'modified'
-                            fileid = id
-                    for rpath, id, kind in delta.unchanged:
-                        if rpath == filename:
-                            status = 'unchanged'
-                            fileid = id
-                    for rpath, file_class, kind, id, entry in self.wt.list_files():
-                        if rpath == filename and file_class == 'I':
-                            status = 'ignored'
-                finally:
-                    self.wt.unlock()
-            
-            if status == 'renamed':
-                st = _i18n('renamed')
-            elif status == 'removed':
-                st = _i18n('removed')
-            elif status == 'added':
-                st = _i18n('added')
-            elif status == 'modified':
-                st = _i18n('modified')
-            elif status == 'unchanged':
-                st = _i18n('unchanged')
-            elif status == 'ignored':
-                st = _i18n('ignored')
-            else:
-                st = _i18n('unknown')
-            
-            try:
-                statinfo = os.stat(self.path + os.sep + item)
-            except OSError, e:
-                if e.errno == 40:
-                    continue
-                else:
-                    raise
-            liststore.append([gtk.STOCK_FILE,
-                              False,
-                              item,
-                              st,
-                              status,
-                              str(statinfo.st_size), # NOTE: if int used there it will fail for large files (size expressed as long int)
-                              self._format_size(statinfo.st_size),
-                              statinfo.st_mtime,
-                              self._format_date(statinfo.st_mtime),
-                              fileid])
-        
-        # Create the columns and add them to the TreeView
-        self.treeview_right.set_model(liststore)
-        self._tvcolumn_filename = gtk.TreeViewColumn(_i18n('Filename'))
-        self._tvcolumn_status = gtk.TreeViewColumn(_i18n('Status'))
-        self._tvcolumn_size = gtk.TreeViewColumn(_i18n('Size'))
-        self._tvcolumn_mtime = gtk.TreeViewColumn(_i18n('Last modified'))
-        self.treeview_right.append_column(self._tvcolumn_filename)
-        self.treeview_right.append_column(self._tvcolumn_status)
-        self.treeview_right.append_column(self._tvcolumn_size)
-        self.treeview_right.append_column(self._tvcolumn_mtime)
-        
-        # Set up the cells
-        cellpb = gtk.CellRendererPixbuf()
-        cell = gtk.CellRendererText()
-        self._tvcolumn_filename.pack_start(cellpb, False)
-        self._tvcolumn_filename.pack_start(cell, True)
-        self._tvcolumn_filename.set_attributes(cellpb, stock_id=0)
-        self._tvcolumn_filename.add_attribute(cell, 'text', 2)
-        self._tvcolumn_status.pack_start(cell, True)
-        self._tvcolumn_status.add_attribute(cell, 'text', 3)
-        self._tvcolumn_size.pack_start(cell, True)
-        self._tvcolumn_size.add_attribute(cell, 'text', 6)
-        self._tvcolumn_mtime.pack_start(cell, True)
-        self._tvcolumn_mtime.add_attribute(cell, 'text', 8)
-        
-        # Set up the properties of the TreeView
-        self.treeview_right.set_headers_visible(True)
-        self.treeview_right.set_headers_clickable(True)
-        self.treeview_right.set_search_column(1)
-        self._tvcolumn_filename.set_resizable(True)
-        self._tvcolumn_status.set_resizable(True)
-        self._tvcolumn_size.set_resizable(True)
-        self._tvcolumn_mtime.set_resizable(True)
-        # Set up sorting
-        liststore.set_sort_func(13, self._sort_filelist_callback, None)
-        liststore.set_sort_column_id(13, gtk.SORT_ASCENDING)
-        self._tvcolumn_filename.set_sort_column_id(13)
-        self._tvcolumn_status.set_sort_column_id(3)
-        self._tvcolumn_size.set_sort_column_id(5)
-        self._tvcolumn_mtime.set_sort_column_id(7)
-        
-        # Set sensitivity
-        self.set_sensitivity()
-        
-    def get_selected_fileid(self):
-        """ Get the file_id of the selected file. """
-        treeselection = self.treeview_right.get_selection()
-        (model, iter) = treeselection.get_selected()
-        
-        if iter is None:
-            return None
-        else:
-            return model.get_value(iter, 9)
-    
-    def get_selected_right(self):
-        """ Get the selected filename. """
-        treeselection = self.treeview_right.get_selection()
-        (model, iter) = treeselection.get_selected()
-        
-        if iter is None:
-            return None
-        else:
-            return model.get_value(iter, 2)
-    
-    def get_selected_left(self):
-        """ Get the selected bookmark. """
-        treeselection = self.treeview_left.get_selection()
-        (model, iter) = treeselection.get_selected()
-        
-        if iter is None:
-            return None
-        else:
-            return model.get_value(iter, 1)
-
-    def set_statusbar(self, message):
-        """ Set the statusbar message. """
-        self.statusbar.push(self.context_id, message)
-    
-    def clear_statusbar(self):
-        """ Clean the last message from the statusbar. """
-        self.statusbar.pop(self.context_id)
-    
-    def set_sensitivity(self):
-        """ Set menu and toolbar sensitivity. """
-        if not self.remote:
-            # We're local
-            self.menuitem_branch_init.set_sensitive(self.notbranch)
-            self.menuitem_branch_get.set_sensitive(self.notbranch)
-            self.menuitem_branch_checkout.set_sensitive(self.notbranch)
-            self.menuitem_branch_pull.set_sensitive(not self.notbranch)
-            self.menuitem_branch_push.set_sensitive(not self.notbranch)
-            self.menuitem_branch_update.set_sensitive(not self.notbranch)
-            self.menuitem_branch_revert.set_sensitive(not self.notbranch)
-            self.menuitem_branch_merge.set_sensitive(not self.notbranch)
-            self.menuitem_branch_commit.set_sensitive(not self.notbranch)
-            self.menuitem_branch_tags.set_sensitive(not self.notbranch)
-            self.menuitem_branch_status.set_sensitive(not self.notbranch)
-            self.menuitem_branch_missing.set_sensitive(not self.notbranch)
-            self.menuitem_branch_conflicts.set_sensitive(not self.notbranch)
-            self.menuitem_stats.set_sensitive(not self.notbranch)
-            self.menuitem_stats_diff.set_sensitive(not self.notbranch)
-            self.menuitem_add_files.set_sensitive(not self.notbranch)
-            self.menuitem_remove_files.set_sensitive(not self.notbranch)
-            self.menuitem_file_make_directory.set_sensitive(not self.notbranch)
-            self.menuitem_file_rename.set_sensitive(not self.notbranch)
-            self.menuitem_file_move.set_sensitive(not self.notbranch)
-            self.menuitem_file_annotate.set_sensitive(not self.notbranch)
-            #self.menutoolbutton_diff.set_sensitive(True)
-            self.toolbutton_diff.set_sensitive(not self.notbranch)
-            self.toolbutton_log.set_sensitive(not self.notbranch)
-            self.toolbutton_commit.set_sensitive(not self.notbranch)
-            self.toolbutton_pull.set_sensitive(not self.notbranch)
-            self.toolbutton_push.set_sensitive(not self.notbranch)
-            self.toolbutton_update.set_sensitive(not self.notbranch)
-        else:
-            # We're remote
-            self.menuitem_branch_init.set_sensitive(False)
-            self.menuitem_branch_get.set_sensitive(True)
-            self.menuitem_branch_checkout.set_sensitive(True)
-            self.menuitem_branch_pull.set_sensitive(False)
-            self.menuitem_branch_push.set_sensitive(False)
-            self.menuitem_branch_update.set_sensitive(False)
-            self.menuitem_branch_revert.set_sensitive(False)
-            self.menuitem_branch_merge.set_sensitive(False)
-            self.menuitem_branch_commit.set_sensitive(False)
-            self.menuitem_branch_tags.set_sensitive(True)
-            self.menuitem_branch_status.set_sensitive(False)
-            self.menuitem_branch_missing.set_sensitive(False)
-            self.menuitem_branch_conflicts.set_sensitive(False)
-            self.menuitem_stats.set_sensitive(True)
-            self.menuitem_stats_diff.set_sensitive(False)
-            self.menuitem_add_files.set_sensitive(False)
-            self.menuitem_remove_files.set_sensitive(False)
-            self.menuitem_file_make_directory.set_sensitive(False)
-            self.menuitem_file_rename.set_sensitive(False)
-            self.menuitem_file_move.set_sensitive(False)
-            self.menuitem_file_annotate.set_sensitive(False)
-            #self.menutoolbutton_diff.set_sensitive(True)
-            self.toolbutton_diff.set_sensitive(False)
-            self.toolbutton_log.set_sensitive(True)
-            self.toolbutton_commit.set_sensitive(False)
-            self.toolbutton_pull.set_sensitive(False)
-            self.toolbutton_push.set_sensitive(False)
-            self.toolbutton_update.set_sensitive(False)
-    
-    def refresh_left(self):
-        """ Refresh the bookmark list. """
-        
-        # Get TreeStore and clear it
-        treestore = self.treeview_left.get_model()
-        treestore.clear()
-
-        # Re-read preferences
-        self.pref.read()
-        
-        # Get bookmarks
-        bookmarks = self.pref.get_bookmarks()
-
-        # Add them to the TreeStore
-        titer = treestore.append(None, [_i18n('Bookmarks'), None])
-        for item in bookmarks:
-            title = self.pref.get_bookmark_title(item)
-            treestore.append(titer, [title, item])
-
-        # Add the TreeStore to the TreeView
-        self.treeview_left.set_model(treestore)
-
-        # Expand the tree
-        self.treeview_left.expand_all()
-
-    def refresh_right(self, path=None):
-        """ Refresh the file list. """
-        if not self.remote:
-            # We're local
-            from bzrlib.workingtree import WorkingTree
-    
-            if path is None:
-                path = self.get_path()
-    
-            # A workaround for double-clicking Bookmarks
-            if not os.path.exists(path):
-                return
-    
-            # Get ListStore and clear it
-            liststore = self.treeview_right.get_model()
-            liststore.clear()
-            
-            # Show Status column
-            self._tvcolumn_status.set_visible(True)
-    
-            dirs = []
-            files = []
-    
-            # Fill the appropriate lists
-            dotted_files = self.pref.get_preference('dotted_files', 'bool')
-            ignored_files = self.pref.get_preference('ignored_files', 'bool')
-
-            for item in os.listdir(path):
-                if not dotted_files and item[0] == '.':
-                    continue
-                if os.path.isdir(path + os.sep + item):
-                    dirs.append(item)
-                else:
-                    files.append(item)
-            
-            # Try to open the working tree
-            notbranch = False
-            try:
-                tree1 = WorkingTree.open_containing(path)[0]
-            except (bzrerrors.NotBranchError, bzrerrors.NoWorkingTree):
-                notbranch = True
-            
-            if not notbranch:
-                branch = tree1.branch
-                tree2 = tree1.branch.repository.revision_tree(branch.last_revision())
-            
-                delta = tree1.changes_from(tree2, want_unchanged=True)
-                
-            # Add'em to the ListStore
-            for item in dirs:
-                try:
-                    statinfo = os.stat(self.path + os.sep + item)
-                except OSError, e:
-                    if e.errno == 40:
-                        continue
-                    else:
-                        raise
-                liststore.append([gtk.STOCK_DIRECTORY,
-                                  True,
-                                  item,
-                                  '',
-                                  '',
-                                  "<DIR>",
-                                  "<DIR>",
-                                  statinfo.st_mtime,
-                                  self._format_date(statinfo.st_mtime),
-                                  ''])
-            for item in files:
-                status = 'unknown'
-                fileid = ''
-                if not notbranch:
-                    filename = tree1.relpath(path + os.sep + item)
-                    
-                    try:
-                        self.wt.lock_read()
-                        
-                        for rpath, rpathnew, id, kind, text_modified, meta_modified in delta.renamed:
-                            if rpathnew == filename:
-                                status = 'renamed'
-                                fileid = id
-                        for rpath, id, kind in delta.added:
-                            if rpath == filename:
-                                status = 'added'
-                                fileid = id
-                        for rpath, id, kind in delta.removed:
-                            if rpath == filename:
-                                status = 'removed'
-                                fileid = id
-                        for rpath, id, kind, text_modified, meta_modified in delta.modified:
-                            if rpath == filename:
-                                status = 'modified'
-                                fileid = id
-                        for rpath, id, kind in delta.unchanged:
-                            if rpath == filename:
-                                status = 'unchanged'
-                                fileid = id
-                        for rpath, file_class, kind, id, entry in self.wt.list_files():
-                            if rpath == filename and file_class == 'I':
-                                status = 'ignored'
-                    finally:
-                        self.wt.unlock()
-                
-                if status == 'renamed':
-                    st = _i18n('renamed')
-                elif status == 'removed':
-                    st = _i18n('removed')
-                elif status == 'added':
-                    st = _i18n('added')
-                elif status == 'modified':
-                    st = _i18n('modified')
-                elif status == 'unchanged':
-                    st = _i18n('unchanged')
-                elif status == 'ignored':
-                    st = _i18n('ignored')
-                    if not ignored_files:
-                        continue
-                else:
-                    st = _i18n('unknown')
-                
-                try:
-                    statinfo = os.stat(self.path + os.sep + item)
-                except OSError, e:
-                    if e.errno == 40:
-                        continue
-                    else:
-                        raise
-                liststore.append([gtk.STOCK_FILE,
-                                  False,
-                                  item,
-                                  st,
-                                  status,
-                                  str(statinfo.st_size),
-                                  self._format_size(statinfo.st_size),
-                                  statinfo.st_mtime,
-                                  self._format_date(statinfo.st_mtime),
-                                  fileid])
-        else:
-            # We're remote
-            
-            # Get ListStore and clear it
-            liststore = self.treeview_right.get_model()
-            liststore.clear()
-            
-            # Hide Status column
-            self._tvcolumn_status.set_visible(False)
-            
-            dirs = []
-            files = []
-            
-            self._show_stock_image(gtk.STOCK_REFRESH)
-            
-            for (name, type) in self.remote_entries:
-                if type.kind == 'directory':
-                    dirs.append(type)
-                elif type.kind == 'file':
-                    files.append(type)
-            
-            class HistoryCache:
-                """ Cache based on revision history. """
-                def __init__(self, history):
-                    self._history = history
-                
-                def _lookup_revision(self, revid):
-                    for r in self._history:
-                        if r.revision_id == revid:
-                            return r
-                    rev = repo.get_revision(revid)
-                    self._history.append(rev)
-                    return rev
-            
-            repo = self.remote_branch.repository
-            
-            revhistory = self.remote_branch.revision_history()
-            try:
-                revs = repo.get_revisions(revhistory)
-                cache = HistoryCache(revs)
-            except bzrerrors.InvalidHttpResponse:
-                # Fallback to dummy algorithm, because of LP: #115209
-                cache = HistoryCache([])
-            
-            for item in dirs:
-                if item.parent_id == self.remote_parent:
-                    rev = cache._lookup_revision(item.revision)
-                    liststore.append([ gtk.STOCK_DIRECTORY,
-                                       True,
-                                       item.name,
-                                       '',
-                                       '',
-                                       "<DIR>",
-                                       "<DIR>",
-                                       rev.timestamp,
-                                       self._format_date(rev.timestamp),
-                                       ''
-                                   ])
-                while gtk.events_pending():
-                    gtk.main_iteration()
-            
-            for item in files:
-                if item.parent_id == self.remote_parent:
-                    rev = cache._lookup_revision(item.revision)
-                    liststore.append([ gtk.STOCK_FILE,
-                                       False,
-                                       item.name,
-                                       '',
-                                       '',
-                                       str(item.text_size),
-                                       self._format_size(item.text_size),
-                                       rev.timestamp,
-                                       self._format_date(rev.timestamp),
-                                       item.file_id
-                                   ])
-                while gtk.events_pending():
-                    gtk.main_iteration()
-            
-            self.image_location_error.destroy()
-
-        # Columns should auto-size
-        self.treeview_right.columns_autosize()
-        
-        # Set sensitivity
-        self.set_sensitivity()
-
-    def _harddisks(self):
-        """ Returns hard drive letters under Win32. """
-        try:
-            import win32file
-            import string
-        except ImportError:
-            if sys.platform == 'win32':
-                print "pyWin32 modules needed to run Olive on Win32."
-                sys.exit(1)
-            else:
-                pass
-        
-        driveletters = []
-        for drive in string.ascii_uppercase:
-            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED:
-                driveletters.append(drive+':')
-        return driveletters
-    
-    def gen_hard_selector(self):
-        """ Generate the hard drive selector under Win32. """
-        drives = self._harddisks()
-        for drive in drives:
-            self.combobox_drive.append_text(drive)
-        self.combobox_drive.set_active(drives.index(os.getcwd()[0:2]))
-    
-    def _refresh_drives(self, combobox):
-        if self._just_started:
-            return
-        model = combobox.get_model()
-        active = combobox.get_active()
-        if active >= 0:
-            drive = model[active][0]
-            self.set_path(drive + '\\')
-            self.refresh_right(drive + '\\')
-    
-    def check_for_changes(self):
-        """ Check whether there were changes in the current working tree. """
-        old_tree = self.wt.branch.repository.revision_tree(self.wt.branch.last_revision())
-        delta = self.wt.changes_from(old_tree)
-
-        changes = False
-        
-        if len(delta.added) or len(delta.removed) or len(delta.renamed) or len(delta.modified):
-            changes = True
-        
-        return changes
-    
-    def _sort_filelist_callback(self, model, iter1, iter2, data):
-        """ The sort callback for the file list, return values:
-        -1: iter1 < iter2
-        0: iter1 = iter2
-        1: iter1 > iter2
-        """
-        name1 = model.get_value(iter1, 2)
-        name2 = model.get_value(iter2, 2)
-        
-        if model.get_value(iter1, 1):
-            # item1 is a directory
-            if not model.get_value(iter2, 1):
-                # item2 isn't
-                return -1
-            else:
-                # both of them are directories, we compare their names
-                if name1 < name2:
-                    return -1
-                elif name1 == name2:
-                    return 0
-                else:
-                    return 1
-        else:
-            # item1 is not a directory
-            if model.get_value(iter2, 1):
-                # item2 is
-                return 1
-            else:
-                # both of them are files, compare them
-                if name1 < name2:
-                    return -1
-                elif name1 == name2:
-                    return 0
-                else:
-                    return 1
-    
-    def _format_size(self, size):
-        """ Format size to a human readable format. """
-        if size < 1000:
-            return "%d[B]" % (size,)
-        size = size / 1000.0
-        
-        for metric in ["kB","MB","GB","TB"]:
-            if size < 1000:
-                break
-            size = size / 1000.0
-        return "%.1f[%s]" % (size,metric) 
-    
-    def _format_date(self, timestamp):
-        """ Format the time (given in secs) to a human readable format. """
-        return time.ctime(timestamp)
-    
-    def _is_remote_dir(self, location):
-        """ Determine whether the given location is a directory or not. """
-        if not self.remote:
-            # We're in local mode
-            return False
-        else:
-            branch, path = Branch.open_containing(location)
-            for (name, type) in self.remote_entries:
-                if name == path and type.kind == 'directory':
-                    # We got it
-                    return True
-            # Either it's not a directory or not in the inventory
-            return False
-    
-    def _show_stock_image(self, stock_id):
-        """ Show a stock image next to the location entry. """
-        self.image_location_error.destroy()
-        self.image_location_error = gtk.image_new_from_stock(stock_id, gtk.ICON_SIZE_BUTTON)
-        self.hbox_location.pack_start(self.image_location_error, False, False, 0)
-        if sys.platform == 'win32':
-            self.hbox_location.reorder_child(self.image_location_error, 2)
-        else:
-            self.hbox_location.reorder_child(self.image_location_error, 1)
-        self.image_location_error.show()
-        while gtk.events_pending():
-            gtk.main_iteration()
-
-import ConfigParser
-
-class Preferences:
-    """ A class which handles Olive's preferences. """
-    def __init__(self, path=None):
-        """ Initialize the Preferences class. """
-        # Some default options
-        self.defaults = { 'strict_commit' : False,
-                          'dotted_files'  : False,
-                          'ignored_files' : True,
-                          'window_width'  : 700,
-                          'window_height' : 400,
-                          'window_x'      : 40,
-                          'window_y'      : 40,
-                          'paned_position': 200 }
-
-        # Create a config parser object
-        self.config = ConfigParser.RawConfigParser()
-
-        # Set filename
-        if path is None:
-            if sys.platform == 'win32':
-                # Windows - no dotted files
-                self._filename = os.path.expanduser('~/olive.conf')
-            else:
-                self._filename = os.path.expanduser('~/.olive.conf')
-        else:
-            self._filename = path
-        
-        # Load the configuration
-        self.read()
-        
-    def _get_default(self, option):
-        """ Get the default option for a preference. """
-        try:
-            ret = self.defaults[option]
-        except KeyError:
-            return None
-        else:
-            return ret
-
-    def refresh(self):
-        """ Refresh the configuration. """
-        # First write out the changes
-        self.write()
-        # Then load the configuration again
-        self.read()
-
-    def read(self):
-        """ Just read the configuration. """
-        # Re-initialize the config parser object to avoid some bugs
-        self.config = ConfigParser.RawConfigParser()
-        self.config.read([self._filename])
-    
-    def write(self):
-        """ Write the configuration to the appropriate files. """
-        fp = open(self._filename, 'w')
-        self.config.write(fp)
-        fp.close()
-
-    def get_bookmarks(self):
-        """ Return the list of bookmarks. """
-        bookmarks = self.config.sections()
-        if self.config.has_section('preferences'):
-            bookmarks.remove('preferences')
-        return bookmarks
-
-    def add_bookmark(self, path):
-        """ Add bookmark. """
-        try:
-            self.config.add_section(path)
-        except ConfigParser.DuplicateSectionError:
-            return False
-        else:
-            return True
-
-    def get_bookmark_title(self, path):
-        """ Get bookmark title. """
-        try:
-            ret = self.config.get(path, 'title')
-        except ConfigParser.NoOptionError:
-            ret = path
-        
-        return ret
-    
-    def set_bookmark_title(self, path, title):
-        """ Set bookmark title. """
-        # FIXME: What if path isn't listed yet?
-        # FIXME: Canonicalize paths first?
-        self.config.set(path, 'title', title)
-    
-    def remove_bookmark(self, path):
-        """ Remove bookmark. """
-        return self.config.remove_section(path)
-
-    def set_preference(self, option, value):
-        """ Set the value of the given option. """
-        if value is True:
-            value = 'yes'
-        elif value is False:
-            value = 'no'
-        
-        if self.config.has_section('preferences'):
-            self.config.set('preferences', option, value)
-        else:
-            self.config.add_section('preferences')
-            self.config.set('preferences', option, value)
-
-    def get_preference(self, option, kind='str'):
-        """ Get the value of the given option.
-        
-        :param kind: str/bool/int/float. default: str
-        """
-        if self.config.has_option('preferences', option):
-            if kind == 'bool':
-                return self.config.getboolean('preferences', option)
-            elif kind == 'int':
-                return self.config.getint('preferences', option)
-            elif kind == 'float':
-                return self.config.getfloat('preferences', option)
-            else:
-                return self.config.get('preferences', option)
-        else:
-            try:
-                return self._get_default(option)
-            except KeyError:
-                return None
- 

=== removed file 'olive/add.py'
--- olive/add.py	2008-05-05 18:16:46 +0000
+++ olive/add.py	1970-01-01 00:00:00 +0000
@@ -1,94 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gtk
-import gtk.glade
-
-import bzrlib.add
-import bzrlib.errors as errors
-
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog
-from guifiles import GLADEFILENAME
-
-
-class OliveAdd:
-    """ Display the Add file(s) dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Add file(s) dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_add', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_add')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_add_add_clicked": self.add,
-                "on_button_add_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-
-        self.wt = wt
-        self.wtpath = wtpath
-        self.selected = selected
-
-    def display(self):
-        """ Display the Add file(s) dialog. """
-        self.window.show_all()
-        
-    def add(self, widget):
-        radio_selected = self.glade.get_widget('radiobutton_add_selected')
-        radio_unknown = self.glade.get_widget('radiobutton_add_unknown')
-        
-        if radio_selected.get_active():
-            # Add only the selected file
-            filename = self.selected
-            
-            if filename is None:
-                error_dialog(_i18n('No file was selected'),
-                             _i18n('Please select a file from the list,\nor choose the other option.'))
-                return
-            
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
-            try:
-                bzrlib.add.smart_add([fullpath])
-            except errors.NotBranchError:
-                error_dialog(_i18n('Directory is not a branch'),
-                             _i18n('You can perform this action only in a branch.'))
-                return
-        elif radio_unknown.get_active():
-            # Add unknown files recursively
-            fullpath = self.wt.abspath(self.wtpath)
-            
-            try:
-                bzrlib.add.smart_add([fullpath], True)
-            except errors.NotBranchError:
-                error_dialog(_i18n('Directory is not a branch'),
-                             _i18n('You can perform this action only in a branch.'))
-                return
-        
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()

=== removed file 'olive/bookmark.py'
--- olive/bookmark.py	2008-05-05 18:16:46 +0000
+++ olive/bookmark.py	1970-01-01 00:00:00 +0000
@@ -1,90 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gtk
-
-from olive import Preferences
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog
-
-
-class BookmarkDialog(gtk.Dialog):
-    """ This class wraps the old Bookmark window into a gtk.Dialog. """
-    
-    def __init__(self, selected, parent=None):
-        """ Initialize the Bookmark dialog. """
-        gtk.Dialog.__init__(self, title="Bookmarks - Olive",
-                                  parent=parent,
-                                  flags=0,
-                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
-        
-        self.pref = Preferences()
-        
-        # Get arguments
-        self.selected = selected
-        
-        # Create widgets
-        self._label_location = gtk.Label(_i18n("Location:"))
-        self._label_title = gtk.Label(_i18n("Title:"))
-        self._entry_location = gtk.Entry()
-        self._entry_title = gtk.Entry()
-        self._button_save = gtk.Button(stock=gtk.STOCK_SAVE)
-        
-        self._button_save.connect('clicked', self._on_save_clicked)
-        
-        # Set default values
-        self._entry_location.set_text(self.selected)
-        self._entry_location.set_sensitive(False)
-        self._entry_title.set_text(self.pref.get_bookmark_title(self.selected))
-        self._entry_title.set_flags(gtk.CAN_FOCUS | gtk.HAS_FOCUS)
-        
-        # Create a table and put widgets into it
-        self._table = gtk.Table(rows=2, columns=2)
-        self._table.attach(self._label_location, 0, 1, 0, 1)
-        self._table.attach(self._label_title, 0, 1, 1, 2)
-        self._table.attach(self._entry_location, 1, 2, 0, 1)
-        self._table.attach(self._entry_title, 1, 2, 1, 2)
-        
-        self._label_location.set_alignment(0, 0.5)
-        self._label_title.set_alignment(0, 0.5)
-        self._table.set_row_spacings(3)
-        self._table.set_col_spacings(3)
-        self.vbox.set_spacing(3)
-        
-        self.vbox.add(self._table)
-        
-        self.action_area.pack_end(self._button_save)
-        
-        self.vbox.show_all()
-        
-    def _on_save_clicked(self, button):
-        """ Save button clicked handler. """
-        if self._entry_title.get_text() == '':
-            error_dialog(_i18n('No title given'),
-                         _i18n('Please specify a title to continue.'))
-            return
-        
-        self.pref.set_bookmark_title(self._entry_location.get_text(),
-                                     self._entry_title.get_text())
-        self.pref.write()
-        
-        self.response(gtk.RESPONSE_OK)

=== removed file 'olive/guifiles.py'
--- olive/guifiles.py	2008-05-05 18:16:46 +0000
+++ olive/guifiles.py	1970-01-01 00:00:00 +0000
@@ -1,61 +0,0 @@
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-"""Glade file name"""
-
-import os
-import sys
-
-from bzrlib.plugins.gtk import _i18n
-
-GLADEFILENAMES = ["/usr/share/olive/olive.glade",
-                  "/usr/local/share/olive/olive.glade",
-                  "/opt/share/olive/olive.glade",
-                  "/opt/local/share/olive/olive.glade",
-                  "~/share/olive/olive.glade",
-                 ]
-
-# Get the glade file name
-if sys.platform == 'win32':
-    GLADEFILENAMES = [os.path.join(os.path.dirname(sys.executable),
-                                   "share/olive/olive.glade")]
-
-dir_ = os.path.split(os.path.dirname(__file__))[0]
-# Check first if we are running from source
-GLADEFILENAMES.insert(0, os.path.join(dir_, "olive.glade"))
-
-GLADEFILENAME = None
-
-for path in GLADEFILENAMES:
-    path = os.path.expanduser(path)
-    if os.path.isfile(path):
-        GLADEFILENAME = path
-        break
-
-if GLADEFILENAME is None:
-    # Fail
-    print _i18n('Glade file cannot be found.')
-    sys.exit(1)
-
-UIFILEDIR = os.path.dirname(GLADEFILENAME)
-
-# Get the cmenu.ui file name
-UIFILENAME = os.path.join(UIFILEDIR, 'cmenu.ui')
-
-if not os.path.isfile(UIFILENAME):
-    # Fail
-    print _i18n('UI description file cannot be found.')
-    sys.exit(1)
-
-

=== removed file 'olive/info.py'
--- olive/info.py	2008-05-05 18:16:46 +0000
+++ olive/info.py	1970-01-01 00:00:00 +0000
@@ -1,564 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gtk
-import gtk.glade
-
-import bzrlib.errors as errors
-
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog
-from guifiles import GLADEFILENAME
-
-
-def info(location):
-    """ Get info about branch, working tree, and repository
-    
-    :param location: the location of the branch/working tree/repository
-    
-    :return: the information in dictionary format
-    
-    The following informations are delivered (if available):
-    ret['location']['lightcoroot']: Light checkout root
-    ret['location']['sharedrepo']: Shared repository
-    ret['location']['repobranch']: Repository branch
-    ret['location']['cobranch']: Checkout of branch
-    ret['location']['repoco']: Repository checkout
-    ret['location']['coroot']: Checkout root
-    ret['location']['branchroot']: Branch root
-    ret['related']['parentbranch']: Parent branch
-    ret['related']['publishbranch']: Publish to branch
-    ret['format']['control']: Control format
-    ret['format']['workingtree']: Working tree format
-    ret['format']['branch']: Branch format
-    ret['format']['repository']: Repository format
-    ret['locking']['workingtree']: Working tree lock status
-    ret['locking']['branch']: Branch lock status
-    ret['locking']['repository']: Repository lock status
-    ret['missing']['branch']: Missing revisions in branch
-    ret['missing']['workingtree']: Missing revisions in working tree
-    ret['wtstats']['unchanged']: Unchanged files
-    ret['wtstats']['modified']: Modified files
-    ret['wtstats']['added']: Added files
-    ret['wtstats']['removed']: Removed files
-    ret['wtstats']['renamed']: Renamed files
-    ret['wtstats']['unknown']: Unknown files
-    ret['wtstats']['ignored']: Ingnored files
-    ret['wtstats']['subdirs']: Versioned subdirectories
-    ret['brstats']['revno']: Revisions in branch
-    ret['brstats']['commiters']: Number of commiters
-    ret['brstats']['age']: Age of branch in days
-    ret['brstats']['firstrev']: Time of first revision
-    ret['brstats']['lastrev']: Time of last revision
-    ret['repstats']['revisions']: Revisions in repository
-    ret['repstats']['size']: Size of repository in bytes
-    """
-    import bzrlib.bzrdir as bzrdir
-    
-    import info_helper
-    
-    ret = {}
-    try:
-        a_bzrdir = bzrdir.BzrDir.open_containing(location)[0]
-    except errors.NotBranchError:
-        raise errors.NotBranchError(location)
-
-    try:
-        working = a_bzrdir.open_workingtree()
-        working.lock_read()
-        try:
-            branch = working.branch
-            repository = branch.repository
-            control = working.bzrdir
-            
-            ret['location'] = info_helper.get_location_info(repository, branch, working)
-            ret['related'] = info_helper.get_related_info(branch)
-            ret['format'] = info_helper.get_format_info(control, repository, branch, working)
-            ret['locking'] = info_helper.get_locking_info(repository, branch, working)
-            ret['missing'] = {}
-            ret['missing']['branch'] = info_helper.get_missing_revisions_branch(branch)
-            ret['missing']['workingtree'] = info_helper.get_missing_revisions_working(working)
-            ret['wtstats'] = info_helper.get_working_stats(working)
-            ret['brstats'] = info_helper.get_branch_stats(branch)
-            ret['repstats'] = info_helper.get_repository_stats(repository)
-        finally:
-            working.unlock()
-            return ret
-        return
-    except (errors.NoWorkingTree, errors.NotLocalUrl):
-        pass
-
-    try:
-        branch = a_bzrdir.open_branch()
-        repository = branch.repository
-        control = a_bzrdir
-        branch.lock_read()
-        try:
-            ret['location'] = info_helper.get_location_info(repository, branch)
-            ret['related'] = info_helper.get_related_info(branch)
-            ret['format'] = info_helper.get_format_info(control, repository, branch)
-            ret['locking'] = info_helper.get_locking_info(repository, branch)
-            ret['missing']['branch'] = info_helper.get_missing_revisions_branch(branch)
-            ret['brstats'] = info_helper.get_branch_stats(branch)
-            ret['repstats'] = info_helper.get_repository_stats(repository)
-        finally:
-            branch.unlock()
-            return ret
-        return
-    except errors.NotBranchError:
-        pass
-
-    try:
-        repository = a_bzrdir.open_repository()
-        repository.lock_read()
-        try:
-            ret['location'] = info_helper.get_location_info(repository)
-            ret['format'] = info_helper.get_format_info(control, repository)
-            ret['locking'] = info_helper.get_locking_info(repository)
-            ret['repstats'] = info_helper.get_repository_stats(repository)
-        finally:
-            repository.unlock()
-            return ret
-        return
-    except errors.NoRepositoryPresent:
-        pass
-
-
-class OliveInfo:
-    """ Display Informations window and perform the needed actions. """
-    def __init__(self, branch):
-        """ Initialize the Informations window. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_info', 'olive-gtk')
-        
-        # Get the Informations window widget
-        self.window = self.glade.get_widget('window_info')
-        
-        # Check if current location is a branch
-        self.notbranch = False
-        try:
-            self.ret = info(branch.base)
-        except errors.NotBranchError:
-            self.notbranch = True
-            return
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_info_close_clicked": self.close,
-                "on_expander_info_location_activate": self.activate,
-                "on_expander_info_related_activate": self.activate,
-                "on_expander_info_format_activate": self.activate,
-                "on_expander_info_locking_activate": self.activate,
-                "on_expander_info_missing_activate": self.activate,
-                "on_expander_info_wtstats_activate": self.activate,
-                "on_expander_info_brstats_activate": self.activate,
-                "on_expander_info_repstats_activate": self.activate }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        # Generate status output
-        self._generate_info()
-
-    def _generate_info(self):
-        """ Generate 'bzr info' output. """
-        # location
-        if self.ret.has_key('location'):
-            display = False
-            e = self.glade.get_widget('expander_info_location')
-            if self.ret['location'].has_key('lightcoroot'):
-                ll = self.glade.get_widget('label_info_location_lightcoroot_label')
-                l = self.glade.get_widget('label_info_location_lightcoroot')
-                l.set_text(self.ret['location']['lightcoroot'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('sharedrepo'):
-                ll = self.glade.get_widget('label_info_location_sharedrepo_label')
-                l = self.glade.get_widget('label_info_location_sharedrepo')
-                l.set_text(self.ret['location']['sharedrepo'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('repobranch'):
-                ll = self.glade.get_widget('label_info_location_repobranch_label')
-                l = self.glade.get_widget('label_info_location_repobranch')
-                l.set_text(self.ret['location']['repobranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('cobranch'):
-                ll = self.glade.get_widget('label_info_location_cobranch_label')
-                l = self.glade.get_widget('label_info_location_cobranch')
-                l.set_text(self.ret['location']['cobranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('repoco'):
-                ll = self.glade.get_widget('label_info_location_repoco_label')
-                l = self.glade.get_widget('label_info_location_repoco')
-                l.set_text(self.ret['location']['repoco'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('coroot'):
-                ll = self.glade.get_widget('label_info_location_coroot_label')
-                l = self.glade.get_widget('label_info_location_coroot')
-                l.set_text(self.ret['location']['coroot'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['location'].has_key('branchroot'):
-                ll = self.glade.get_widget('label_info_location_branchroot_label')
-                l = self.glade.get_widget('label_info_location_branchroot')
-                l.set_text(self.ret['location']['branchroot'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # related
-        if self.ret.has_key('related'):
-            display = False
-            e = self.glade.get_widget('expander_info_related')
-            if self.ret['related'].has_key('parentbranch'):
-                ll = self.glade.get_widget('label_info_related_parentbranch_label')
-                l = self.glade.get_widget('label_info_related_parentbranch')
-                l.set_text(self.ret['related']['parentbranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['related'].has_key('publishbranch'):
-                ll = self.glade.get_widget('label_info_related_publishbranch_label')
-                l = self.glade.get_widget('label_info_related_publishbranch')
-                l.set_text(self.ret['related']['publishbranch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # format
-        if self.ret.has_key('format'):
-            display = False
-            e = self.glade.get_widget('expander_info_format')
-            if self.ret['format'].has_key('control'):
-                ll = self.glade.get_widget('label_info_format_control_label')
-                l = self.glade.get_widget('label_info_format_control')
-                l.set_text(self.ret['format']['control'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['format'].has_key('workingtree'):
-                ll = self.glade.get_widget('label_info_format_workingtree_label')
-                l = self.glade.get_widget('label_info_format_workingtree')
-                l.set_text(self.ret['format']['workingtree'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['format'].has_key('branch'):
-                ll = self.glade.get_widget('label_info_format_branch_label')
-                l = self.glade.get_widget('label_info_format_branch')
-                l.set_text(self.ret['format']['branch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['format'].has_key('repository'):
-                ll = self.glade.get_widget('label_info_format_repository_label')
-                l = self.glade.get_widget('label_info_format_repository')
-                l.set_text(self.ret['format']['repository'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # locking
-        if self.ret.has_key('locking'):
-            display = False
-            e = self.glade.get_widget('expander_info_locking')
-            if self.ret['locking'].has_key('workingtree'):
-                ll = self.glade.get_widget('label_info_locking_workingtree_label')
-                l = self.glade.get_widget('label_info_locking_workingtree')
-                l.set_text(self.ret['locking']['workingtree'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['locking'].has_key('branch'):
-                ll = self.glade.get_widget('label_info_locking_branch_label')
-                l = self.glade.get_widget('label_info_locking_branch')
-                l.set_text(self.ret['locking']['branch'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['locking'].has_key('repository'):
-                ll = self.glade.get_widget('label_info_locking_repository_label')
-                l = self.glade.get_widget('label_info_locking_repository')
-                l.set_text(self.ret['locking']['repository'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # missing - temporary disabled
-        """
-        if self.ret.has_key('missing'):
-            display = False
-            e = self.glade.get_widget('expander_info_missing')
-            if self.ret['missing'].has_key('branch'):
-                ll = self.glade.get_widget('label_info_missing_branch_label')
-                l = self.glade.get_widget('label_info_missing_branch')
-                l.set_text(self.ret['missing']['branch'])
-                ll.set_markup('<b>' + ll.get_text() + '</b>')
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['missing'].has_key('workingtree'):
-                ll = self.glade.get_widget('label_info_missing_workingtree_label')
-                l = self.glade.get_widget('label_info_missing_workingtree')
-                l.set_text(self.ret['missing']['branch'])
-                ll.set_markup('<b>' + ll.get_text() + '</b>')
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        """
-        # working tree stats
-        if self.ret.has_key('wtstats'):
-            display = False
-            e = self.glade.get_widget('expander_info_wtstats')
-            if self.ret['wtstats'].has_key('unchanged'):
-                ll = self.glade.get_widget('label_info_wtstats_unchanged_label')
-                l = self.glade.get_widget('label_info_wtstats_unchanged')
-                l.set_text(str(self.ret['wtstats']['unchanged']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('modified'):
-                ll = self.glade.get_widget('label_info_wtstats_modified_label')
-                l = self.glade.get_widget('label_info_wtstats_modified')
-                l.set_text(str(self.ret['wtstats']['modified']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('added'):
-                ll = self.glade.get_widget('label_info_wtstats_added_label')
-                l = self.glade.get_widget('label_info_wtstats_added')
-                l.set_text(str(self.ret['wtstats']['added']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('removed'):
-                ll = self.glade.get_widget('label_info_wtstats_removed_label')
-                l = self.glade.get_widget('label_info_wtstats_removed')
-                l.set_text(str(self.ret['wtstats']['removed']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('renamed'):
-                ll = self.glade.get_widget('label_info_wtstats_renamed_label')
-                l = self.glade.get_widget('label_info_wtstats_renamed')
-                l.set_text(str(self.ret['wtstats']['renamed']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('unknown'):
-                ll = self.glade.get_widget('label_info_wtstats_unknown_label')
-                l = self.glade.get_widget('label_info_wtstats_unknown')
-                l.set_text(str(self.ret['wtstats']['unknown']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('ignored'):
-                ll = self.glade.get_widget('label_info_wtstats_ignored_label')
-                l = self.glade.get_widget('label_info_wtstats_ignored')
-                l.set_text(str(self.ret['wtstats']['ignored']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['wtstats'].has_key('subdirs'):
-                ll = self.glade.get_widget('label_info_wtstats_subdirs_label')
-                l = self.glade.get_widget('label_info_wtstats_subdirs')
-                l.set_text(str(self.ret['wtstats']['subdirs']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # branch stats
-        if self.ret.has_key('brstats'):
-            display = False
-            e = self.glade.get_widget('expander_info_brstats')
-            if self.ret['brstats'].has_key('revno'):
-                ll = self.glade.get_widget('label_info_brstats_revno_label')
-                l = self.glade.get_widget('label_info_brstats_revno')
-                l.set_text(str(self.ret['brstats']['revno']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('commiters'):
-                ll = self.glade.get_widget('label_info_brstats_commiters_label')
-                l = self.glade.get_widget('label_info_brstats_commiters')
-                l.set_text(str(self.ret['brstats']['commiters']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('age'):
-                ll = self.glade.get_widget('label_info_brstats_age_label')
-                l = self.glade.get_widget('label_info_brstats_age')
-                l.set_text('%d days' % self.ret['brstats']['age'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('firstrev'):
-                ll = self.glade.get_widget('label_info_brstats_firstrev_label')
-                l = self.glade.get_widget('label_info_brstats_firstrev')
-                l.set_text(self.ret['brstats']['firstrev'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['brstats'].has_key('lastrev'):
-                ll = self.glade.get_widget('label_info_brstats_lastrev_label')
-                l = self.glade.get_widget('label_info_brstats_lastrev')
-                l.set_text(self.ret['brstats']['lastrev'])
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-        # repository stats
-        if self.ret.has_key('repstats'):
-            display = False
-            e = self.glade.get_widget('expander_info_repstats')
-            if self.ret['repstats'].has_key('revisions'):
-                ll = self.glade.get_widget('label_info_repstats_revisions_label')
-                l = self.glade.get_widget('label_info_repstats_revisions')
-                l.set_text(str(self.ret['repstats']['revisions']))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-            if self.ret['repstats'].has_key('size'):
-                ll = self.glade.get_widget('label_info_repstats_size_label')
-                l = self.glade.get_widget('label_info_repstats_size')
-                l.set_text('%d KiB' % (self.ret['repstats']['size'] / 1024))
-                ll.show()
-                l.show()
-                if not display:
-                    e.set_expanded(True)
-                    e.show()
-                    display = True
-    
-    def activate(self, expander):
-        """ Redraw the window. """
-        self.window.resize(50, 50)
-        self.window.queue_resize()
-    
-    def display(self):
-        """ Display the Informations window. """
-        if self.notbranch:
-            error_dialog(_i18n('Directory is not a branch'),
-                         _i18n('You can perform this action only in a branch.'))
-            self.close()
-        else:
-            self.window.show()
-
-    def close(self, widget=None):
-        self.window.destroy()

=== removed file 'olive/info_helper.py'
--- olive/info_helper.py	2007-08-12 21:14:51 +0000
+++ olive/info_helper.py	1970-01-01 00:00:00 +0000
@@ -1,324 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-# Some parts of the code are:
-# Copyright (C) 2005, 2006 by Canonical Ltd
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import time
-
-import bzrlib
-
-from bzrlib import (
-    bzrdir,
-    diff,
-    errors,
-    osutils,
-    urlutils,
-    )
-
-from bzrlib.missing import find_unmerged
-
-def _repo_rel_url(repo_url, inner_url):
-    """Return path with common prefix of repository path removed.
-
-    If path is not part of the repository, the original path is returned.
-    If path is equal to the repository, the current directory marker '.' is
-    returned.
-    Otherwise, a relative path is returned, with trailing '/' stripped.
-    """
-    inner_url = urlutils.normalize_url(inner_url)
-    repo_url = urlutils.normalize_url(repo_url)
-    if inner_url == repo_url:
-        return '.'
-    result = urlutils.relative_url(repo_url, inner_url)
-    if result != inner_url:
-        result = result.rstrip('/')
-    return result
-
-def get_location_info(repository, branch=None, working=None):
-    """ Get known locations for working, branch and repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    repository_path = repository.bzrdir.root_transport.base
-    if working and branch:
-        working_path = working.bzrdir.root_transport.base
-        branch_path = branch.bzrdir.root_transport.base
-        if working_path != branch_path:
-            # lightweight checkout
-            ret['lightcoroot'] = working_path
-            if repository.is_shared():
-                # lightweight checkout of branch in shared repository
-                ret['sharedrepo'] = repository_path
-                ret['repobranch'] = _repo_rel_url(repository_path, branch_path)
-            else:
-                # lightweight checkout of standalone branch
-                ret['cobranch'] = branch_path
-        elif repository.is_shared():
-            # branch with tree inside shared repository
-            ret['sharedrepo'] = repository_path
-            ret['repoco'] = _repo_rel_url(repository_path, branch_path)
-        elif branch.get_bound_location():
-            # normal checkout
-            ret['coroot'] = working_path
-            ret['cobranch'] = branch.get_bound_location()
-        else:
-            # standalone
-            ret['branchroot'] = working_path
-    elif branch:
-        branch_path = branch.bzrdir.root_transport.base
-        if repository.is_shared():
-            # branch is part of shared repository
-            ret['sharedrepo'] = repository_path
-            ret['repobranch'] = _repo_rel_url(repository_path, branch_path)
-        else:
-            # standalone branch
-            ret['branchroot'] = branch_path
-    else:
-        # shared repository
-        assert repository.is_shared()
-        ret['sharedrepo'] = repository_path
-    
-    return ret
-
-def get_related_info(branch):
-    """ Get parent and push location of branch.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if branch.get_parent() or branch.get_push_location():
-        if branch.get_parent():
-            ret['parentbranch'] = branch.get_parent()
-        if branch.get_push_location():
-            ret['publishbranch'] = branch.get_push_location()
-    
-    return ret
-
-
-def get_format_info(control=None, repository=None, branch=None, working=None):
-    """ Get known formats for control, working, branch and repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if control:
-        ret['control'] = control._format.get_format_description()
-    if working:
-        ret['workingtree'] = working._format.get_format_description()
-    if branch:
-        ret['branch'] = branch._format.get_format_description()
-    if repository:
-        ret['repository'] = repository._format.get_format_description()
-    
-    return ret
-
-
-def get_locking_info(repository, branch=None, working=None):
-    """ Get locking status of working, branch and repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if (repository.get_physical_lock_status() or
-        (branch and branch.get_physical_lock_status()) or
-        (working and working.get_physical_lock_status())):
-        if working:
-            if working.get_physical_lock_status():
-                status = 'locked'
-            else:
-                status = 'unlocked'
-            ret['workingtree'] = status
-        if branch:
-            if branch.get_physical_lock_status():
-                status = 'locked'
-            else:
-                status = 'unlocked'
-            ret['branch'] = status
-        if repository:
-            if repository.get_physical_lock_status():
-                status = 'locked'
-            else:
-                status = 'unlocked'
-            ret['repository'] = status
-    
-    return ret
-
-def get_missing_revisions_branch(branch):
-    """ Get missing master revisions in branch.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    # Try with inaccessible branch ?
-    master = branch.get_master_branch()
-    if master:
-        local_extra, remote_extra = find_unmerged(branch, master)
-        if remote_extra:
-            ret = len(remote_extra)
-    
-    return ret
-
-
-def get_missing_revisions_working(working):
-    """ Get missing revisions in working tree.
-    
-    :return: a dictionary containing the needed infos
-    """
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        # function deprecated after 0.9
-        from bzrlib.delta import compare_trees
-
-    ret = {}
-    branch = working.branch
-    basis = working.basis_tree()
-
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        delta = compare_trees(basis, working, want_unchanged=True)
-    else:
-        delta = working.changes_from(basis, want_unchanged=True)
-
-    history = branch.revision_history()
-    tree_last_id = working.last_revision()
-
-    if len(history) and tree_last_id != history[-1]:
-        tree_last_revno = branch.revision_id_to_revno(tree_last_id)
-        missing_count = len(history) - tree_last_revno
-        ret = missing_count
-    
-    return ret
-
-
-def get_working_stats(working):
-    """ Get statistics about a working tree.
-    
-    :return: a dictionary containing the needed infos
-    """
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        # function deprecated after 0.9
-        from bzrlib.delta import compare_trees
-    
-    ret = {}
-    basis = working.basis_tree()
-
-    if (bzrlib.version_info[0] == 0) and (bzrlib.version_info[1] < 9):
-        delta = compare_trees(basis, working, want_unchanged=True)
-    else:
-        delta = working.changes_from(basis, want_unchanged=True)
-
-    ret['unchanged'] = len(delta.unchanged)
-    ret['modified'] = len(delta.modified)
-    ret['added'] = len(delta.added)
-    ret['removed'] = len(delta.removed)
-    ret['renamed'] = len(delta.renamed)
-
-    ignore_cnt = unknown_cnt = 0
-    for path in working.extras():
-        if working.is_ignored(path):
-            ignore_cnt += 1
-        else:
-            unknown_cnt += 1
-    ret['unknown'] = unknown_cnt
-    ret['ignored'] = ignore_cnt
-
-    dir_cnt = 0
-    for path, ie in working.iter_entries_by_dir():
-        if ie.kind == 'directory':
-            dir_cnt += 1
-    ret['subdirs'] = dir_cnt
-
-    return ret
-
-def get_branch_stats(branch):
-    """ Get statistics about a branch.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    repository = branch.repository
-    history = branch.revision_history()
-
-    revno = len(history)
-    ret['revno'] = revno 
-    committers = {}
-    for rev in history:
-        committers[repository.get_revision(rev).committer] = True
-    ret['commiters'] = len(committers)
-    if revno > 0:
-        firstrev = repository.get_revision(history[0])
-        age = int((time.time() - firstrev.timestamp) / 3600 / 24)
-        ret['age'] = age
-        ret['firstrev'] = osutils.format_date(firstrev.timestamp,
-                                              firstrev.timezone)
-
-        lastrev = repository.get_revision(history[-1])
-        ret['lastrev'] = osutils.format_date(lastrev.timestamp,
-                                             lastrev.timezone)
-
-    return ret
-
-def get_repository_stats(repository):
-    """ Get statistics about a repository.
-    
-    :return: a dictionary containing the needed infos
-    """
-    ret = {}
-    if repository.bzrdir.root_transport.listable():
-        c, t = repository._revision_store.total_size(repository.get_transaction())
-        ret['revisions'] = c
-        ret['size'] = t
-
-    return ret
-
-def diff_helper(tree, specific_files, external_diff_options, 
-                    old_revision_spec=None, new_revision_spec=None,
-                    old_label='a/', new_label='b/', output=None):
-    """ Helper for diff.
-
-    :param tree: a WorkingTree
-
-    :param specific_files: the specific files to compare, or None
-
-    :param external_diff_options: if non-None, run an external diff, and pass it these options
-
-    :param old_revision_spec: if None, use basis tree as old revision, otherwise use the tree for the specified revision. 
-
-    :param new_revision_spec:  if None, use working tree as new revision, otherwise use the tree for the specified revision.
-    """
-    import sys
-    
-    from bzrlib.diff import show_diff_trees
-    
-    if output == None:
-        output = sys.stdout
-    
-    def spec_tree(spec):
-        revision_id = spec.in_store(tree.branch).rev_id
-        return tree.branch.repository.revision_tree(revision_id)
-    
-    if old_revision_spec is None:
-        old_tree = tree.basis_tree()
-    else:
-        old_tree = spec_tree(old_revision_spec)
-
-    if new_revision_spec is None:
-        new_tree = tree
-    else:
-        new_tree = spec_tree(new_revision_spec)
-
-    return show_diff_trees(old_tree, new_tree, output, specific_files,
-                           external_diff_options,
-                           old_label=old_label, new_label=new_label)

=== removed file 'olive/launch.py'
--- olive/launch.py	2006-09-30 13:04:15 +0000
+++ olive/launch.py	1970-01-01 00:00:00 +0000
@@ -1,54 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import sys
-import os
-
-def launch(path):
-    """ Launch program associated with path """
-
-    # Normalize filepath
-    normpath = os.path.normpath(path) 
-    
-    if sys.platform == 'win32':
-        # Windows is easy
-        os.startfile(normpath)
-    else:
-        # Maybe Gnome?
-        exe = search_exe('gnome-open')
-        if exe != None:
-            os.system("gnome-open %s" % normpath)
-            return
-        # Maybe KDE?
-        exe = search_exe('kfmclient')
-        if exe != None:
-            os.system("kfmclient exec file:%s" % normpath)
-            return
-
-        # TODO: support other platforms
-        print "DEBUG: file launch not supported on this platform."
-
-def search_exe(exe):
-    """ Search for given executable. """
-    found = 0
-    paths = os.environ['PATH'].split(os.pathsep)
-    for path in paths:
-        if os.path.exists(os.path.join(path,exe)):
-            found = 1
-            break
-    if found:
-        return True
-    return None

=== removed file 'olive/menu.py'
--- olive/menu.py	2008-05-05 18:18:08 +0000
+++ olive/menu.py	1970-01-01 00:00:00 +0000
@@ -1,380 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-import os.path
-import shutil
-import sys
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gtk
-
-import bzrlib.errors as errors
-from bzrlib.workingtree import WorkingTree
-
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, question_dialog, warning_dialog
-from bzrlib.plugins.gtk.errors import show_bzr_error
-from bzrlib.plugins.gtk.annotate.gannotate import GAnnotateWindow
-from bzrlib.plugins.gtk.annotate.config import GAnnotateConfig
-from bzrlib.plugins.gtk.diff import DiffWindow
-from launch import launch
-from bzrlib.plugins.gtk.olive import Preferences
-
-class OliveMenu:
-    """ This class is responsible for building the context menus. """
-    def __init__(self, path, selected, app=None):
-        # Load the UI file
-        from guifiles import UIFILENAME
-
-        self.uifile = UIFILENAME
-
-        # Preferences handler
-        self.pref = Preferences()
-        
-        # Set default values
-        self.path = path
-        self.selected = selected
-        self.app = app
-        
-        # Create the file list context menu
-        self.ui = gtk.UIManager()
-        
-        self.actiongroup = gtk.ActionGroup('context')
-        self.actiongroup.add_actions([('add', gtk.STOCK_ADD,
-                                       _i18n('Add'), None,
-                                       _i18n('Add the selected file'),
-                                       self.add_file),
-                                      ('remove', gtk.STOCK_REMOVE,
-                                       _i18n('Remove'), None,
-                                       _i18n('Remove the selected file'),
-                                       self.remove_file),
-                                      ('remove_and_delete', gtk.STOCK_REMOVE,
-                                       _i18n('Remove and delete'), None,
-                                       _i18n('Remove the selected file/dir and delete from disk'),
-                                       self.remove_and_delete_file),
-                                      ('rename', None,
-                                       _i18n('Rename'), None,
-                                       _i18n('Rename the selected file'),
-                                       self.rename_file),
-                                      ('open', gtk.STOCK_OPEN,
-                                       _i18n('Open'), None,
-                                       _i18n('Open the selected file'),
-                                       self.open_file),
-                                      ('revert', None,
-                                       _i18n('Revert'), None,
-                                       _i18n('Revert the changes'),
-                                       self.revert),
-                                      ('commit', None,
-                                       _i18n('Commit'), None,
-                                       _i18n('Commit the changes'),
-                                       self.commit),
-                                      ('annotate', None,
-                                       _i18n('Annotate'), None,
-                                       _i18n('Annotate the selected file'),
-                                       self.annotate),
-                                      ('diff', None,
-                                       _i18n('Diff'), None,
-                                       _i18n('Show the diff of the file'),
-                                       self.diff),
-                                      ('bookmark', None,
-                                       _i18n('Bookmark'), None,
-                                       _i18n('Bookmark current location'),
-                                       self.bookmark),
-                                      ('edit_bookmark', gtk.STOCK_EDIT,
-                                       _i18n('Edit'), None,
-                                       _i18n('Edit the selected bookmark'),
-                                       self.edit_bookmark),
-                                      ('remove_bookmark', gtk.STOCK_REMOVE,
-                                       _i18n('Remove'), None,
-                                       _i18n('Remove the selected bookmark'),
-                                       self.remove_bookmark),
-                                      ('open_folder', gtk.STOCK_OPEN,
-                                       _i18n('Open Folder'), None,
-                                       _i18n('Open bookmark folder in Nautilus'),
-                                       self.open_folder),
-                                      ('diff_selected', None,
-                                       _i18n('Selected...'), None,
-                                       _i18n('Show the differences of the selected file'),
-                                       self.diff_selected),
-                                      ('diff_all', None,
-                                       _i18n('All...'), None,
-                                       _i18n('Show the differences of all files'),
-                                       self.diff_all),
-                                      ('view_remote', None,
-                                       _i18n('View contents'), None,
-                                       _i18n('View the contents of the file in a builtin viewer'),
-                                       self.view_remote),
-                                      ('diff_remote', None,
-                                       _i18n('Show differences'), None,
-                                       _i18n('Show the differences between two revisions of the file'),
-                                       self.diff_remote),
-                                      ('revert_remote', None,
-                                       _i18n('Revert to this revision'), None,
-                                       _i18n('Revert the selected file to the selected revision'),
-                                       self.revert_remote)
-                                     ])
-        
-        self.ui.insert_action_group(self.actiongroup, 0)
-        self.ui.add_ui_from_file(self.uifile)
-        
-        self.cmenu_right = self.ui.get_widget('/context_right')
-        self.cmenu_left = self.ui.get_widget('/context_left')
-        self.toolbar_diff = self.ui.get_widget('/toolbar_diff')
-        self.cmenu_remote = self.ui.get_widget('/context_remote')
-        
-        # Set icons
-        # TODO: do it without using deprecated comm
-        #commit_menu = self.ui.get_widget('/context_right/commit')
-        #commit_image = self.comm.menuitem_branch_commit.get_image()
-        #commit_pixbuf = commit_image.get_pixbuf()
-        #commit_icon = gtk.Image()
-        #commit_icon.set_from_pixbuf(commit_pixbuf)
-        #commit_menu.set_image(commit_icon)
-        #diff_menu = self.ui.get_widget('/context_right/diff')
-        #diff_image = self.comm.menuitem_stats_diff.get_image()
-        #diff_pixbuf = diff_image.get_pixbuf()
-        #diff_icon = gtk.Image()
-        #diff_icon.set_from_pixbuf(diff_pixbuf)
-        #diff_menu.set_image(diff_icon)
-
-    def right_context_menu(self):
-        return self.cmenu_right
-    
-    def left_context_menu(self):
-        return self.cmenu_left
-    
-    def remote_context_menu(self):
-        return self.cmenu_remote
-    
-    @show_bzr_error
-    def add_file(self, action):
-        """ Right context menu -> Add """
-        import bzrlib.add
-        
-        # Add only the selected file
-        directory = self.path
-        filename = self.selected
-            
-        if filename is None:
-            error_dialog(_i18n('No file was selected'),
-                         _i18n('Please select a file from the list,\nor choose the other option.'))
-            return
-        
-        bzrlib.add.smart_add([os.path.join(directory, filename)])
-    
-    @show_bzr_error
-    def annotate(self, action):
-        """ Right context menu -> Annotate """
-        directory = self.path
-        filename = self.selected
-        
-        if filename is None:
-            error_dialog(_i18n('No file was selected'),
-                         _i18n('Please select a file from the list.'))
-            return
-        
-        wt, path = WorkingTree.open_containing(os.path.join(directory, filename))
-        
-        branch = wt.branch
-        file_id = wt.path2id(wt.relpath(os.path.join(directory, filename)))
-        
-        window = GAnnotateWindow(all=False, plain=False, parent=self.app)
-        window.set_title(os.path.join(directory, filename) + " - Annotate")
-        config = GAnnotateConfig(window)
-        window.show()
-        branch.lock_read()
-        try:
-            window.annotate(wt, branch, file_id)
-        finally:
-            branch.unlock()
-    
-    @show_bzr_error
-    def remove_file(self, action,delete_on_disk=0):
-        """ Right context menu -> Remove """
-        # Remove only the selected file
-        directory = self.path
-        filename = self.selected
-        
-        if filename is None:
-            error_dialog(_i18n('No file was selected'),
-                         _i18n('Please select a file from the list,\nor choose the other option.'))
-            return
-        
-        wt, path = WorkingTree.open_containing(os.path.join(directory, filename))
-        wt.remove(path)
-        
-        if delete_on_disk:
-            abs_filename = os.path.join(directory,filename)
-            if os.path.isdir(abs_filename):
-                response = question_dialog(_i18n('Delete directory with all directories below ?'), abs_filename )
-                if response == gtk.RESPONSE_YES:
-                    shutil.rmtree(abs_filename)
-            else:
-                os.remove(abs_filename)
-                
-        self.app.set_path(self.path)
-        self.app.refresh_right()
-        
-    def remove_and_delete_file(self, action):
-        """ Right context menu -> Remove and delete"""
-        self.remove_file(action,delete_on_disk=1)
-
-    def rename_file(self, action):
-        """ Right context menu -> Rename """
-        from rename import OliveRename
-        wt = WorkingTree.open_containing(self.path + os.sep + self.selected)[0]
-        rename = OliveRename(wt, wt.relpath(self.path), self.selected)
-        rename.display()
-    
-    def open_file(self, action):
-        """ Right context menu -> Open """
-        # Open only the selected file
-        filename = self.selected
-        
-        if filename is None:
-            error_dialog(_i18n('No file was selected'),
-                         _i18n('Please select a file from the list,\nor choose the other option.'))
-            return
-
-        if filename == '..':
-            # TODO: how to enter a directory?
-            return
-        else:
-            fullpath = self.path + os.sep + filename
-            if os.path.isdir(fullpath):
-                # selected item is an existant directory
-                # TODO: how to enter a directory?
-                return
-            else:
-                launch(fullpath) 
-
-    def revert(self, action):
-        """ Right context menu -> Revert """
-        wt, path = WorkingTree.open_containing(self.path)
-        ret = wt.revert([os.path.join(path, self.selected)])
-        if ret:
-            warning_dialog(_i18n('Conflicts detected'),
-                           _i18n('Please have a look at the working tree before continuing.'))
-        else:
-            info_dialog(_i18n('Revert successful'),
-                        _i18n('All files reverted to last revision.'))
-        self.app.refresh_right()       
-    
-    def commit(self, action):
-        """ Right context menu -> Commit """
-        from commit import CommitDialog
-        branch = None
-        try:
-            wt, path = WorkingTree.open_containing(self.path)
-            branch = wt.branch
-        except NotBranchError, e:
-            path = e.path
-        
-        if self.selected:
-            selected = os.path.join(path, self.selected)
-        else:
-            selected = None
-        commit = CommitDialog(wt=wt, selected=selected, parent=None)
-        response = commit.run()
-        if response != gtk.RESPONSE_NONE:
-            commit.hide()
-        
-            if response == gtk.RESPONSE_OK:
-                self.app.refresh_right()
-            
-            commit.destroy()
-    
-    @show_bzr_error
-    def diff(self, action):
-        """ Right context menu -> Diff """
-        wt = WorkingTree.open_containing(self.path)[0]
-        window = DiffWindow(self.app)
-        parent_tree = wt.branch.repository.revision_tree(wt.branch.last_revision())
-        window.set_diff(wt.branch.nick, wt, parent_tree)
-        window.set_file(wt.relpath(self.path + os.sep + self.selected))
-        window.show()
-    
-    def bookmark(self, action):
-        """ Right context menu -> Bookmark """
-        if self.pref.add_bookmark(self.path):
-            info_dialog(_i18n('Bookmark successfully added'),
-                        _i18n('The current directory was bookmarked. You can reach\nit by selecting it from the left panel.'))
-            self.pref.write()
-        else:
-            warning_dialog(_i18n('Location already bookmarked'),
-                           _i18n('The current directory is already bookmarked.\nSee the left panel for reference.'))
-        
-        self.app.refresh_left()
-
-    def edit_bookmark(self, action):
-        """ Left context menu -> Edit """
-        from bookmark import BookmarkDialog
-        
-        if self.selected != None:
-            bookmark = BookmarkDialog(self.selected, self.app.window)
-            response = bookmark.run()
-            
-            if response != gtk.RESPONSE_NONE:
-                bookmark.hide()
-        
-                if response == gtk.RESPONSE_OK:
-                    self.app.refresh_left()
-            
-                bookmark.destroy()
-
-    def remove_bookmark(self, action):
-        """ Left context menu -> Remove """
-        
-        if self.selected != None:
-            self.pref.remove_bookmark(self.selected)
-            self.pref.write()
-        
-        self.app.refresh_left()
-    
-    def open_folder(self, action):
-        """ Left context menu -> Open Folder """
-        path = self.selected
-
-        if path != None:
-            launch(path)
-    
-    def diff_selected(self, action):
-        """ Diff toolbutton -> Selected... """
-        print "DEBUG: not implemented."
-    
-    def diff_all(self, action):
-        """ Diff toolbutton -> All... """
-        from diff import OliveDiff
-        diff = OliveDiff(self.comm)
-        diff.display()
-    
-    def view_remote(self, action):
-        """ Remote context menu -> View contents """
-        print "DEBUG: view contents."
-    
-    def diff_remote(self, action):
-        """ Remote context menu -> Show differences """
-        print "DEBUG: show differences."
-    
-    def revert_remote(self, action):
-        """ Remote context menu -> Revert to this revision """
-        print "DEBUG: revert to this revision."

=== removed file 'olive/mkdir.py'
--- olive/mkdir.py	2008-05-05 18:16:46 +0000
+++ olive/mkdir.py	1970-01-01 00:00:00 +0000
@@ -1,97 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gtk
-import gtk.glade
-
-import bzrlib.errors as errors
-
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog, warning_dialog
-from guifiles import GLADEFILENAME
-
-from bzrlib.plugins.gtk.errors import show_bzr_error
-
-
-class OliveMkdir:
-    """ Display the Make directory dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath):
-        """ Initialize the Make directory dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_mkdir', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_mkdir')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_mkdir_mkdir_clicked": self.mkdir,
-                "on_button_mkdir_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        self.wt = wt
-        self.wtpath = wtpath
-
-    def display(self):
-        """ Display the Make directory dialog. """
-        self.window.show_all()
-
-    @show_bzr_error
-    def mkdir(self, widget):
-        # Get the widgets
-        entry = self.glade.get_widget('entry_mkdir')
-        checkbox = self.glade.get_widget('checkbutton_mkdir_versioned')
-        
-        dirname = entry.get_text()
-        
-        if dirname == "":
-            error_dialog(_i18n('No directory name given'),
-                         _i18n('Please specify a desired name for the new directory.'))
-            return
-        
-        if checkbox.get_active():
-            # Want to create a versioned directory
-            try:
-                os.mkdir(os.path.join(self.wt.basedir, self.wtpath, dirname))
-
-                self.wt.add([os.path.join(self.wtpath, dirname)])
-            except OSError, e:
-                if e.errno == 17:
-                    error_dialog(_i18n('Directory already exists'),
-                                 _i18n('Please specify another name to continue.'))
-                else:
-                    raise
-        else:
-            # Just a simple directory
-            try:
-                os.mkdir(os.path.join(self.wt.basedir, self.wtpath, dirname))
-            except OSError, e:
-                if e.errno == 17:
-                    error_dialog(_i18n('Directory already exists'),
-                                 _i18n('Please specify another name to continue.'))
-                    return
-
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()

=== removed file 'olive/move.py'
--- olive/move.py	2008-05-05 18:16:46 +0000
+++ olive/move.py	1970-01-01 00:00:00 +0000
@@ -1,98 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-from os.path import dirname
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gtk
-import gtk.glade
-
-import bzrlib.errors as errors
-from bzrlib.workingtree import WorkingTree
-
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog
-from errors import show_bzr_error
-from guifiles import GLADEFILENAME
-
-
-class OliveMove:
-    """ Display the Move dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Move dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_move', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_move')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_move_move_clicked": self.move,
-                "on_button_move_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        self.wt = wt
-        self.wtpath = wtpath
-        self.selected = selected
-        
-        if self.selected is None:
-            self.selected = ""
-        
-        if self.wtpath == "":
-            directory = dirname(self.wt.abspath(self.selected))
-        else:
-            directory = dirname(self.wt.abspath(self.wtpath + os.sep + self.selected))
-        
-        # Set FileChooser directory
-        self.filechooser = self.glade.get_widget('filechooserbutton_move')
-        self.filechooser.set_filename(directory)
-
-    def display(self):
-        """ Display the Move dialog. """
-        self.window.show_all()
-
-    @show_bzr_error
-    def move(self, widget):
-        destination = self.filechooser.get_filename()
-
-        filename = self.selected
-            
-        if filename is None:
-            error_dialog(_i18n('No file was selected'),
-                         _i18n('Please select a file from the list to proceed.'))
-            return
-        
-        source = os.path.join(self.wtpath, filename)
-        
-        # Move the file to a directory
-        wt1, path1 = WorkingTree.open_containing(self.wt.abspath(source))
-        wt2, path2 = WorkingTree.open_containing(destination)
-        if wt1.basedir != wt2.basedir:
-            error_dialog(_i18n('Not the same branch'),
-                         _i18n('The destination is not in the same branch.'))
-            return
-
-        wt1.move([source], wt1.relpath(destination))
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()

=== removed file 'olive/remove.py'
--- olive/remove.py	2008-05-05 18:16:46 +0000
+++ olive/remove.py	1970-01-01 00:00:00 +0000
@@ -1,145 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-	pass
-
-import gtk
-import gtk.glade
-
-import bzrlib.errors as errors
-
-from bzrlib.plugins.gtk import _i18n
-from bzrlib.plugins.gtk.dialog import error_dialog, warning_dialog
-from guifiles import GLADEFILENAME
-
-
-class OliveRemove:
-    """ Display the Remove file(s) dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Remove file(s) dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_remove')
-        
-        self.window = self.glade.get_widget('window_remove')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_remove_remove_clicked": self.remove,
-                "on_button_remove_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        self.wt = wt
-        self.wtpath = wtpath
-        self.selected = selected
-
-    def display(self):
-        """ Display the Remove file(s) dialog. """
-        self.window.show_all()
-        
-    @show_bzr_error
-    def remove(self, widget):
-        radio_selected = self.glade.get_widget('radiobutton_remove_selected')
-        radio_new = self.glade.get_widget('radiobutton_remove_new')
-        
-        if radio_selected.get_active():
-            # Remove only the selected file
-            filename = self.selected
-            
-            if filename is None:
-                error_dialog(_i18n('No file was selected'),
-                             _i18n('Please select a file from the list,\nor choose the other option.'))
-                return
-            
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
-            self.wt.remove(fullpath)
-        elif radio_new.get_active():
-            # Remove added files recursively
-            added = self.wt.changes_from(self.wt.basis_tree()).added
-            file_list = sorted([f[0] for f in added], reverse=True)
-            if len(file_list) == 0:
-                warning_dialog(_i18n('No matching files'),
-                               _i18n('No added files were found in the working tree.'))
-                return
-            self.wt.remove(file_list)
-        
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
-
-class OliveRemoveDialog(gtk.Dialog):
-    """ This class wraps the old Remove window into a gtk.Dialog. """
-    
-    def __init__(self, wt, wtpath, selected=[], parent=None):
-        """ Initialize the Remove file(s) dialog. """
-        gtk.Dialog.__init__(self, title="Remove files - Olive",
-                                  parent=parent,
-                                  flags=0,
-                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
-        
-        # Get arguments
-        self.wt = wt
-        self.wtpath = wtpath
-        self.selected = selected
-        
-        # Create widgets
-        self._label = gtk.Label(_i18n("Which file(s) do you want to remove?"))
-        self._radio_selected = gtk.RadioButton(None, _i18n("Selected only"), False)
-        self._radio_added = gtk.RadioButton(self._radio_selected, _i18n("All files with status 'added'"), False)
-        self._button_remove = gtk.Button(_i18n("_Remove"), use_underline=True)
-        
-        self._button_remove.connect('clicked', self._on_remove_clicked)
-        
-        self.vbox.pack_start(self._label)
-        self.vbox.pack_end(self._radio_added)
-        self.vbox.pack_end(self._radio_selected)
-        
-        self.action_area.pack_end(self._button_remove)
-        
-        self.vbox.set_spacing(3)
-        self.vbox.show_all()
-        
-    @show_bzr_error
-    def _on_remove_clicked(self, button):
-        """ Remove button clicked handler. """
-        if self._radio_selected.get_active():
-            # Remove only the selected file
-            filename = self.selected
-            
-            if filename is None:
-                error_dialog(_i18n('No file was selected'),
-                             _i18n('Please select a file from the list,\nor choose the other option.'))
-                return
-            
-            self.wt.remove(os.path.join(self.wtpath, filename))
-        elif self._radio_added.get_active():
-            # Remove added files recursively
-            added = self.wt.changes_from(self.wt.basis_tree()).added
-            file_list = sorted([f[0] for f in added], reverse=True)
-            if len(file_list) == 0:
-                warning_dialog(_i18n('No matching files'),
-                               _i18n('No added files were found in the working tree.'))
-                return
-            self.wt.remove(file_list)
-        
-        self.response(gtk.RESPONSE_OK)

=== removed file 'olive/rename.py'
--- olive/rename.py	2008-05-05 18:16:46 +0000
+++ olive/rename.py	1970-01-01 00:00:00 +0000
@@ -1,95 +0,0 @@
-# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-import os
-
-try:
-    import pygtk
-    pygtk.require("2.0")
-except:
-    pass
-
-import gtk
-import gtk.glade
-
-import bzrlib.errors as errors
-from bzrlib.workingtree import WorkingTree
-
-from errors import show_bzr_error
-from bzrlib.plugins.gtk.dialog import error_dialog
-from guifiles import GLADEFILENAME
-from bzrlib.plugins.gtk import _i18n
-
-
-class OliveRename:
-    """ Display the Rename dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Rename dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_rename')
-        
-        self.window = self.glade.get_widget('window_rename')
-        self.entry = self.glade.get_widget('entry_rename')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_rename_rename_clicked": self.rename,
-                "on_button_rename_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-        
-        self.wt = wt
-        self.wtpath = wtpath
-        self.selected = selected
-        
-    def display(self):
-        """ Display the Rename dialog. """
-        if self.selected is not None:
-            self.entry.set_text(self.selected)
-        
-        self.window.show_all()
-
-    @show_bzr_error
-    def rename(self, widget):
-        # Get entry
-        old_filename = self.selected
-        new_filename = self.entry.get_text()
-            
-        if old_filename is None:
-            error_dialog(_i18n('No file was selected'),
-                         _i18n('Please select a file from the list to proceed.'))
-            return
-        
-        if new_filename == "":
-            error_dialog(_i18n('Filename not given'),
-                         _i18n('Please specify a new name for the file.'))
-            return
-        
-        source = os.path.join(self.wtpath, old_filename)
-        destination = os.path.join(self.wtpath, new_filename)
-        
-        # Rename the file
-        wt1, path1 = WorkingTree.open_containing(self.wt.abspath(source))
-        wt2, path2 = WorkingTree.open_containing(self.wt.abspath(source))
-
-        if wt1.basedir != wt2.basedir:
-            error_dialog(_i18n('Not the same branch'),
-                         _i18n('The destination is not in the same branch.'))
-            return
-        wt1.rename_one(source, destination)
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()

=== added file 'preferences/TODO'
--- preferences/TODO	1970-01-01 00:00:00 +0000
+++ preferences/TODO	2008-10-30 13:48:44 +0000
@@ -0,0 +1,2 @@
+- per_file_commits
+- push/pull/submit/public locations

=== modified file 'preferences/__init__.py'
--- preferences/__init__.py	2008-03-28 19:39:35 +0000
+++ preferences/__init__.py	2011-02-18 13:01:03 +0000
@@ -23,8 +23,9 @@
 import gtk
 
 from bzrlib.config import GlobalConfig
-from identity import IdentityPage
-from plugins import PluginsPage
+from bzrlib.plugins.gtk.preferences.identity import IdentityPage
+from bzrlib.plugins.gtk.preferences.plugins import PluginsPage
+from bzrlib.plugins.gtk.preferences.notifications import NotificationsPage
 
 class PreferencesWindow(gtk.Dialog):
     """Displays global preferences windows."""
@@ -37,24 +38,31 @@
         """ Initialize the Status window. """
         super(PreferencesWindow, self).__init__(flags=gtk.DIALOG_MODAL)
         self.set_title("Bazaar Preferences")
+        self.set_has_separator(False)
         self.config = config
         if self.config is None:
             self.config = GlobalConfig()
         self._create()
-        self._create_pages()
-
 
     def _create(self):
-        self.set_default_size(600, 600)
+        self.set_default_size(320, 480)
+        self.set_border_width(0)
+
         notebook = gtk.Notebook()
+        notebook.set_border_width(12)
         for (label, page) in self._create_pages():
-            notebook.insert_page(page, gtk.Label(label))
+            notebook.append_page(page, gtk.Label(label))
+
+        notebook.set_current_page(0)
+        self.vbox.set_border_width(0)
         self.vbox.pack_start(notebook, True, True)
         self.vbox.show_all()
+        self.action_area.set_border_width(12)
 
     def _create_pages(self):
         return [("Identity", IdentityPage(self.config)), 
-                ("Plugins", PluginsPage())]
+                ("Plugins", PluginsPage()),
+                ("Notifications", NotificationsPage(self.config))]
 
     def display(self):
         self.window.show_all()

=== modified file 'preferences/identity.py'
--- preferences/identity.py	2008-03-28 19:39:35 +0000
+++ preferences/identity.py	2011-02-18 13:01:03 +0000
@@ -23,15 +23,17 @@
 import gtk
 
 class IdentityPage(gtk.Table):
+
     def __init__(self, config):
         self.config = config
         gtk.Table.__init__(self, rows=4, columns=2)
+        self.set_border_width(12)
         self.set_row_spacings(6)
         self.set_col_spacings(6)
 
-        align = gtk.Alignment(1.0, 0.5)
+        align = gtk.Alignment(0.0, 0.5)
         label = gtk.Label()
-        label.set_markup("<b>User Id:</b>")
+        label.set_markup("E-Mail:")
         align.add(label)
         self.attach(align, 0, 1, 0, 1, gtk.FILL, gtk.FILL)
 
@@ -39,9 +41,9 @@
         self.username.set_text(self.config.username())
         self.attach(self.username, 1, 2, 0, 1, gtk.EXPAND | gtk.FILL, gtk.FILL)
 
-        align = gtk.Alignment(1.0, 0.5)
+        align = gtk.Alignment(0.0, 0.5)
         label = gtk.Label()
-        label.set_markup("<b>GPG signing command:</b>")
+        label.set_markup("GPG signing command:")
         align.add(label)
         self.attach(align, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
 
@@ -49,9 +51,9 @@
         self.email.set_text(self.config.gpg_signing_command())
         self.attach(self.email, 1, 2, 1, 2, gtk.EXPAND | gtk.FILL, gtk.FILL)
 
-        align = gtk.Alignment(1.0, 0.5)
+        align = gtk.Alignment(0.0, 0.1)
         label = gtk.Label()
-        label.set_markup("<b>Check GPG Signatures:</b>")
+        label.set_markup("Check GPG Signatures:")
         align.add(label)
         self.attach(align, 0, 1, 2, 3, gtk.FILL, gtk.FILL)
 
@@ -68,9 +70,9 @@
         # FIXME: Set default
         self.attach(sigvals, 1, 2, 2, 3, gtk.EXPAND | gtk.FILL, gtk.FILL)
 
-        align = gtk.Alignment(1.0, 0.5)
+        align = gtk.Alignment(0.0, 0.1)
         label = gtk.Label()
-        label.set_markup("<b>Create GPG Signatures:</b>")
+        label.set_markup("Create GPG Signatures:")
         align.add(label)
         self.attach(align, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
 

=== added file 'preferences/notifications.py'
--- preferences/notifications.py	1970-01-01 00:00:00 +0000
+++ preferences/notifications.py	2011-02-18 13:01:03 +0000
@@ -0,0 +1,80 @@
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
+import gtk
+
+import bzrlib.plugins.gtk
+from bzrlib.plugins.gtk.notify import has_avahi, has_dbus
+
+def has_email():
+    return (getattr(bzrlib.plugins, "email", None) is not None)
+
+def has_cia():
+    return (getattr(bzrlib.plugins, "cia", None) is not None)
+
+
+class NotificationsPage(gtk.VBox):
+
+    def __init__(self, config, homogeneous=False, spacing=6):
+        self.config = config
+        gtk.VBox.__init__(self, homogeneous=homogeneous, spacing=spacing)
+        self.set_spacing(spacing) # The vertical one
+
+        lan_frame = gtk.Frame("LAN Notifications")
+
+        lan_vbox = gtk.VBox()
+        lan_frame.add(lan_vbox)
+
+        self.gateway_to_lan = gtk.CheckButton("_Gateway to LAN")
+        lan_vbox.pack_start(self.gateway_to_lan)
+        self.gateway_to_lan.set_sensitive(has_dbus())
+
+        self.announce_on_lan = gtk.CheckButton("_Announce on LAN")
+        lan_vbox.pack_start(self.announce_on_lan)
+        self.announce_on_lan.set_sensitive(has_avahi())
+
+        self.pack_start(lan_frame)
+
+        email_frame = gtk.Frame("E-mail notifications")
+
+        email_hbox = gtk.HBox()
+        self.send_email = gtk.CheckButton("Send _E-Mail to")
+        email_hbox.pack_start(self.send_email)
+        self.send_email_to = gtk.Entry()
+        email_hbox.pack_start(self.send_email_to)
+
+        email_frame.add(email_hbox)
+        email_frame.set_sensitive(has_email())
+
+        self.pack_start(email_frame)
+
+        cia_frame = gtk.Frame("CIA notifications")
+
+        cia_user_hbox = gtk.HBox()
+        cia_user_hbox.pack_start(gtk.Label("Author name"))
+        self.cia_user = gtk.Entry()
+        cia_user_hbox.pack_start(self.cia_user)
+
+        cia_frame.add(cia_user_hbox)
+        cia_frame.set_sensitive(has_cia())
+
+        self.pack_start(cia_frame)

=== modified file 'preferences/plugins.py'
--- preferences/plugins.py	2008-04-02 13:36:55 +0000
+++ preferences/plugins.py	2011-02-18 13:01:03 +0000
@@ -23,16 +23,22 @@
 import gtk
 
 class PluginsPage(gtk.VPaned):
+
     def __init__(self):
         gtk.VPaned.__init__(self)
+        self.set_border_width(12)
+        self.set_position(216)
+
         scrolledwindow = gtk.ScrolledWindow()
         scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        scrolledwindow.set_shadow_type(gtk.SHADOW_IN)
         self.model = gtk.ListStore(str, str)
         treeview = gtk.TreeView()
         scrolledwindow.add(treeview)
         self.pack1(scrolledwindow, resize=True, shrink=False)
 
         self.table = gtk.Table(columns=2)
+        self.table.set_border_width(12)
         self.table.set_row_spacings(6)
         self.table.set_col_spacings(6)
 
@@ -51,14 +57,14 @@
         column.pack_start(cell, expand=True)
         column.add_attribute(cell, "text", 1)
         treeview.append_column(column)
-        
+
         import bzrlib.plugin
         plugins = bzrlib.plugin.plugins()
         plugin_names = plugins.keys()
         plugin_names.sort()
         for name in plugin_names:
             self.model.append([name, getattr(plugins[name], '__file__', None)])
-                 
+
         scrolledwindow = gtk.ScrolledWindow()
         scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
         scrolledwindow.add_with_viewport(self.table)
@@ -67,14 +73,14 @@
 
     def row_selected(self, tv, path, tvc):
         import bzrlib
-        p = bzrlib.plugin.plugins()[self.model[path][0]]
+        p = bzrlib.plugin.plugins()[self.model[path][0]].module
         from inspect import getdoc
 
         for w in self.table.get_children():
             self.table.remove(w)
 
         if getattr(p, '__author__', None) is not None:
-            align = gtk.Alignment(1.0, 0.5)
+            align = gtk.Alignment(0.0, 0.5)
             label = gtk.Label()
             label.set_markup("<b>Author:</b>")
             align.add(label)
@@ -90,7 +96,7 @@
             self.table.attach(align, 1, 2, 0, 1, gtk.EXPAND | gtk.FILL, gtk.FILL)
 
         if getattr(p, '__version__', None) is not None:
-            align = gtk.Alignment(1.0, 0.5)
+            align = gtk.Alignment(0.0, 0.5)
             label = gtk.Label()
             label.set_markup("<b>Version:</b>")
             align.add(label)

=== modified file 'push.py'
--- push.py	2008-05-05 18:16:46 +0000
+++ push.py	2009-05-06 11:51:38 +0000
@@ -25,8 +25,6 @@
 
 from errors import show_bzr_error
 
-# FIXME: This needs to be public JRV 20070714
-from bzrlib.builtins import _create_prefix
 from bzrlib.config import LocationConfig
 import bzrlib.errors as errors
 
@@ -94,12 +92,7 @@
         """ Push button clicked handler. """
         location = self._combo.get_child().get_text()
         revs = 0
-        if self.branch is not None and self.branch.get_push_location() is None:
-            response = question_dialog(_i18n('Set default push location'),
-                                       _i18n('There is no default push location set.\nSet %r as default now?') % location)
-            if response == gtk.RESPONSE_OK:
-                self.branch.set_push_location(location)
-
+        
         try:
             revs = do_push(self.branch, location=location, overwrite=False)
         except errors.DivergedBranches:
@@ -108,6 +101,9 @@
             if response == gtk.RESPONSE_YES:
                 revs = do_push(self.branch, location=location, overwrite=True)
         
+        if self.branch is not None and self.branch.get_push_location() is None:
+            self.branch.set_push_location(location)
+        
         self._history.add_entry(location)
         info_dialog(_i18n('Push successful'),
                     _i18n("%d revision(s) pushed.") % revs)
@@ -146,7 +142,7 @@
             response = question_dialog(_i18n('Non existing parent directory'),
                          _i18n("The parent directory (%s)\ndoesn't exist. Create?") % location)
             if response == gtk.RESPONSE_OK:
-                _create_prefix(transport)
+                transport.create_prefix()
             else:
                 return
         dir_to = br_from.bzrdir.clone(location_url,

=== modified file 'revisionmenu.py'
--- revisionmenu.py	2008-01-23 16:36:21 +0000
+++ revisionmenu.py	2008-07-01 21:54:21 +0000
@@ -27,7 +27,7 @@
 from bzrlib import (errors, ui)
 from bzrlib.revision import NULL_REVISION
 
-class RevisionPopupMenu(gtk.Menu):
+class RevisionMenu(gtk.Menu):
 
     __gsignals__ = {
             'tag-added': (
@@ -37,11 +37,18 @@
             )
     }
 
-    def __init__(self, repository, revids, branch=None, wt=None):
-        super(RevisionPopupMenu, self).__init__()
+    def __init__(self, repository, revids, branch=None, wt=None, parent=None):
+        super(RevisionMenu, self).__init__()
+        self._parent = parent
         self.branch = branch
         self.repository = repository
         self.wt = wt
+        self.set_revision_ids(revids)
+
+    def set_revision_ids(self, revids):
+        assert isinstance(revids, list)
+        for c in self.get_children():
+            self.remove(c)
         self.revids = revids
         self.create_items()
 
@@ -50,44 +57,55 @@
             item = gtk.MenuItem("View _Changes")
             item.connect('activate', self.show_diff)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Push")
             item.connect('activate', self.show_push)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Tag Revision")
             item.connect('activate', self.show_tag)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Merge Directive")
             item.connect('activate', self.store_merge_directive)
             # FIXME: self.append(item)
-            self.show_all()
+
+            item = gtk.MenuItem("_Send Merge Directive")
+            item.connect('activate', self.send_merge_directive)
+            self.append(item)
             
             if self.wt:
                 item = gtk.MenuItem("_Revert to this revision")
                 item.connect('activate', self.revert)
                 self.append(item)
-                self.show_all()
+
+        self.show_all()
 
     def store_merge_directive(self, item):
         from bzrlib.plugins.gtk.mergedirective import CreateMergeDirectiveDialog
         window = CreateMergeDirectiveDialog(self.branch, self.revids[0])
         window.show()
 
+    def send_merge_directive(self, item):
+        from bzrlib.plugins.gtk.mergedirective import SendMergeDirectiveDialog
+        from cStringIO import StringIO
+        window = SendMergeDirectiveDialog(self.branch, self.revids[0])
+        if window.run() == gtk.RESPONSE_OK:
+            outf = StringIO()
+            outf.writelines(window.get_merge_directive().to_lines())
+            mail_client = self.branch.get_config().get_mail_client()
+            mail_client.compose_merge_request(window.get_mail_to(), "[MERGE]",
+                                              outf.getvalue())
+        window.destroy()
+
     def show_diff(self, item):
         from bzrlib.plugins.gtk.diff import DiffWindow
-        window = DiffWindow(parent=self.parent)
-        parentids = self.repository.revision_parents(self.revids[0])
-
+        window = DiffWindow(parent=self._parent)
+        parentids = self.repository.get_revision(self.revids[0]).parent_ids
         if len(parentids) == 0:
             parentid = NULL_REVISION
         else:
             parentid = parentids[0]
-
         rev_tree    = self.repository.revision_tree(self.revids[0])
         parent_tree = self.repository.revision_tree(parentid)
         window.set_diff(self.revids[0], rev_tree, parent_tree)

=== modified file 'revisionview.py'
--- revisionview.py	2008-06-24 10:34:38 +0000
+++ revisionview.py	2009-12-09 13:27:53 +0000
@@ -22,9 +22,15 @@
 import gobject
 import webbrowser
 
+from bzrlib import trace
+from bzrlib.osutils import format_date
+try:
+    from bzrlib.bencode import bdecode
+except ImportError:
+    from bzrlib.util.bencode import bdecode
+from bzrlib.testament import Testament
+
 from bzrlib.plugins.gtk import icon_path
-from bzrlib.osutils import format_date
-from bzrlib.util.bencode import bdecode
 
 try:
     from bzrlib.plugins.gtk import seahorse
@@ -45,13 +51,15 @@
             webbrowser._tryorder.insert(0, '%s "%%s"' % cmd)
     webbrowser.open(uri)
 
-gtk.link_button_set_uri_hook(_open_link)
+if getattr(gtk, 'link_button_set_uri_hook', None) is not None:
+    # Not available before PyGtk-2.10
+    gtk.link_button_set_uri_hook(_open_link)
 
 class BugsTab(gtk.VBox):
 
     def __init__(self):
         super(BugsTab, self).__init__(False, 6)
-    
+
         table = gtk.Table(rows=2, columns=2)
 
         table.set_row_spacings(6)
@@ -220,7 +228,17 @@
                                         "This revision has not been signed.")
 
     def show_signature(self, crypttext):
-        key = seahorse.verify(crypttext)
+        (cleartext, key) = seahorse.verify(crypttext)
+
+        assert cleartext is not None
+
+        inv = self.repository.get_inventory(self.revision.revision_id)
+        expected_testament = Testament(self.revision, inv).as_short_text()
+        if expected_testament != cleartext:
+            self.signature_image.set_from_file(icon_path("sign-bad.png"))
+            self.signature_label.set_markup("<b>Signature does not match repository data</b>\n" +
+                        "The signature plaintext is different from the expected testament plaintext.")
+            return
 
         if key and key.is_available():
             if key.is_trusted():
@@ -322,8 +340,8 @@
         self._create_general()
         self._create_relations()
         # Disabled because testaments aren't verified yet:
-        # if has_seahorse:
-        #    self._create_signature()
+        if has_seahorse:
+            self._create_signature()
         self._create_file_info_view()
         self._create_bugs()
 
@@ -403,17 +421,25 @@
             self.timestamp.set_text(format_date(revision.timestamp,
                                                 revision.timezone))
         try:
-            self.branchnick_label.set_text(revision.properties['branch-nick'])
+            self.branchnick.show()
+            self.branchnick_label.show()
+            self.branchnick.set_text(revision.properties['branch-nick'])
         except KeyError:
-            self.branchnick_label.set_text("")
+            self.branchnick.hide()
+            self.branchnick_label.hide()
 
         self._add_parents_or_children(revision.parent_ids,
                                       self.parents_widgets,
                                       self.parents_table)
-        
+
         file_info = revision.properties.get('file-info', None)
         if file_info is not None:
-            file_info = bdecode(file_info.encode('UTF-8'))
+            try:
+                file_info = bdecode(file_info.encode('UTF-8'))
+            except ValueError:
+                trace.note('Invalid per-file info for revision:%s, value: %r',
+                           revision.revision_id, file_info)
+                file_info = None
 
         if file_info:
             if self._file_id is None:
@@ -497,7 +523,7 @@
         table.resize(max(len(revids), 1), 2)
 
         for idx, revid in enumerate(revids):
-            align = gtk.Alignment(0.0, 0.0)
+            align = gtk.Alignment(0.0, 0.0, 1, 1)
             widgets.append(align)
             table.attach(align, 1, 2, idx, idx + 1,
                                       gtk.EXPAND | gtk.FILL, gtk.FILL)
@@ -520,12 +546,16 @@
                 hbox.pack_start(button, expand=False, fill=True)
                 button.show()
 
-            button = gtk.Button(revid)
+            button = gtk.Button()
+            revid_label = gtk.Label(str(revid))
+            revid_label.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+            revid_label.set_alignment(0.0, 0.5)
+            button.add(revid_label)
             button.connect("clicked",
                     lambda w, r: self.set_revision(self._repository.get_revision(r)), revid)
             button.set_use_underline(False)
-            hbox.pack_start(button, expand=False, fill=True)
-            button.show()
+            hbox.pack_start(button, expand=True, fill=True)
+            button.show_all()
 
     def _create_general(self):
         vbox = gtk.VBox(False, 6)
@@ -554,102 +584,91 @@
         self.table.set_col_spacings(6)
         self.table.show()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row = 0
+
         label = gtk.Label()
+        label.set_alignment(1.0, 0.5)
         label.set_markup("<b>Revision Id:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 0, 1, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         revision_id = gtk.Label()
+        revision_id.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+        revision_id.set_alignment(0.0, 0.5)
         revision_id.set_selectable(True)
         self.connect('notify::revision', 
                 lambda w, p: revision_id.set_text(self._revision.revision_id))
-        align.add(revision_id)
-        self.table.attach(align, 1, 2, 0, 1, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(revision_id, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         revision_id.show()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row += 1
         self.author_label = gtk.Label()
+        self.author_label.set_alignment(1.0, 0.5)
         self.author_label.set_markup("<b>Author:</b>")
-        align.add(self.author_label)
-        self.table.attach(align, 0, 1, 1, 2, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.author_label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         self.author_label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.author = gtk.Label()
+        self.author.set_ellipsize(pango.ELLIPSIZE_END)
+        self.author.set_alignment(0.0, 0.5)
         self.author.set_selectable(True)
-        align.add(self.author)
-        self.table.attach(align, 1, 2, 1, 2, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.author, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.author.show()
         self.author.hide()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row += 1
         label = gtk.Label()
+        label.set_alignment(1.0, 0.5)
         label.set_markup("<b>Committer:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 2, 3, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.committer = gtk.Label()
+        self.committer.set_ellipsize(pango.ELLIPSIZE_END)
+        self.committer.set_alignment(0.0, 0.5)
         self.committer.set_selectable(True)
-        align.add(self.committer)
-        self.table.attach(align, 1, 2, 2, 3, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.committer, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.committer.show()
 
-        align = gtk.Alignment(0.0, 0.5)
-        label = gtk.Label()
-        label.set_markup("<b>Branch nick:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 3, 4, gtk.FILL, gtk.FILL)
-        label.show()
-        align.show()
-
-        align = gtk.Alignment(0.0, 0.5)
+        row += 1
         self.branchnick_label = gtk.Label()
-        self.branchnick_label.set_selectable(True)
-        align.add(self.branchnick_label)
-        self.table.attach(align, 1, 2, 3, 4, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        self.branchnick_label.set_alignment(1.0, 0.5)
+        self.branchnick_label.set_markup("<b>Branch nick:</b>")
+        self.table.attach(self.branchnick_label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         self.branchnick_label.show()
-        align.show()
-
-        align = gtk.Alignment(1.0, 0.5)
+
+        self.branchnick = gtk.Label()
+        self.branchnick.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+        self.branchnick.set_alignment(0.0, 0.5)
+        self.branchnick.set_selectable(True)
+        self.table.attach(self.branchnick, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
+        self.branchnick.show()
+
+        row += 1
         label = gtk.Label()
+        label.set_alignment(1.0, 0.5)
         label.set_markup("<b>Timestamp:</b>")
-        align.add(label)
-        self.table.attach(align, 0, 1, 4, 5, gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.timestamp = gtk.Label()
+        self.timestamp.set_ellipsize(pango.ELLIPSIZE_END)
+        self.timestamp.set_alignment(0.0, 0.5)
         self.timestamp.set_selectable(True)
-        align.add(self.timestamp)
-        self.table.attach(align, 1, 2, 4, 5, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.table.attach(self.timestamp, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.timestamp.show()
 
-        align = gtk.Alignment(1.0, 0.5)
+        row += 1
         self.tags_label = gtk.Label()
+        self.tags_label.set_alignment(1.0, 0.5)
         self.tags_label.set_markup("<b>Tags:</b>")
-        align.add(self.tags_label)
-        align.show()
-        self.table.attach(align, 0, 1, 5, 6, gtk.FILL, gtk.FILL)
+        self.table.attach(self.tags_label, 0, 1, row, row+1, gtk.FILL, gtk.FILL)
         self.tags_label.show()
 
-        align = gtk.Alignment(0.0, 0.5)
         self.tags_list = gtk.Label()
-        align.add(self.tags_list)
-        self.table.attach(align, 1, 2, 5, 6, gtk.EXPAND | gtk.FILL, gtk.FILL)
-        align.show()
+        self.tags_list.set_ellipsize(pango.ELLIPSIZE_MIDDLE)
+        self.tags_list.set_alignment(0.0, 0.5)
+        self.table.attach(self.tags_list, 1, 2, row, row+1, gtk.EXPAND | gtk.FILL, gtk.FILL)
         self.tags_list.show()
 
         self.connect('notify::revision', self._add_tags)

=== modified file 'seahorse.py'
--- seahorse.py	2008-06-20 03:33:17 +0000
+++ seahorse.py	2008-08-05 13:56:46 +0000
@@ -30,33 +30,30 @@
 
 try:
     bus = dbus.SessionBus()
+    crypto = dbus.Interface(bus.get_object(BUS_NAME, CRYPTO_PATH), 
+                            CRYPTO_INTERFACE)
+    openpgp = dbus.Interface(bus.get_object(BUS_NAME, OPENPGP_PATH),
+                             OPENPGP_INTERFACE)
 except dbus.exceptions.DBusException, e:
     get_name = getattr(e, 'get_dbus_name', None)
     if get_name is not None:
         name = get_name()
     else:
         name = getattr(e, '_dbus_error_name', None)
+        
+    if name is None:
+        args = getattr(e, 'args', None) # This is case for old python-dbus-0.62
+        if args == ("Unable to determine the address of the message bus (try 'man dbus-launch' and 'man dbus-daemon' for help)",):
+            raise ImportError
+        
     # DBus sometimes fails like this, just treat it as if seahorse is not
     # available rather than crashing.
-    if name == "org.freedesktop.DBus.Error.Spawn.ExecFailed":
+    if name in ("org.freedesktop.DBus.Error.Spawn.ExecFailed", 
+                "org.freedesktop.DBus.Error.ServiceUnknown"):
         raise ImportError
     else:
         raise
 
-if hasattr(bus, 'list_activatable_names'):
-    bus_names = bus.list_activatable_names()
-else:
-    bus_object = bus.get_object('org.freedesktop.DBus', '/org/freedesktop/DBus')
-    bus_names = bus_object.ListNames(dbus_interface='org.freedesktop.DBus')
-
-if BUS_NAME not in bus_names:
-    raise ImportError
-
-crypto = dbus.Interface(bus.get_object(BUS_NAME, CRYPTO_PATH), 
-                        CRYPTO_INTERFACE)
-openpgp = dbus.Interface(bus.get_object(BUS_NAME, OPENPGP_PATH),
-                         OPENPGP_INTERFACE)
-
 FLAG_VALID = 0x0001
 FLAG_CAN_ENCRYPT = 0x0002
 FLAG_CAN_SIGN = 0x0004
@@ -85,7 +82,10 @@
         if key not in keyset:
             keyset[key] = Key(key)
 
-        return keyset[key]
+        return (cleartext, keyset[key])
+
+    return (cleartext, None)
+
 
 class Key:
 

=== added file 'search.py'
--- search.py	1970-01-01 00:00:00 +0000
+++ search.py	2008-07-20 13:23:29 +0000
@@ -0,0 +1,96 @@
+# Copyright (C) 2008 by Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
+import gobject
+import gtk
+
+from bzrlib.plugins.search import index as _mod_index
+from bzrlib.plugins.gtk import _i18n
+
+class SearchDialog(gtk.Dialog):
+    """Search dialog."""
+    def __init__(self, index, parent=None):
+        gtk.Dialog.__init__(self, title="Search Revisions",
+                                  parent=parent,
+                                  flags=gtk.DIALOG_MODAL,
+                                  buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK,
+                                           gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        pixbuf = self.render_icon(gtk.STOCK_FIND, gtk.ICON_SIZE_MENU)
+        self.set_icon(pixbuf)
+        
+        # Get arguments
+        self.index = index
+
+        self.searchbar = gtk.HBox()
+        searchbar_label = gtk.Label(_i18n("Search for:"))
+        self.searchbar.pack_start(searchbar_label, False, False, 0)
+        self.searchentry = gtk.Entry()
+        self.searchentry.connect('activate', self._searchentry_activate)
+        # TODO: Completion using the bzr-search suggests functionality
+        self.searchbar.add(self.searchentry)
+        self.vbox.pack_start(self.searchbar, expand=False, fill=False)
+
+        self.results_model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
+        self.results_treeview = gtk.TreeView(self.results_model)
+        self.results_treeview.connect("row-activated", self._searchresult_row_activated)
+
+        documentname_column = gtk.TreeViewColumn(_i18n("Document"), gtk.CellRendererText(), text=0)
+        self.results_treeview.append_column(documentname_column)
+
+        summary_column = gtk.TreeViewColumn(_i18n("Summary"), gtk.CellRendererText(), text=1)
+        self.results_treeview.append_column(summary_column)
+
+        results_scrolledwindow = gtk.ScrolledWindow()
+        results_scrolledwindow.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
+        results_scrolledwindow.add(self.results_treeview)
+
+        self.vbox.pack_start(results_scrolledwindow, expand=True, fill=True)
+
+        self.set_default_size(600, 400)
+        # Show the dialog
+        self.show_all()
+
+    def get_revision(self):
+        (path, focus) = self.results_treeview.get_cursor()
+        if path is None:
+            return None
+        iter = self.results_model.get_iter(path)
+        return self.results_model.get_value(iter, 2)
+
+    def _searchentry_activate(self, entry):
+        self.results_model.clear()
+        self.index._branch.lock_read()
+        try:
+            query = [(query_item,) for query_item in self.searchentry.get_text().split(" ")]
+            for result in self.index.search(query):
+                if isinstance(result, _mod_index.FileTextHit):
+                    revid = result.text_key[-1]
+                elif isinstance(result, _mod_index.RevisionHit):
+                    revid = result.revision_key[0]
+                else:
+                    raise AssertionError()
+                self.results_model.append([result.document_name(), result.summary(), revid])
+        finally:
+            self.index._branch.unlock()
+    
+    def _searchresult_row_activated(self, treeview, path, view_column):
+        self.response(gtk.RESPONSE_OK)

=== modified file 'setup.py'
--- setup.py	2008-06-27 16:53:56 +0000
+++ setup.py	2011-03-02 14:44:38 +0000
@@ -1,11 +1,12 @@
 #!/usr/bin/python
 """GTK+ Frontends for various Bazaar commands."""
 
+from info import *
+
 from distutils.core import setup, Command
 from distutils.command.install_data import install_data
-from distutils.dep_util import newer
-from distutils.log import info
-import glob
+from distutils.command.build import build
+from distutils.command.sdist import sdist
 import os
 import sys
 
@@ -25,130 +26,155 @@
 
     def run(self):
         from bzrlib.tests import TestLoader, TestSuite, TextTestRunner
-        import __init__ as bzrgtk
+        from bzrlib.plugin import PluginImporter
+        PluginImporter.specific_paths["bzrlib.plugins.gtk"] = os.path.dirname(__file__)
+        from bzrlib.plugins.gtk.tests import load_tests
+        suite = TestSuite()
+        loader = TestLoader()
+        load_tests(suite, None, loader)
         runner = TextTestRunner()
-        loader = TestLoader()
-        suite = TestSuite()
-        suite.addTest(bzrgtk.test_suite())
         result = runner.run(suite)
         return result.wasSuccessful()
 
+
+class CreateCredits(Command):
+    description = "Create credits file"
+
+    user_options = [("url=", None, "URL of branch")]
+
+    def initialize_options(self):
+        self.url = "."
+
+    def finalize_options(self):
+        pass
+
+    def get_command_name(self):
+        return 'build_credits'
+
+    def run(self):
+        from bzrlib.plugin import load_plugins; load_plugins()
+        from bzrlib.branch import Branch
+        from bzrlib.plugins.stats.cmds import find_credits
+
+        import pickle
+
+        branch = Branch.open(self.url)
+        credits = find_credits(branch.repository, branch.last_revision())
+
+        pickle.dump(credits, file("credits.pickle", 'w'))
+        return True
+
+
+def is_versioned(cmd):
+    from bzrlib.errors import NotBranchError
+    try:
+        from bzrlib.branch import Branch
+        Branch.open(".")
+        return True
+    except NotBranchError:
+        return False
+
+
+class BuildData(build):
+    sub_commands = build.sub_commands[:]
+    sub_commands.append(('build_credits', is_versioned))
+
+
+class SourceDist(sdist):
+    sub_commands = sdist.sub_commands[:]
+    sub_commands.append(('build_credits', is_versioned))
+
+
 class InstallData(install_data):
+
     def run(self):
-        self.data_files.extend(self._compile_po_files())
+        import subprocess
         self.data_files.extend(self._nautilus_plugin())
         install_data.run(self)
 
         try:
-            subprocess.check_call('gtk-update-icon-cache -f -t /usr/share/icons/hicolor')
-        except:
+            subprocess.check_call('gtk-update-icon-cache '
+                                  '-f -t /usr/share/icons/hicolor')
+        except OSError:
             pass
 
-    def _compile_po_files(self):
-        data_files = []
-        
-        # Don't install language files on Win32
-        if sys.platform == 'win32':
-            return data_files
-        
-        PO_DIR = 'po'
-        for po in glob.glob(os.path.join(PO_DIR,'*.po')):
-            lang = os.path.basename(po[:-3])
-            # It's necessary to compile in this directory (not in po_dir)
-            # because install_data can't rename file
-            mo = os.path.join('build', 'mo', lang, 'olive-gtk.mo')
-            
-            directory = os.path.dirname(mo)
-            if not os.path.exists(directory):
-                info('creating %s' % directory)
-                os.makedirs(directory)
-            
-            if newer(po, mo):
-                # True if mo doesn't exist
-                cmd = 'msgfmt -o %s %s' % (mo, po)
-                info('compiling %s -> %s' % (po, mo))
-                if os.system(cmd) != 0:
-                    raise SystemExit('Error while running msgfmt')
-                
-                dest = os.path.dirname(os.path.join('share', 'locale', lang, 'LC_MESSAGES', 'olive-gtk.mo'))
-                data_files.append((dest, [mo]))
-        
-        return data_files
-    
     def _nautilus_plugin(self):
         files = []
         if sys.platform[:5] == 'linux':
-            cmd = os.popen('pkg-config --variable=pythondir nautilus-python', 'r')
-            res = cmd.readline()
+            cmd = os.popen('pkg-config --variable=pythondir nautilus-python',
+                           'r')
+            res = cmd.readline().strip()
             ret = cmd.close()
-            
             if ret is None:
                 dest = res[5:]
                 files.append((dest, ['nautilus-bzr.py']))
-        
         return files
 
 
-setup(
-    name = "bzr-gtk",
-    version = "0.95.0",
-    maintainer = "Jelmer Vernooij",
-    maintainer_email = "jelmer@samba.org",
-    description = "GTK+ Frontends for various Bazaar commands",
-    license = "GNU GPL v2 or later",
-    scripts=['olive-gtk', 'bzr-handle-patch'],
-    package_dir = {
-        "bzrlib.plugins.gtk": ".",
-        "bzrlib.plugins.gtk.viz": "viz", 
-        "bzrlib.plugins.gtk.annotate": "annotate",
-        "bzrlib.plugins.gtk.olive": "olive",
-        "bzrlib.plugins.gtk.tests": "tests",
-        "bzrlib.plugins.gtk.branchview": "branchview",
-        "bzrlib.plugins.gtk.preferences": "preferences",
-        },
-    packages = [
-        "bzrlib.plugins.gtk",
-        "bzrlib.plugins.gtk.viz",
-        "bzrlib.plugins.gtk.annotate",
-        "bzrlib.plugins.gtk.olive",
-        "bzrlib.plugins.gtk.tests",
-        "bzrlib.plugins.gtk.branchview",
-        "bzrlib.plugins.gtk.preferences",
+if __name__ == '__main__':
+    version = bzr_plugin_version[:3]
+    version_string = ".".join([str(x) for x in version])
+    setup(
+        name = "bzr-gtk",
+        version = version_string,
+        maintainer = "Jelmer Vernooij",
+        maintainer_email = "jelmer@samba.org",
+        description = "GTK+ Frontends for various Bazaar commands",
+        license = "GNU GPL v2 or later",
+        scripts = ['bzr-handle-patch', 'bzr-notify'],
+        url = "http://bazaar-vcs.org/BzrGtk",
+        package_dir = {
+            "bzrlib.plugins.gtk": ".",
+            "bzrlib.plugins.gtk.viz": "viz",
+            "bzrlib.plugins.gtk.annotate": "annotate",
+            "bzrlib.plugins.gtk.tests": "tests",
+            "bzrlib.plugins.gtk.branchview": "branchview",
+            "bzrlib.plugins.gtk.preferences": "preferences",
+            },
+        packages = [
+            "bzrlib.plugins.gtk",
+            "bzrlib.plugins.gtk.viz",
+            "bzrlib.plugins.gtk.annotate",
+            "bzrlib.plugins.gtk.tests",
+            "bzrlib.plugins.gtk.branchview",
+            "bzrlib.plugins.gtk.preferences",
         ],
-    data_files=[('share/olive', ['olive.glade',
-                                 'cmenu.ui',
-                                ]),
-                ('share/olive/icons', ['icons/commit.png',
-                                 'icons/commit16.png',
-                                 'icons/diff.png',
-                                 'icons/diff16.png',
-                                 'icons/log.png',
-                                 'icons/log16.png',
-                                 'icons/pull.png',
-                                 'icons/pull16.png',
-                                 'icons/push.png',
-                                 'icons/push16.png',
-                                 'icons/refresh.png',
-                                 'icons/oliveicon2.png']),
-                ('share/bzr-gtk/icons', ['icons/sign-bad.png',
-                                 'icons/sign-ok.png',
-                                 'icons/sign.png',
-                                 'icons/sign-unknown.png',
-                                 'icons/bug.png',
-                                 'icons/bzr-icon-64.png']),
-                ('share/applications', ['olive-gtk.desktop',
-                                        'bazaar-properties.desktop',
-                                        'bzr-handle-patch.desktop',
-                                        'bzr-notify.desktop']),
-                ('share/application-registry', ['bzr-gtk.applications']),
-                ('share/pixmaps', ['icons/olive-gtk.png', 'icons/bzr-icon-64.png']),
-                ('share/icons/hicolor/scalable/emblems', 
-                    ['icons/emblem-bzr-added.svg', 
-                        'icons/emblem-bzr-conflict.svg', 
-                        'icons/emblem-bzr-controlled.svg', 
-                        'icons/emblem-bzr-modified.svg',
-                        'icons/emblem-bzr-removed.svg'])
-               ],
-    cmdclass={'install_data': InstallData,
-              'check': Check}
-)
+        data_files=[ ('share/bzr-gtk', ['credits.pickle']),
+                    ('share/bzr-gtk/icons', ['icons/commit.png',
+                                             'icons/commit16.png',
+                                             'icons/diff.png',
+                                             'icons/diff16.png',
+                                             'icons/log.png',
+                                             'icons/log16.png',
+                                             'icons/pull.png',
+                                             'icons/pull16.png',
+                                             'icons/push.png',
+                                             'icons/push16.png',
+                                             'icons/refresh.png',
+                                             'icons/sign-bad.png',
+                                             'icons/sign-ok.png',
+                                             'icons/sign.png',
+                                             'icons/sign-unknown.png',
+                                             'icons/tag-16.png',
+                                             'icons/bug.png',
+                                             'icons/bzr-icon-64.png']),
+                    ('share/applications', ['bazaar-properties.desktop',
+                                            'bzr-handle-patch.desktop',
+                                            'bzr-notify.desktop']),
+                    ('share/application-registry', ['bzr-gtk.applications']),
+                    ('share/pixmaps', ['icons/bzr-icon-64.png']),
+                    ('share/icons/hicolor/scalable/apps', ['icons/bzr-panel.svg']),
+                    ('share/icons/hicolor/scalable/emblems',
+                     ['icons/emblem-bzr-added.svg',
+                      'icons/emblem-bzr-conflict.svg',
+                      'icons/emblem-bzr-controlled.svg',
+                      'icons/emblem-bzr-modified.svg',
+                      'icons/emblem-bzr-removed.svg',
+                      'icons/emblem-bzr-ignored.svg'])
+                    ],
+        cmdclass={'install_data': InstallData,
+                  'build_credits': CreateCredits,
+                  'build': BuildData,
+                  'sdist': SourceDist,
+                  'check': Check}
+        )

=== modified file 'status.py'
--- status.py	2008-05-05 18:16:46 +0000
+++ status.py	2008-11-06 15:45:24 +0000
@@ -21,22 +21,25 @@
     pass
 
 import gtk
-from bzrlib.plugins.gtk import _i18n
-
-
-class StatusDialog(gtk.Dialog):
+from bzrlib.plugins.gtk import (
+    _i18n,
+    window,
+    )
+
+
+class StatusWindow(window.Window):
     """ Display Status window and perform the needed actions. """
     def __init__(self, wt, wtpath, revision=None):
         """ Initialize the Status window. """
-        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
+        super(StatusWindow, self).__init__()
         self.set_title("Working tree changes")
         self._create()
         self.wt = wt
         self.wtpath = wtpath
-        
+
         if revision is None:
             revision = self.wt.branch.last_revision()
-            
+
         # Set the old working tree
         self.old_tree = self.wt.branch.repository.revision_tree(revision)
         # Generate status output
@@ -44,12 +47,18 @@
 
     def _create(self):
         self.set_default_size(400, 300)
-        scrolledwindow = gtk.ScrolledWindow()
-        scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        sw = gtk.ScrolledWindow()
+        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        sw.set_shadow_type(gtk.SHADOW_IN)
         self.treeview = gtk.TreeView()
-        scrolledwindow.add(self.treeview)
-        self.vbox.pack_start(scrolledwindow, True, True)
-        self.vbox.show_all()
+        sw.add(self.treeview)
+        self.add(sw)
+
+        # sane border and spacing widths (as recommended by GNOME HIG) 
+        self.set_border_width(5)
+        sw.set_border_width(5)
+        self.show_all()
+
 
     def row_diff(self, tv, path, tvc):
         file = self.model[path][1]
@@ -57,28 +66,29 @@
             return
         from bzrlib.plugins.gtk.diff import DiffWindow
         window = DiffWindow()
-        window.set_diff("Working tree changes", self.old_tree, self.wt)
+        window.set_diff("Working tree changes", self.wt, self.old_tree)
         window.set_file(file)
         window.show()
 
+
     def _generate_status(self):
         """ Generate 'bzr status' output. """
         self.model = gtk.TreeStore(str, str)
         self.treeview.set_headers_visible(False)
         self.treeview.set_model(self.model)
         self.treeview.connect("row-activated", self.row_diff)
-        
+
         cell = gtk.CellRendererText()
         cell.set_property("width-chars", 20)
         column = gtk.TreeViewColumn()
         column.pack_start(cell, expand=True)
         column.add_attribute(cell, "text", 0)
         self.treeview.append_column(column)
-        
+
         delta = self.wt.changes_from(self.old_tree)
 
         changes = False
-        
+
         if len(delta.added):
             changes = True
             titer = self.model.append(None, [ _i18n('Added'), None ])
@@ -103,7 +113,7 @@
             titer = self.model.append(None, [ _i18n('Modified'), None ])
             for path, id, kind, text_modified, meta_modified in delta.modified:
                 self.model.append(titer, [ path, path ])
-        
+
         done_unknown = False
         for path in self.wt.unknowns():
             changes = True
@@ -116,6 +126,6 @@
             self.model.append(None, [ _i18n('No changes.'), None ])
 
         self.treeview.expand_all()
-    
+
     def close(self, widget=None):
         self.window.destroy()

=== modified file 'tests/__init__.py'
--- tests/__init__.py	2008-06-29 15:54:40 +0000
+++ tests/__init__.py	2011-02-18 13:01:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 Jelmer Vernooij <jelmer@samba.org>
+# Copyright (C) 2007, 2008 Jelmer Vernooij <jelmer@samba.org>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,27 +14,17 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from unittest import TestLoader, TestSuite
-from bzrlib.tests import TestUtil
-
-import os
-
-def test_suite():
-    result = TestSuite()
-
-    loader = TestUtil.TestLoader()
-
+
+def load_tests(basic_tests, module, loader):
     testmod_names = [
+        'test_annotate_config',
         'test_commit',
         'test_diff',
+        'test_history',
         'test_linegraph',
-        'test_preferences',
-        'test_history',
+        'test_revisionview',
         ]
 
-    if os.name == 'nt':
-        testmod_names.append("test_tortoise_bzr")
-
-    result.addTest(loader.loadTestsFromModuleNames(["%s.%s" % (__name__, i) for i in testmod_names]))
-    return result
-
+    basic_tests.addTest(loader.loadTestsFromModuleNames(
+            ["%s.%s" % (__name__, tmn) for tmn in testmod_names]))
+    return basic_tests

=== added file 'tests/test_annotate_config.py'
--- tests/test_annotate_config.py	1970-01-01 00:00:00 +0000
+++ tests/test_annotate_config.py	2009-05-07 11:48:03 +0000
@@ -0,0 +1,40 @@
+# Copyright (C) 2009 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Test the annotate configuration functionality."""
+
+from bzrlib import (
+    tests,
+    )
+
+from bzrlib.plugins.gtk.annotate import (
+    config,
+    gannotate,
+    )
+
+class TestConfig(tests.TestCaseInTempDir):
+
+    def setUp(self):
+        super(TestConfig, self).setUp()
+        self.window = gannotate.GAnnotateWindow()
+
+    def test_create_initial_config(self):
+        """We can create a config even without a prior conf file"""
+        conf = config.GAnnotateConfig(self.window)
+        # We can access the default values (we just pick a random one)
+        width = conf['window']['width']
+        # configobj presents attributes as strings only
+        self.assertIsInstance(width, str)

=== modified file 'tests/test_commit.py'
--- tests/test_commit.py	2008-06-10 15:25:47 +0000
+++ tests/test_commit.py	2011-02-18 13:01:03 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2007 John Arbash Meinel <john@arbash-meinel.com>
+# Copyright (C) 2007, 2008 John Arbash Meinel <john@arbash-meinel.com>
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -21,10 +21,14 @@
 import gtk
 
 from bzrlib import (
+    branch,
     tests,
-    revision,
+    uncommit,
     )
-from bzrlib.util import bencode
+try:
+    from bzrlib import bencode
+except ImportError:
+    from bzrlib.util import bencode
 
 from bzrlib.plugins.gtk import commit
 
@@ -86,7 +90,7 @@
         rev_id4 = tree3.commit('four')
         rev_id5 = tree3.commit('five')
         tree.merge_from_branch(tree2.branch)
-        tree.merge_from_branch(tree3.branch)
+        tree.merge_from_branch(tree3.branch, force=True)
         self.assertEqual([rev_id1, rev_id3, rev_id5], tree.get_parent_ids())
 
         pending_revisions = commit.pending_revisions(tree)
@@ -266,7 +270,7 @@
                                committer='Jerry Foo <jerry@foo.com>',
                                timestamp=1191372278.05,
                                timezone=+7200)
-        tree.merge_from_branch(tree3.branch)
+        tree.merge_from_branch(tree3.branch, force=True)
 
         dlg = commit.CommitDialog(tree)
         # TODO: assert that the pending box is set to show
@@ -644,14 +648,35 @@
                             'message':'message\nfor b_dir\n'},
                           ]), dlg._get_specific_files())
 
-
-class TestCommitDialog_Commit(tests.TestCaseWithTransport):
-    """Tests on the actual 'commit' button being pushed."""
+    def test_specific_files_sanitizes_messages(self):
+        tree = self.make_branch_and_tree('tree')
+        tree.branch.get_config().set_user_option('per_file_commits', 'true')
+        self.build_tree(['tree/a_file', 'tree/b_dir/'])
+        tree.add(['a_file', 'b_dir'], ['1a-id', '0b-id'])
+
+        dlg = commit.CommitDialog(tree)
+        dlg._commit_selected_radio.set_active(True)
+        self.assertEqual((['a_file', 'b_dir'], []), dlg._get_specific_files())
+
+        dlg._treeview_files.set_cursor((1,))
+        dlg._set_file_commit_message('Test\r\nmessage\rfor a_file\n')
+        dlg._treeview_files.set_cursor((2,))
+        dlg._set_file_commit_message('message\r\nfor\nb_dir\r')
+
+        self.assertEqual((['a_file', 'b_dir'],
+                          [{'path':'a_file', 'file_id':'1a-id',
+                            'message':'Test\nmessage\nfor a_file\n'},
+                           {'path':'b_dir', 'file_id':'0b-id',
+                            'message':'message\nfor\nb_dir\n'},
+                          ]), dlg._get_specific_files())
+
+
+class QuestionHelpers(object):
 
     def _set_question_yes(self, dlg):
         """Set the dialog to answer YES to any questions."""
         self.questions = []
-        def _question_yes(*args):
+        def _question_yes(*args, **kwargs):
             self.questions.append(args)
             self.questions.append('YES')
             return gtk.RESPONSE_YES
@@ -660,12 +685,16 @@
     def _set_question_no(self, dlg):
         """Set the dialog to answer NO to any questions."""
         self.questions = []
-        def _question_no(*args):
+        def _question_no(*args, **kwargs):
             self.questions.append(args)
             self.questions.append('NO')
             return gtk.RESPONSE_NO
         dlg._question_dialog = _question_no
 
+
+class TestCommitDialog_Commit(tests.TestCaseWithTransport, QuestionHelpers):
+    """Tests on the actual 'commit' button being pushed."""
+
     def test_bound_commit_local(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a'])
@@ -687,6 +716,21 @@
         self.assertEqual(last_rev, dlg.committed_revision_id)
         self.assertEqual(rev_id1, tree.branch.last_revision())
 
+    def test_commit_global_sanitizes_message(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a'])
+        tree.add(['a'], ['a-id'])
+        rev_id1 = tree.commit('one')
+
+        self.build_tree(['tree/b'])
+        tree.add(['b'], ['b-id'])
+        dlg = commit.CommitDialog(tree)
+        # With the check box set, it should only effect the local branch
+        dlg._set_global_commit_message('Commit\r\nmessage\rfoo\n')
+        dlg._do_commit()
+        rev = tree.branch.repository.get_revision(tree.last_revision())
+        self.assertEqual('Commit\nmessage\nfoo\n', rev.message)
+
     def test_bound_commit_both(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a'])
@@ -708,7 +752,7 @@
         self.assertEqual(last_rev, dlg.committed_revision_id)
         self.assertEqual(last_rev, tree.branch.last_revision())
 
-    def test_commit_no_message(self):
+    def test_commit_empty_message(self):
         tree = self.make_branch_and_tree('tree')
         self.build_tree(['tree/a', 'tree/b'])
         tree.add(['a'], ['a-id'])
@@ -943,13 +987,14 @@
         rev = tree.branch.repository.get_revision(rev_id2)
         self.assertEqual('Commit just "a"', rev.message)
         file_info = rev.properties['file-info']
-        self.assertEqual('ld7:file_id4:a-id'
-                           '7:message14:Message for A\n'
-                           '4:path1:a'
-                         'ee', file_info)
+        self.assertEqual(u'ld7:file_id4:a-id'
+                         '7:message14:Message for A\n'
+                         '4:path1:a'
+                         'ee',
+                         file_info)
         self.assertEqual([{'path':'a', 'file_id':'a-id',
-                           'message':'Message for A\n'},
-                         ], bencode.bdecode(file_info))
+                           'message':'Message for A\n'},],
+                         bencode.bdecode(file_info.encode('UTF-8')))
 
     def test_commit_messages_after_merge(self):
         tree = self.make_branch_and_tree('tree')
@@ -976,13 +1021,14 @@
         self.assertEqual('Merging from "tree2"\n', rev.message)
         self.assertEqual([rev_id1, rev_id2], rev.parent_ids)
         file_info = rev.properties['file-info']
-        self.assertEqual('ld7:file_id4:a-id'
-                           '7:message14:Message for A\n'
-                           '4:path1:a'
-                         'ee', file_info)
+        self.assertEqual(u'ld7:file_id4:a-id'
+                         '7:message14:Message for A\n'
+                         '4:path1:a'
+                         'ee',
+                         file_info)
         self.assertEqual([{'path':'a', 'file_id':'a-id',
-                           'message':'Message for A\n'},
-                         ], bencode.bdecode(file_info))
+                           'message':'Message for A\n'},],
+                         bencode.bdecode(file_info.encode('UTF-8')))
 
     def test_commit_unicode_messages(self):
         self.requireFeature(tests.UnicodeFilenameFeature)
@@ -1030,3 +1076,153 @@
                           {'path':u'\u03a9', 'file_id':'omega-id',
                            'message':u'\u03a9 is the end of all things.\n'},
                          ], file_info_decoded)
+
+
+class TestSanitizeMessage(tests.TestCase):
+
+    def assertSanitize(self, expected, original):
+        self.assertEqual(expected,
+                         commit._sanitize_and_decode_message(original))
+
+    def test_untouched(self):
+        self.assertSanitize('foo\nbar\nbaz\n', 'foo\nbar\nbaz\n')
+
+    def test_converts_cr_to_lf(self):
+        self.assertSanitize('foo\nbar\nbaz\n', 'foo\rbar\rbaz\r')
+
+    def test_converts_crlf_to_lf(self):
+        self.assertSanitize('foo\nbar\nbaz\n', 'foo\r\nbar\r\nbaz\r\n')
+
+    def test_converts_mixed_to_lf(self):
+        self.assertSanitize('foo\nbar\nbaz\n', 'foo\r\nbar\rbaz\n')
+
+
+class TestSavedCommitMessages(tests.TestCaseWithTransport):
+
+    def setUp(self):
+        super(TestSavedCommitMessages, self).setUp()
+        # Install our hook
+        branch.Branch.hooks.install_named_hook(
+            'post_uncommit', commit.save_commit_messages, None)
+
+    def _get_file_info_dict(self, rank):
+        file_info = [dict(path='a', file_id='a-id', message='a msg %d' % rank),
+                     dict(path='b', file_id='b-id', message='b msg %d' % rank)]
+        return file_info
+
+    def _get_file_info_revprops(self, rank):
+        file_info_prop = self._get_file_info_dict(rank)
+        return {'file-info': bencode.bencode(file_info_prop).decode('UTF-8')}
+
+    def _get_commit_message(self):
+        return self.config.get_user_option('gtk_global_commit_message')
+
+    def _get_file_commit_messages(self):
+        return self.config.get_user_option('gtk_file_commit_messages')
+
+
+class TestUncommitHook(TestSavedCommitMessages):
+
+    def setUp(self):
+        super(TestUncommitHook, self).setUp()
+        self.tree = self.make_branch_and_tree('tree')
+        self.config = self.tree.branch.get_config()
+        self.build_tree(['tree/a', 'tree/b'])
+        self.tree.add(['a'], ['a-id'])
+        self.tree.add(['b'], ['b-id'])
+        rev1 = self.tree.commit('one', rev_id='one-id',
+                                revprops=self._get_file_info_revprops(1))
+        rev2 = self.tree.commit('two', rev_id='two-id',
+                                revprops=self._get_file_info_revprops(2))
+        rev3 = self.tree.commit('three', rev_id='three-id',
+                                revprops=self._get_file_info_revprops(3))
+
+    def test_uncommit_one_by_one(self):
+        uncommit.uncommit(self.tree.branch, tree=self.tree)
+        self.assertEquals(u'three', self._get_commit_message())
+        self.assertEquals(u'd4:a-id7:a msg 34:b-id7:b msg 3e',
+                          self._get_file_commit_messages())
+
+        uncommit.uncommit(self.tree.branch, tree=self.tree)
+        self.assertEquals(u'two\n******\nthree', self._get_commit_message())
+        self.assertEquals(u'd4:a-id22:a msg 2\n******\na msg 3'
+                          '4:b-id22:b msg 2\n******\nb msg 3e',
+                          self._get_file_commit_messages())
+
+        uncommit.uncommit(self.tree.branch, tree=self.tree)
+        self.assertEquals(u'one\n******\ntwo\n******\nthree',
+                          self._get_commit_message())
+        self.assertEquals(u'd4:a-id37:a msg 1\n******\na msg 2\n******\na msg 3'
+                          '4:b-id37:b msg 1\n******\nb msg 2\n******\nb msg 3e',
+                          self._get_file_commit_messages())
+
+    def test_uncommit_all_at_once(self):
+        uncommit.uncommit(self.tree.branch, tree=self.tree, revno=1)
+        self.assertEquals(u'one\n******\ntwo\n******\nthree',
+                          self._get_commit_message())
+        self.assertEquals(u'd4:a-id37:a msg 1\n******\na msg 2\n******\na msg 3'
+                          '4:b-id37:b msg 1\n******\nb msg 2\n******\nb msg 3e',
+                          self._get_file_commit_messages())
+
+
+class TestReusingSavedCommitMessages(TestSavedCommitMessages, QuestionHelpers):
+
+    def setUp(self):
+        super(TestReusingSavedCommitMessages, self).setUp()
+        self.tree = self.make_branch_and_tree('tree')
+        self.config = self.tree.branch.get_config()
+        self.config.set_user_option('per_file_commits', 'true')
+        self.build_tree(['tree/a', 'tree/b'])
+        self.tree.add(['a'], ['a-id'])
+        self.tree.add(['b'], ['b-id'])
+        rev1 = self.tree.commit('one', revprops=self._get_file_info_revprops(1))
+        rev2 = self.tree.commit('two', revprops=self._get_file_info_revprops(2))
+        uncommit.uncommit(self.tree.branch, tree=self.tree)
+        self.build_tree_contents([('tree/a', 'new a content\n'),
+                                  ('tree/b', 'new b content'),])
+
+    def _get_commit_dialog(self, tree):
+        # Ensure we will never use a dialog that can actually prompt the user
+        # during the test suite. Test *can* and *should* override with the
+        # correct question dialog type.
+        dlg = commit.CommitDialog(tree)
+        self._set_question_no(dlg)
+        return dlg
+
+    def test_setup_saved_messages(self):
+        # Check the initial setup
+        self.assertEquals(u'two', self._get_commit_message())
+        self.assertEquals(u'd4:a-id7:a msg 24:b-id7:b msg 2e',
+                          self._get_file_commit_messages())
+
+    def test_messages_are_reloaded(self):
+        dlg = self._get_commit_dialog(self.tree)
+        self.assertEquals(u'two', dlg._get_global_commit_message())
+        self.assertEquals(([u'a', u'b'],
+                           [{ 'path': 'a',
+                             'file_id': 'a-id', 'message': 'a msg 2',},
+                           {'path': 'b',
+                            'file_id': 'b-id', 'message': 'b msg 2',}],),
+                          dlg._get_specific_files())
+
+    def test_messages_are_consumed(self):
+        dlg = self._get_commit_dialog(self.tree)
+        dlg._do_commit()
+        self.assertEquals(u'', self._get_commit_message())
+        self.assertEquals(u'de', self._get_file_commit_messages())
+
+    def test_messages_are_saved_on_cancel_if_required(self):
+        dlg = self._get_commit_dialog(self.tree)
+        self._set_question_yes(dlg) # Save messages
+        dlg._do_cancel()
+        self.assertEquals(u'two', self._get_commit_message())
+        self.assertEquals(u'd4:a-id7:a msg 24:b-id7:b msg 2e',
+                          self._get_file_commit_messages())
+
+    def test_messages_are_cleared_on_cancel_if_required(self):
+        dlg = self._get_commit_dialog(self.tree)
+        self._set_question_no(dlg) # Don't save messages
+        dlg._do_cancel()
+        self.assertEquals(u'', self._get_commit_message())
+        self.assertEquals(u'de',
+                          self._get_file_commit_messages())

=== modified file 'tests/test_diff.py'
--- tests/test_diff.py	2008-06-09 15:59:13 +0000
+++ tests/test_diff.py	2011-02-18 13:01:03 +0000
@@ -18,7 +18,11 @@
 from cStringIO import StringIO
 import os
 
-from bzrlib import errors, tests
+from bzrlib import (
+    conflicts,
+    errors,
+    tests,
+    )
 from bzrlib.merge_directive import MergeDirective2
 
 from bzrlib.plugins.gtk.diff import (
@@ -98,6 +102,7 @@
 
 
 class MockWindow(object):
+
     def __init__(self):
         self.diff = MockDiffWidget()
         self.merge_successful = False
@@ -303,3 +308,57 @@
             [('a-id', 'a', 'removed', 'a'),
              ('b-id', 'b', 'removed', 'b/'),
             ], tree)
+
+    def test_status_missing_file(self):
+        this = self.make_branch_and_tree('this')
+        self.build_tree(['this/foo'])
+        this.add(['foo'], ['foo-id'])
+        this.commit('add')
+
+        other = this.bzrdir.sprout('other').open_workingtree()
+
+        os.remove('this/foo')
+        this.remove('foo', force=True)
+        this.commit('remove')
+
+        f = open('other/foo', 'wt')
+        try:
+            f.write('Modified\n')
+        finally:
+            f.close()
+        other.commit('modified')
+
+        this.merge_from_branch(other.branch)
+        conflicts.resolve(this)
+
+        self.assertStatusEqual(
+            [('foo-id', 'foo.OTHER', 'missing', 'foo.OTHER'),],
+            this)
+
+    def test_status_missing_directory(self):
+        this = self.make_branch_and_tree('this')
+        self.build_tree(['this/foo/', 'this/foo/bar'])
+        this.add(['foo', 'foo/bar'], ['foo-id', 'bar-id'])
+        this.commit('add')
+
+        other = this.bzrdir.sprout('other').open_workingtree()
+
+        os.remove('this/foo/bar')
+        os.rmdir('this/foo')
+        this.remove('foo', force=True)
+        this.commit('remove')
+
+        f = open('other/foo/bar', 'wt')
+        try:
+            f.write('Modified\n')
+        finally:
+            f.close()
+        other.commit('modified')
+
+        this.merge_from_branch(other.branch)
+        conflicts.resolve(this)
+
+        self.assertStatusEqual(
+            [('foo-id', u'foo', 'added', u'foo/'),
+             ('bar-id', u'foo/bar.OTHER', 'missing', u'foo/bar.OTHER'),],
+            this)

=== modified file 'tests/test_history.py'
--- tests/test_history.py	2007-03-09 17:47:28 +0000
+++ tests/test_history.py	2011-02-18 13:01:03 +0000
@@ -14,12 +14,14 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
+from bzrlib import config
 from bzrlib.tests import TestCaseInTempDir
+
 from bzrlib.plugins.gtk.history import UrlHistory
 
-from bzrlib import config
 
 class TestsUrlHistory(TestCaseInTempDir):
+
     def setUp(self):
         super(TestsUrlHistory, self).setUp()
         self.config = config.GlobalConfig()

=== modified file 'tests/test_linegraph.py'
--- tests/test_linegraph.py	2008-06-29 15:54:40 +0000
+++ tests/test_linegraph.py	2011-02-18 13:01:03 +0000
@@ -16,26 +16,22 @@
 
 """Test the linegraph functionality."""
 
-import os
-
-import gtk
-
 from bzrlib import (
-	graph,
+    graph,
     tests,
     )
-from bzrlib.util import bencode
 
 from bzrlib.plugins.gtk.branchview.linegraph import linegraph
 
 
 class TestLinegraph(tests.TestCase):
-	def get_graph(self, dict):
-		return graph.Graph(graph.DictParentsProvider(dict))
-
-	def test_simple(self):
-		lg = linegraph(self.get_graph({"A": ("B", "C"), "B": ()}), ["A"])
-		self.assertEquals(lg,  
+
+    def get_graph(self, dict):
+        return graph.Graph(graph.DictParentsProvider(dict))
+
+    def test_simple(self):
+        lg = linegraph(self.get_graph({"A": ("B", "C"), "B": ()}), ["A"])
+        self.assertEquals(lg,  
             ([
                ['A', (0, 0), [(0, 0, 0)], ['B'], [], (2,)],
                ['B', (0, 0), [], (), ['A'], (1,)]

=== removed file 'tests/test_preferences.py'
--- tests/test_preferences.py	2007-03-15 16:23:15 +0000
+++ tests/test_preferences.py	1970-01-01 00:00:00 +0000
@@ -1,91 +0,0 @@
-# Copyright (C) 2007 Jelmer Vernooij <jelmer@samba.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.tests import TestCase, TestCaseInTempDir
-from bzrlib.plugins.gtk.olive import Preferences
-
-import os
-
-# FIXME: need to make sure that this also tests writing/reading.
-class TestPreferences(TestCaseInTempDir):
-    def setUp(self):
-        super(TestPreferences, self).setUp()
-        self.prefs = Preferences(os.path.join(self.test_dir, 'prefs'))
-
-    def test_create(self):
-        Preferences()
-
-    def test_add_bookmark(self):
-        """make sure a bookmark can be added. This function is only supposed 
-        to store the location, not try to access it. """
-        self.assertTrue(self.prefs.add_bookmark("file://foobar"))
-        self.assertTrue("file://foobar" in self.prefs.get_bookmarks())
-
-    def test_add_bookmark_twice(self):
-        """Adding an already present bookmark will result in False being 
-        returned."""
-        self.assertTrue(self.prefs.add_bookmark("file://foobar"))
-        self.assertFalse(self.prefs.add_bookmark("file://foobar"))
-
-    def test_set_bookmark_title(self):
-        """Test setting a title for an existing bookmark."""
-        self.prefs.add_bookmark("file://foobar")
-        self.prefs.set_bookmark_title("file://foobar", "My Bookmark")
-
-    def test_remove_bookmark(self):
-        """Test removing a bookmark."""
-        self.prefs.add_bookmark("http://example.com/branch")
-        self.prefs.remove_bookmark("http://example.com/branch")
-        self.assertFalse("http://example.com/branch" in self.prefs.get_bookmarks())
-
-    def test_get_bookmarks_empty(self):
-        """Test whether a new Preferences() object has an empty bookmarks 
-        list."""
-        self.assertEqual([], self.prefs.get_bookmarks())
-
-    def test_get_bookmark_title_set(self):
-        """Test getting a title for an existing bookmark."""
-        self.prefs.add_bookmark("file://foobar")
-        self.prefs.set_bookmark_title("file://foobar", "My Bookmark")
-        self.assertEqual("My Bookmark", self.prefs.get_bookmark_title("file://foobar"))
-
-    def test_get_bookmark_title_implicit(self):
-        """Test getting a bookmark title for a bookmark that doesn't
-        have a title set."""
-        self.prefs.add_bookmark("file://bla")
-        self.assertEqual("file://bla", self.prefs.get_bookmark_title("file://bla"))
-
-    def test_set_preference(self):
-        """Check whether setting preferences works."""
-        self.prefs.set_preference("foo", True)
-        self.prefs.set_preference("foo", False)
-        self.prefs.set_preference("foo", "bloe")
-
-    def test_get_preference_bool(self):
-        """Check whether a preference can be retrieved."""
-        self.prefs.set_preference("foo", True)
-        self.assertEqual(True, self.prefs.get_preference("foo", "bool"))
-
-    def test_get_preference_str(self):
-        """Check whether a string preference can be retrieved."""
-        self.prefs.set_preference("bla", "bloe")
-        self.assertEqual("bloe", self.prefs.get_preference("bla"))
-
-    def test_get_preference_nonexistant(self):
-        """Check whether get_preference returns None for nonexisting 
-        options."""
-        self.assertEqual(None, self.prefs.get_preference("foo"))
-

=== added file 'tests/test_revisionview.py'
--- tests/test_revisionview.py	1970-01-01 00:00:00 +0000
+++ tests/test_revisionview.py	2011-02-18 13:01:03 +0000
@@ -0,0 +1,90 @@
+# Copyright (C) 2007, 2008 John Arbash Meinel <john@arbash-meinel.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Test the RevisionView functionality."""
+
+from bzrlib import (
+    tests,
+    )
+try:
+    from bzrlib import bencode
+except ImportError:
+    from bzrlib.util import bencode
+
+from bzrlib.plugins.gtk import revisionview
+
+
+class TestPendingRevisions(tests.TestCaseWithMemoryTransport):
+
+    def assertBufferText(self, text, buffer):
+        """Check the text stored in the buffer."""
+        self.assertEqual(text, buffer.get_text(buffer.get_start_iter(),
+                                               buffer.get_end_iter()))
+
+    def test_create_view(self):
+        builder = self.make_branch_builder('test')
+        builder.build_snapshot('A', None,
+            [('add', ('', 'root-id', 'directory', None))])
+        b = builder.get_branch()
+
+        rv = revisionview.RevisionView(b)
+        rev = b.repository.get_revision('A')
+        rv.set_revision(rev)
+        self.assertEqual(rev.committer, rv.committer.get_text())
+        self.assertFalse(rv.author.get_property('visible'))
+        self.assertFalse(rv.author_label.get_property('visible'))
+        self.assertFalse(rv.file_info_box.get_property('visible'))
+
+    def test_create_view_with_file_info(self):
+        tree = self.make_branch_and_memory_tree('test')
+        file_info = bencode.bencode([{'file_id':'root-id', 'path':'',
+                                      'message':'test-message\n'}])
+        tree.lock_write()
+        try:
+            tree.add([''], ['root-id'])
+            tree.commit('test', rev_id='A', revprops={'file-info': file_info})
+        finally:
+            tree.unlock()
+        b = tree.branch
+
+        rv = revisionview.RevisionView(b)
+        rev = b.repository.get_revision('A')
+        rv.set_revision(rev)
+
+        self.assertEqual(rev.committer, rv.committer.get_text())
+        self.assertTrue(rv.file_info_box.get_property('visible'))
+        self.assertBufferText('\ntest-message\n', rv.file_info_buffer)
+
+    def test_create_view_with_broken_file_info(self):
+        tree = self.make_branch_and_memory_tree('test')
+        # This should be 'message13:'
+        file_info = 'ld7:file_id7:root-id7:message11:test-message\n4:path0:ee'
+        tree.lock_write()
+        try:
+            tree.add([''], ['root-id'])
+            tree.commit('test', rev_id='A', revprops={'file-info': file_info})
+        finally:
+            tree.unlock()
+        b = tree.branch
+
+        rv = revisionview.RevisionView(b)
+        rev = b.repository.get_revision('A')
+        rv.set_revision(rev)
+
+        self.assertEqual(rev.committer, rv.committer.get_text())
+        self.assertFalse(rv.file_info_box.get_property('visible'))
+        log = self._get_log(True)
+        self.assertContainsRe(log, 'Invalid per-file info for revision:A')

=== removed file 'tests/test_tortoise_bzr.py'
--- tests/test_tortoise_bzr.py	2007-03-15 12:43:48 +0000
+++ tests/test_tortoise_bzr.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-# Copyright (C) 2007 Jelmer Vernooij <jelmer@samba.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib import config
-
-import win32com.client as client
-
-class TestsShellExtension(TestCaseInTempDir):
-    def setUp(self):
-        super(TestsUrlHistory, self).setUp()
-        self.ext = client.Dispatch("Bazaar.ShellExtension.ContextMenu")
-
-    def test_get_command_string(self):
-        self.assertEqual(u"Hello from Python!!", self.ext.GetCommandString(1,1))

=== modified file 'ui.py'
--- ui.py	2008-06-29 16:20:15 +0000
+++ ui.py	2009-06-15 14:02:08 +0000
@@ -22,7 +22,7 @@
 import gtk
 import sys
 
-import bzrlib.progress
+from bzrlib import progress
 from bzrlib.ui import UIFactory
 
 
@@ -30,88 +30,129 @@
     """ Prompt the user for a yes/no answer. """
     def __init__(self, prompt):
         gtk.Dialog.__init__(self)
-        
+
         label = gtk.Label(prompt)
         self.vbox.pack_start(label, padding=10)
-        
         self.vbox.show_all()
 
-        self.add_buttons(gtk.STOCK_YES, gtk.RESPONSE_YES, gtk.STOCK_NO, 
+        self.add_buttons(gtk.STOCK_YES, gtk.RESPONSE_YES, gtk.STOCK_NO,
                          gtk.RESPONSE_NO)
 
 
 class GtkProgressBar(gtk.ProgressBar):
-    def __init__(self, stack):
-        super(GtkProgressBar, self).__init__()
+
+    def __init__(self):
+        gtk.ProgressBar.__init__(self)
         self.set_fraction(0.0)
-        self._stack = stack
         self.current = None
         self.total = None
 
-    def finished(self):
-        self._stack.remove(self)
-
-    def clear(self):
-        pass
-
     def tick(self):
+        self.show()
         self.pulse()
 
-    def update(self, msg=None, current=None, total=None):
-        if current:
-            self.current = current
-        if total:
-            self.total = total
+    def update(self, msg=None, current_cnt=None, total_cnt=None):
+        self.show()
+        if current_cnt is not None:
+            self.current = current_cnt
+        if total_cnt is not None:
+            self.total = total_cnt
         if msg is not None:
             self.set_text(msg)
         if None not in (self.current, self.total):
-            self.set_fraction(1.0 * self.current / self.total)
+            self.fraction = float(self.current) / self.total
+            if self.fraction < 0.0 or self.fraction > 1.0:
+                raise AssertionError
+            self.set_fraction(self.fraction)
         while gtk.events_pending():
             gtk.main_iteration()
 
-
-class GtkWindowProgressBarStack(gtk.Window):
+    def finished(self):
+        self.hide()
+
+    def clear(self):
+        self.hide()
+
+
+class ProgressBarWindow(gtk.Window):
+
     def __init__(self):
-        super(GtkWindowProgressBarStack, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+        super(ProgressBarWindow, self).__init__(type=gtk.WINDOW_TOPLEVEL)
         self.set_border_width(0)
         self.set_title("Progress")
         self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
-        self.vbox = gtk.VBox()
-        self.add(self.vbox)
+        self.pb = GtkProgressBar()
+        self.add(self.pb)
+        self.resize(250, 15)
         self.set_resizable(False)
 
-    def _adapt_size(self):
-        self.resize(250, 15 * len(self.vbox.get_children()))
-
-    def get_nested(self):
-        nested = GtkProgressBar(self)
-        self.vbox.pack_start(nested)
-        self._adapt_size()
-        self.show_all()
-        return nested
-
-    def remove(self, pb):
-        self.vbox.remove(pb)
-        if len(self.vbox.get_children()) == 0: # If there is nothing to show, don't leave a ghost window here
-             self.destroy()
+    def tick(self, *args, **kwargs):
+        self.show_all()
+        self.pb.tick(*args, **kwargs)
+
+    def update(self, *args, **kwargs):
+        self.show_all()
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+        self.destroy()
+
+    def clear(self):
+        self.pb.clear()
+        self.hide_all()
+
+
+class ProgressPanel(gtk.HBox):
+
+    def __init__(self):
+        super(ProgressPanel, self).__init__()
+        image_loading = gtk.image_new_from_stock(gtk.STOCK_REFRESH,
+                                                 gtk.ICON_SIZE_BUTTON)
+        image_loading.show()
+
+        self.pb = GtkProgressBar()
+        self.set_spacing(5)
+        self.set_border_width(5)
+        self.pack_start(image_loading, False, False)
+        self.pack_start(self.pb, True, True)
+
+    def tick(self, *args, **kwargs):
+        self.show_all()
+        self.pb.tick(*args, **kwargs)
+
+    def update(self, *args, **kwargs):
+        self.show_all()
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+
+    def clear(self):
+        self.pb.clear()
+        self.hide_all()
 
 
 class PasswordDialog(gtk.Dialog):
     """ Prompt the user for a password. """
+
     def __init__(self, prompt):
         gtk.Dialog.__init__(self)
-        
+
         label = gtk.Label(prompt)
         self.vbox.pack_start(label, padding=10)
-        
+
         self.entry = gtk.Entry()
         self.entry.set_visibility(False)
         self.vbox.pack_end(self.entry, padding=10)
-        
+
         self.vbox.show_all()
-        
-        self.add_buttons(gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
-    
+
+        self.add_buttons(gtk.STOCK_OK, gtk.RESPONSE_OK,
+                         gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)
+
     def _get_passwd(self):
         return self.entry.get_text()
 
@@ -121,14 +162,13 @@
 class GtkUIFactory(UIFactory):
     """A UI factory for GTK user interfaces."""
 
-    def __init__(self,
-                 stdout=None,
-                 stderr=None):
-        """Create a GtkUIFactory.
-
-        """
+    def __init__(self):
+        """Create a GtkUIFactory"""
         super(GtkUIFactory, self).__init__()
-        self._progress_bar_stack = None
+        self.set_progress_bar_widget(None)
+
+    def set_progress_bar_widget(self, widget):
+        self._progress_bar_widget = widget
 
     def get_boolean(self, prompt):
         """GtkDialog with yes/no answers"""
@@ -136,7 +176,7 @@
         response = dialog.run()
         dialog.destroy()
         return (response == gtk.RESPONSE_YES)
-        
+
     def get_password(self, prompt='', **kwargs):
         """Prompt the user for a password.
 
@@ -156,20 +196,18 @@
         else:
             return None
 
-    def nested_progress_bar(self):
-        """Return a nested progress bar.
-        """
-        if self._progress_bar_stack is None:
-            self._progress_bar_stack = GtkWindowProgressBarStack()
-        return self._progress_bar_stack.get_nested()
-
-    def set_progress_bar_vbox(self, vbox):
-        """Change the vbox to put progress bars in.
-        """
-        self._progress_bar_stack = vbox
-
-    def clear_term(self):
-        """Prepare the terminal for output.
-
-        It has no sense when talking about GTK."""
-        pass
+    def _progress_all_finished(self):
+        """See UIFactory._progress_all_finished"""
+        pbw = self._progress_bar_widget
+        if pbw:
+            pbw.finished()
+
+    def _progress_updated(self, task):
+        """See UIFactory._progress_updated"""
+        if self._progress_bar_widget is None:
+            # Default to a window since nobody gave us a better mean to report
+            # progress.
+            self.set_progress_bar_widget(ProgressBarWindow())
+        self._progress_bar_widget.update(task.msg,
+                                         task.current_cnt, task.total_cnt)
+

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-06-06 17:46:26 +0000
+++ viz/branchwin.py	2011-02-18 13:01:03 +0000
@@ -1,26 +1,24 @@
-# -*- coding: UTF-8 -*-
 """Branch window.
 
 This module contains the code to manage the branch information window,
 which contains both the revision graph and details panes.
 """
 
-__copyright__ = "Copyright © 2005 Canonical Ltd."
+__copyright__ = "Copyright (c) 2005 Canonical Ltd."
 __author__    = "Scott James Remnant <scott@ubuntu.com>"
 
 
 import gtk
-import gobject
-import pango
 
-from bzrlib.plugins.gtk.window import Window
 from bzrlib.plugins.gtk import icon_path
-from bzrlib.plugins.gtk.tags import AddTagDialog
+from bzrlib.plugins.gtk.branchview import TreeView
 from bzrlib.plugins.gtk.preferences import PreferencesWindow
-from bzrlib.plugins.gtk.branchview import TreeView, treemodel
-from bzrlib.revision import Revision, NULL_REVISION
-from bzrlib.config import BranchConfig
+from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
+from bzrlib.plugins.gtk.window import Window
+
 from bzrlib.config import GlobalConfig
+from bzrlib.revision import NULL_REVISION
+from bzrlib.trace import mutter
 
 class BranchWindow(Window):
     """Branch window.
@@ -51,14 +49,21 @@
         else:
             self.compact_view = False
 
-        self.set_title(branch.nick + " - revision history")
+        self.set_title(branch._get_nick(local=True) + " - revision history")
 
-        # Use three-quarters of the screen by default
-        screen = self.get_screen()
-        monitor = screen.get_monitor_geometry(0)
-        width = int(monitor.width * 0.75)
-        height = int(monitor.height * 0.75)
+        # user-configured window size
+        size = self._load_size('viz-window-size')
+        if size:
+            width, height = size
+        else:
+            # Use three-quarters of the screen by default
+            screen = self.get_screen()
+            monitor = screen.get_monitor_geometry(0)
+            width = int(monitor.width * 0.75)
+            height = int(monitor.height * 0.75)
         self.set_default_size(width, height)
+        self.set_size_request(width/3, height/3)
+        self._save_size_on_destroy(self, 'viz-window-size')
 
         # FIXME AndyFitz!
         icon = self.render_icon(gtk.STOCK_INDEX, gtk.ICON_SIZE_BUTTON)
@@ -71,7 +76,9 @@
         self.accel_group = gtk.AccelGroup()
         self.add_accel_group(self.accel_group)
 
-        gtk.Action.set_tool_item_type(gtk.MenuToolButton)
+        if getattr(gtk.Action, 'set_tool_item_type', None) is not None:
+            # Not available before PyGtk-2.10
+            gtk.Action.set_tool_item_type(gtk.MenuToolButton)
 
         self.prev_rev_action = gtk.Action("prev-rev", "_Previous Revision", "Go to the previous revision", gtk.STOCK_GO_DOWN)
         self.prev_rev_action.set_accel_path("<viz>/Go/Previous Revision")
@@ -93,6 +100,15 @@
 
         self.construct()
 
+    def _save_size_on_destroy(self, widget, config_name):
+        """Creates a hook that saves the size of widget to config option 
+           config_name when the window is destroyed/closed."""
+        def save_size(src):
+            width, height = widget.allocation.width, widget.allocation.height
+            value = '%sx%s' % (width, height)
+            self.config.set_user_option(config_name, value)
+        self.connect("destroy", save_size)
+
     def set_revision(self, revid):
         self.treeview.set_revision_id(revid)
 
@@ -102,16 +118,24 @@
         self.add(vbox)
 
         self.paned = gtk.VPaned()
-        self.paned.pack1(self.construct_top(), resize=True, shrink=False)
-        self.paned.pack2(self.construct_bottom(), resize=False, shrink=True)
+        self.paned.pack1(self.construct_top(), resize=False, shrink=True)
+        self.paned.pack2(self.construct_bottom(), resize=True, shrink=False)
         self.paned.show()
 
-        vbox.pack_start(self.construct_menubar(), expand=False, fill=True)
-        vbox.pack_start(self.construct_navigation(), expand=False, fill=True)
-        
+        nav = self.construct_navigation()
+        menubar = self.construct_menubar()
+        vbox.pack_start(menubar, expand=False, fill=True)
+        vbox.pack_start(nav, expand=False, fill=True)
+
         vbox.pack_start(self.paned, expand=True, fill=True)
         vbox.set_focus_child(self.paned)
 
+        self.treeview.connect('revision-selected',
+                self._treeselection_changed_cb)
+        self.treeview.connect('revision-activated',
+                self._tree_revision_activated)
+
+        self.treeview.connect('tag-added', lambda w, t, r: self._update_tags())
         vbox.show()
 
     def construct_menubar(self):
@@ -123,10 +147,10 @@
 
         file_menu_close = gtk.ImageMenuItem(gtk.STOCK_CLOSE, self.accel_group)
         file_menu_close.connect('activate', lambda x: self.destroy())
-        
+
         file_menu_quit = gtk.ImageMenuItem(gtk.STOCK_QUIT, self.accel_group)
         file_menu_quit.connect('activate', lambda x: gtk.main_quit())
-        
+
         if self._parent is not None:
             file_menu.add(file_menu_close)
         file_menu.add(file_menu_quit)
@@ -135,15 +159,12 @@
         edit_menuitem = gtk.MenuItem("_Edit")
         edit_menuitem.set_submenu(edit_menu)
 
-        edit_menu_find = gtk.ImageMenuItem(gtk.STOCK_FIND)
-
         edit_menu_branchopts = gtk.MenuItem("Branch Settings")
         edit_menu_branchopts.connect('activate', lambda x: PreferencesWindow(self.branch.get_config()).show())
 
         edit_menu_globopts = gtk.MenuItem("Global Settings")
         edit_menu_globopts.connect('activate', lambda x: PreferencesWindow().show())
 
-        edit_menu.add(edit_menu_find)
         edit_menu.add(edit_menu_branchopts)
         edit_menu.add(edit_menu_globopts)
 
@@ -159,15 +180,40 @@
 
         view_menu_toolbar = gtk.CheckMenuItem("Show Toolbar")
         view_menu_toolbar.set_active(True)
+        if self.config.get_user_option('viz-toolbar-visible') == 'False':
+            view_menu_toolbar.set_active(False)
+            self.toolbar.hide()
         view_menu_toolbar.connect('toggled', self._toolbar_visibility_changed)
 
         view_menu_compact = gtk.CheckMenuItem("Show Compact Graph")
         view_menu_compact.set_active(self.compact_view)
         view_menu_compact.connect('activate', self._brokenlines_toggled_cb)
 
+        view_menu_diffs = gtk.CheckMenuItem("Show Diffs")
+        view_menu_diffs.set_active(False)
+        if self.config.get_user_option('viz-show-diffs') == 'True':
+            view_menu_diffs.set_active(True)
+        view_menu_diffs.connect('toggled', self._diff_visibility_changed)
+
+        view_menu_wide_diffs = gtk.CheckMenuItem("Wide Diffs")
+        view_menu_wide_diffs.set_active(False)
+        if self.config.get_user_option('viz-wide-diffs') == 'True':
+            view_menu_wide_diffs.set_active(True)
+        view_menu_wide_diffs.connect('toggled', self._diff_placement_changed)
+
+        view_menu_wrap_diffs = gtk.CheckMenuItem("Wrap _Long Lines in Diffs")
+        view_menu_wrap_diffs.set_active(False)
+        if self.config.get_user_option('viz-wrap-diffs') == 'True':
+            view_menu_wrap_diffs.set_active(True)
+        view_menu_wrap_diffs.connect('toggled', self._diff_wrap_changed)
+
         view_menu.add(view_menu_toolbar)
         view_menu.add(view_menu_compact)
         view_menu.add(gtk.SeparatorMenuItem())
+        view_menu.add(view_menu_diffs)
+        view_menu.add(view_menu_wide_diffs)
+        view_menu.add(view_menu_wrap_diffs)
+        view_menu.add(gtk.SeparatorMenuItem())
 
         self.mnu_show_revno_column = gtk.CheckMenuItem("Show Revision _Number Column")
         self.mnu_show_date_column = gtk.CheckMenuItem("Show _Date Column")
@@ -187,7 +233,7 @@
         go_menu.set_accel_group(self.accel_group)
         go_menuitem = gtk.MenuItem("_Go")
         go_menuitem.set_submenu(go_menu)
-        
+
         go_menu_next = self.next_rev_action.create_menu_item()
         go_menu_prev = self.prev_rev_action.create_menu_item()
 
@@ -195,31 +241,16 @@
         tag_image.set_from_file(icon_path("tag-16.png"))
         self.go_menu_tags = gtk.ImageMenuItem("_Tags")
         self.go_menu_tags.set_image(tag_image)
-        self._update_tags()
+        self.treeview.connect('refreshed', lambda w: self._update_tags())
 
         go_menu.add(go_menu_next)
         go_menu.add(go_menu_prev)
         go_menu.add(gtk.SeparatorMenuItem())
         go_menu.add(self.go_menu_tags)
 
-        revision_menu = gtk.Menu()
+        self.revision_menu = RevisionMenu(self.branch.repository, [], self.branch, parent=self)
         revision_menuitem = gtk.MenuItem("_Revision")
-        revision_menuitem.set_submenu(revision_menu)
-
-        revision_menu_diff = gtk.MenuItem("View Changes")
-        revision_menu_diff.connect('activate', 
-                self._menu_diff_cb)
-        
-        revision_menu_compare = gtk.MenuItem("Compare with...")
-        revision_menu_compare.connect('activate',
-                self._compare_with_cb)
-
-        revision_menu_tag = gtk.MenuItem("Tag Revision")
-        revision_menu_tag.connect('activate', self._tag_revision_cb)
-
-        revision_menu.add(revision_menu_tag)
-        revision_menu.add(revision_menu_diff)
-        revision_menu.add(revision_menu_compare)
+        revision_menuitem.set_submenu(self.revision_menu)
 
         branch_menu = gtk.Menu()
         branch_menuitem = gtk.MenuItem("_Branch")
@@ -228,6 +259,21 @@
         branch_menu.add(gtk.MenuItem("Pu_ll Revisions"))
         branch_menu.add(gtk.MenuItem("Pu_sh Revisions"))
 
+        try:
+            from bzrlib.plugins import search
+        except ImportError:
+            mutter("Didn't find search plugin")
+        else:
+            branch_menu.add(gtk.SeparatorMenuItem())
+
+            branch_index_menuitem = gtk.MenuItem("_Index")
+            branch_index_menuitem.connect('activate', self._branch_index_cb)
+            branch_menu.add(branch_index_menuitem)
+
+            branch_search_menuitem = gtk.MenuItem("_Search")
+            branch_search_menuitem.connect('activate', self._branch_search_cb)
+            branch_menu.add(branch_search_menuitem)
+
         help_menu = gtk.Menu()
         help_menuitem = gtk.MenuItem("_Help")
         help_menuitem.set_submenu(help_menu)
@@ -254,13 +300,6 @@
 
         self.treeview = TreeView(self.branch, self.start_revs, self.maxnum, self.compact_view)
 
-        self.treeview.connect('revision-selected',
-                self._treeselection_changed_cb)
-        self.treeview.connect('revision-activated',
-                self._tree_revision_activated)
-
-        self.treeview.connect('tag-added', lambda w, t, r: self._update_tags())
-
         for col in ["revno", "date"]:
             option = self.config.get_user_option(col + '-column-visible')
             if option is not None:
@@ -273,6 +312,15 @@
         align = gtk.Alignment(0.0, 0.0, 1.0, 1.0)
         align.set_padding(5, 0, 0, 0)
         align.add(self.treeview)
+        # user-configured size
+        size = self._load_size('viz-graph-size')
+        if size:
+            width, height = size
+            align.set_size_request(width, height)
+        else:
+            (width, height) = self.get_size()
+            align.set_size_request(width, int(height / 2.5))
+        self._save_size_on_destroy(align, 'viz-graph-size')
         align.show()
 
         return align
@@ -300,15 +348,37 @@
 
     def construct_bottom(self):
         """Construct the bottom half of the window."""
+        if self.config.get_user_option('viz-wide-diffs') == 'True':
+            self.diff_paned = gtk.VPaned()
+        else:
+            self.diff_paned = gtk.HPaned()
+        (width, height) = self.get_size()
+        self.diff_paned.set_size_request(20, 20) # shrinkable
+
         from bzrlib.plugins.gtk.revisionview import RevisionView
         self.revisionview = RevisionView(branch=self.branch)
-        (width, height) = self.get_size()
-        self.revisionview.set_size_request(width, int(height / 2.5))
+        self.revisionview.set_size_request(width/3, int(height / 2.5))
+        # user-configured size
+        size = self._load_size('viz-revisionview-size')
+        if size:
+            width, height = size
+            self.revisionview.set_size_request(width, height)
+        self._save_size_on_destroy(self.revisionview, 'viz-revisionview-size')
         self.revisionview.show()
         self.revisionview.set_show_callback(self._show_clicked_cb)
         self.revisionview.connect('notify::revision', self._go_clicked_cb)
         self.treeview.connect('tag-added', lambda w, t, r: self.revisionview.update_tags())
-        return self.revisionview
+        self.diff_paned.pack1(self.revisionview)
+
+        from bzrlib.plugins.gtk.diff import DiffWidget
+        self.diff = DiffWidget()
+        self.diff_paned.pack2(self.diff)
+
+        self.diff_paned.show_all()
+        if self.config.get_user_option('viz-show-diffs') != 'True':
+            self.diff.hide()
+
+        return self.diff_paned
 
     def _tag_selected_cb(self, menuitem, revid):
         self.treeview.set_revision_id(revid)
@@ -319,6 +389,8 @@
         parents  = self.treeview.get_parents()
         children = self.treeview.get_children()
 
+        self.revision_menu.set_revision_ids([revision.revision_id])
+
         if revision and revision != NULL_REVISION:
             prev_menu = gtk.Menu()
             if len(parents) > 0:
@@ -339,7 +411,8 @@
                 self.prev_rev_action.set_sensitive(False)
                 prev_menu.hide()
 
-            self.prev_button.set_menu(prev_menu)
+            if getattr(self.prev_button, 'set_menu', None) is not None:
+		self.prev_button.set_menu(prev_menu)
 
             next_menu = gtk.Menu()
             if len(children) > 0:
@@ -359,11 +432,13 @@
                 self.next_rev_action.set_sensitive(False)
                 next_menu.hide()
 
-            self.next_button.set_menu(next_menu)
+            if getattr(self.next_button, 'set_menu', None) is not None:
+		self.next_button.set_menu(next_menu)
 
             self.revisionview.set_revision(revision)
             self.revisionview.set_children(children)
-    
+            self.update_diff_panel(revision, parents)
+
     def _tree_revision_activated(self, widget, path, col):
         # TODO: more than one parent
         """Callback for when a treeview row gets activated."""
@@ -371,30 +446,17 @@
         parents  = self.treeview.get_parents()
 
         if len(parents) == 0:
-            parent_id = None
+            parent_id = NULL_REVISION
         else:
             parent_id = parents[0]
 
         self.show_diff(revision.revision_id, parent_id)
         self.treeview.grab_focus()
-        
-    def _menu_diff_cb(self,w):
-        (path, focus) = self.treeview.treeview.get_cursor()
-        revid = self.treeview.model[path][treemodel.REVID]
-        
-        parentids = self.branch.repository.revision_parents(revid)
-
-        if len(parentids) == 0:
-            parentid = NULL_REVISION
-        else:
-            parentid = parentids[0]
-        
-        self.show_diff(revid,parentid)    
 
     def _back_clicked_cb(self, *args):
         """Callback for when the back button is clicked."""
         self.treeview.back()
-        
+
     def _fwd_clicked_cb(self, *args):
         """Callback for when the forward button is clicked."""
         self.treeview.forward()
@@ -409,22 +471,6 @@
         self.show_diff(revid, parentid)
         self.treeview.grab_focus()
 
-    def _compare_with_cb(self,w):
-        """Callback for revision 'compare with' menu. Will show a small
-            dialog with branch revisions to compare with selected revision in TreeView"""
-        
-        from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
-        
-        rb = RevisionBrowser(self.branch,self)
-        ret = rb.run()
-        
-        if ret == gtk.RESPONSE_OK:          
-            (path, focus) = self.treeview.treeview.get_cursor()
-            revid = self.treeview.model[path][treemodel.REVID]
-            self.show_diff(revid, rb.selected_revid)
-            
-        rb.destroy()
-            
     def _set_revision_cb(self, w, revision_id):
         self.treeview.set_revision_id(revision_id)
 
@@ -440,25 +486,38 @@
         self.treeview.set_property('compact', self.compact_view)
         self.treeview.refresh()
 
-    def _tag_revision_cb(self, w):
+    def _branch_index_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        _mod_index.index_url(self.branch.base)
+
+    def _branch_search_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        from bzrlib.plugins.gtk.search import SearchDialog
+        from bzrlib.plugins.search import errors as search_errors
+
         try:
-            self.treeview.set_sensitive(False)
-            dialog = AddTagDialog(self.branch.repository, self.treeview.get_revision().revision_id, self.branch)
-            response = dialog.run()
-            if response != gtk.RESPONSE_NONE:
-                dialog.hide()
-            
-                if response == gtk.RESPONSE_OK:
-                    self.treeview.add_tag(dialog.tagname, dialog._revid)
-                
-                dialog.destroy()
-
-        finally:
-            self.treeview.set_sensitive(True)
+            index = _mod_index.open_index_url(self.branch.base)
+        except search_errors.NoSearchIndex:
+            dialog = gtk.MessageDialog(self, type=gtk.MESSAGE_QUESTION, 
+                buttons=gtk.BUTTONS_OK_CANCEL, 
+                message_format="This branch has not been indexed yet. "
+                               "Index now?")
+            if dialog.run() == gtk.RESPONSE_OK:
+                dialog.destroy()
+                index = _mod_index.index_url(self.branch.base)
+            else:
+                dialog.destroy()
+                return
+
+        dialog = SearchDialog(index)
+
+        if dialog.run() == gtk.RESPONSE_OK:
+            self.set_revision(dialog.get_revision())
+
+        dialog.destroy()
 
     def _about_dialog_cb(self, w):
         from bzrlib.plugins.gtk.about import AboutDialog
-
         AboutDialog().run()
 
     def _col_visibility_changed(self, col, property):
@@ -467,14 +526,43 @@
 
     def _toolbar_visibility_changed(self, col):
         if col.get_active():
-            self.toolbar.show() 
+            self.toolbar.show()
         else:
             self.toolbar.hide()
-
-    def _show_about_cb(self, w):
-        dialog = AboutDialog()
-        dialog.connect('response', lambda d,r: d.destroy())
-        dialog.run()
+        self.config.set_user_option('viz-toolbar-visible', col.get_active())
+
+    def _make_diff_nonzero_size(self):
+        """make sure the diff isn't zero-width or zero-height"""
+        alloc = self.diff.get_allocation()
+        if (alloc.width < 10) or (alloc.height < 10):
+            width, height = self.get_size()
+            self.revisionview.set_size_request(width/3, int(height / 2.5))
+
+    def _diff_visibility_changed(self, col):
+        """Hide or show the diff panel."""
+        if col.get_active():
+            self.diff.show()
+            self._make_diff_nonzero_size()
+        else:
+            self.diff.hide()
+        self.config.set_user_option('viz-show-diffs', str(col.get_active()))
+        self.update_diff_panel()
+
+    def _diff_placement_changed(self, col):
+        """Toggle the diff panel's position."""
+        self.config.set_user_option('viz-wide-diffs', str(col.get_active()))
+
+        old = self.paned.get_child2()
+        self.paned.remove(old)
+        self.paned.pack2(self.construct_bottom(), resize=True, shrink=False)
+        self._make_diff_nonzero_size()
+
+        self.treeview.emit('revision-selected')
+
+    def _diff_wrap_changed(self, widget):
+        """Toggle word wrap in the diff widget."""
+        self.config.set_user_option('viz-wrap-diffs', widget.get_active())
+        self.diff._on_wraplines_toggled(widget)
 
     def _refresh_clicked(self, w):
         self.treeview.refresh()
@@ -484,14 +572,14 @@
 
         if self.branch.supports_tags():
             tags = self.branch.tags.get_tag_dict().items()
-            tags.sort()
-            tags.reverse()
+            tags.sort(reverse=True)
             for tag, revid in tags:
                 tag_image = gtk.Image()
                 tag_image.set_from_file(icon_path('tag-16.png'))
                 tag_item = gtk.ImageMenuItem(tag.replace('_', '__'))
                 tag_item.set_image(tag_image)
                 tag_item.connect('activate', self._tag_selected_cb, revid)
+                tag_item.set_sensitive(self.treeview.has_revision_id(revid))
                 menu.add(tag_item)
             self.go_menu_tags.set_submenu(menu)
 
@@ -501,19 +589,51 @@
 
         self.go_menu_tags.show_all()
 
-    def show_diff(self, revid=None, parentid=None):
+    def _load_size(self, name):
+        """Read and parse 'name' from self.config.
+        The value is a string, formatted as WIDTHxHEIGHT
+        Returns None, or (width, height)
+        """
+        size = self.config.get_user_option(name)
+        if size:
+            width, height = [int(num) for num in size.split('x')]
+            # avoid writing config every time we start
+            return width, height
+        return None
+
+    def show_diff(self, revid=None, parentid=NULL_REVISION):
         """Open a new window to show a diff between the given revisions."""
         from bzrlib.plugins.gtk.diff import DiffWindow
         window = DiffWindow(parent=self)
 
-        if parentid is None:
-            parentid = NULL_REVISION
-
         rev_tree    = self.branch.repository.revision_tree(revid)
         parent_tree = self.branch.repository.revision_tree(parentid)
 
-        description = revid + " - " + self.branch.nick
+        description = revid + " - " + self.branch._get_nick(local=True)
         window.set_diff(description, rev_tree, parent_tree)
         window.show()
 
-
+    def update_diff_panel(self, revision=None, parents=None):
+        """Show the current revision in the diff panel."""
+        if self.config.get_user_option('viz-show-diffs') != 'True':
+            return
+
+        if not revision: # default to selected row
+            revision = self.treeview.get_revision()
+        if revision == NULL_REVISION:
+            return
+
+        if not parents: # default to selected row's parents
+            parents  = self.treeview.get_parents()
+        if len(parents) == 0:
+            parent_id = NULL_REVISION
+        else:
+            parent_id = parents[0]
+
+        rev_tree    = self.branch.repository.revision_tree(revision.revision_id)
+        parent_tree = self.branch.repository.revision_tree(parent_id)
+
+        self.diff.set_diff(rev_tree, parent_tree)
+        if self.config.get_user_option('viz-wrap-diffs') == 'True':
+            self.diff._on_wraplines_toggled(wrap=True)
+        self.diff.show_all()

=== modified file 'window.py'
--- window.py	2007-10-14 15:54:57 +0000
+++ window.py	2008-10-23 08:14:59 +0000
@@ -7,9 +7,9 @@
     def __init__(self, parent=None):
         gtk.Window.__init__(self, gtk.WINDOW_TOPLEVEL)
         self._parent = parent
-        
+
         self.connect('key-press-event', self._on_key_press)
-        
+
     def _on_key_press(self, widget, event):
         keyname = gtk.gdk.keyval_name(event.keyval)
         if event.state & gtk.gdk.CONTROL_MASK:

